/*
 * AboutDiversityNavigator.java
 *
 * Created on February 1, 2002, 8:06 PM
 */

package net.metadiversity.diversity.navigator.about;

import java.awt.*;
import javax.swing.*;

import net.metadiversity.diversity.navigator.*;

import org.apache.log4j.Logger;

/**
 * About box dialog.
 *
 * @author	<A HREF="mailto:dneu@nexgo.de">Dieter Neubacher</A>
 */
public class AboutDiversityNavigator extends javax.swing.JDialog 
{   
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 4049356418073573683L;

    static Logger logger = Logger.getLogger( AboutDiversityNavigator.class.getName() );
    
    static final String bundle = "net/metadiversity/diversity/navigator/about/DiversityNavigatorAboutBundle";
    static final java.util.ResourceBundle resource = java.util.ResourceBundle.getBundle( bundle );
        
    //--------------------------------------------------------------------------
    // Labels
    //--------------------------------------------------------------------------
    
    static String ok_label      = resource.getString( "L_OK" );
    static String system_label  = resource.getString( "L_System" );
    static String about_label   = resource.getString( "L_About" );
    static String version_label = resource.getString( "L_Version" );
    static String build_label   = resource.getString( "L_Build" );
    static String license_label = resource.getString( "L_License" );
   
    //--------------------------------------------------------------------------
    
    static String title     = resource.getString( "Diversity_Navigator" );
    static String copyright = resource.getString( "Copyright" );
    static String license   = resource.getString( "License" );
    
    public String getTitle()
    {
        return title;
    }
    public String getCopyright()
    {
        return copyright;
    }
    public String getLicense()
    {
        return license;
    }
    /** Creates a new instance of AboutDiversityNavigator */
    
    public AboutDiversityNavigator( JFrame owner )
    {        
        super( owner, title, true );
        
        owner.setIconImage( DiversityNavigatorProperties.getDiversityIcon().getImage() );
        
	final Container contentPane = getContentPane();

	JTabbedPane tabPnl = new JTabbedPane();
        
	tabPnl.add( about_label, new AboutPanel() );
	tabPnl.add( system_label, new SystemPropertiesTable() );

        tabPnl.setPreferredSize( new java.awt.Dimension( 370, 280 ) );
	contentPane.setLayout( new BorderLayout() );
	contentPane.add( tabPnl, BorderLayout.CENTER );

	// Ok button at bottom of dialog.
        
	JPanel  btnsPnl = new JPanel();
	JButton okButton = new JButton( ok_label );
	
        okButton.addActionListener( new java.awt.event.ActionListener() 
        {
            public void actionPerformed( java.awt.event.ActionEvent evt ) 
            {
		dispose();
            }
	});
        
	btnsPnl.add( okButton );
	contentPane.add( btnsPnl, BorderLayout.SOUTH );
        contentPane.setVisible( true );
        
	getRootPane().setDefaultButton( okButton );
	pack();
        //  center gui in main frame
        java.awt.Point pos = owner.getLocationOnScreen();
        java.awt.Dimension d = owner.getSize();
        double centerX = d.getWidth() / 2;
        double centerY = d.getHeight() / 2;
        pos.translate( (int) centerX - this.getWidth() / 2, (int) centerY - this.getHeight() / 2 );
        this.setLocation( pos );        
        this.setVisible( true );
    }

    private static final class AboutPanel extends JPanel 
    {
	/**
         * Comment for <code>serialVersionUID</code>
         */
        private static final long serialVersionUID = 3257283621784924729L;

        AboutPanel() 
        {
            super();
            setLayout( new BorderLayout() );
            JLabel label = new JLabel();
            label.setIcon( DiversityNavigatorProperties.getAboutDiversityIcon() );
            add( BorderLayout.CENTER, label );
            //------------------------------------------------------------------
            JTextArea textArea = new JTextArea();
            textArea.setEditable( false );
            textArea.setOpaque( false );
            textArea.append( version_label + ": " + DiversityNavigatorProperties.getDiversityNavigatorVersion() + 
                             " " + build_label + ": " + DiversityNavigatorProperties.getDiversityNavigatorBuild() );
            textArea.append( "\n" );
            textArea.append( copyright );
            textArea.append( "\n" );
            textArea.append( license_label + ": " + license );
            // ClearLook
            // textArea.setBorder( BorderFactory.createEmptyBorder( 10, 10, 10, 10 ) );
            add( BorderLayout.SOUTH, textArea );
	}
    }
}
