/*
 * DnOptionPane.java
 *
 * Created on 16. September 2003, 16:18
 */

package net.metadiversity.diversity.navigator.gui;

import java.awt.Component;

import javax.swing.Icon;

import org.apache.log4j.Logger;

import net.metadiversity.diversity.navigator.DiversityNavigatorProperties;
/**
 *
 * @author  Dieter Neubacher
 */
public class DnOptionPane extends javax.swing.JOptionPane
{
    static Component defaultParentComponent = null;
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3258128050859422774L;
    static Logger logger = Logger.getLogger( DnOptionPane.class.getName() );
    /** 
     + Creates a JOptionPane with a test message. 
     */
    public DnOptionPane()
    {
        super();
        try
        {
            DnOptionPane.getRootFrame().setIconImage( DiversityNavigatorProperties.getDiversityIcon().getImage() );
            this.setIcon( DiversityNavigatorProperties.getDiversityIcon() );
        }
        catch( java.lang.NullPointerException ex )
        {
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
        }        
    }    
    /** 
     * Creates a instance of JOptionPane to display a message using the 
     * plain-message message type and the default options delivered by the UI.
     */
    public DnOptionPane( Object message )
    {
        super( message );
    }
    /** Creates an instance of JOptionPane to display a message with the 
     *  specified message type and the default options,
     */
    public DnOptionPane( Object message, int messageType )
    {
        super( message, messageType );
    }    
    /**
     * Creates an instance of JOptionPane to display a message with the specified 
     * message type and options.
     */
    public DnOptionPane( Object message, int messageType, int optionType )          
    {
        super( message, messageType, optionType );
    }    
    /**
     * Creates an instance of JOptionPane to display a message with the specified 
     * message type, options, and icon.
     */
    public DnOptionPane( Object message, int messageType, int optionType, Icon icon )          
    {
        super( message, messageType, optionType, icon );
    }    
    /**
     * Creates an instance of JOptionPane to display a message with the specified 
     * message type, icon, and options.
     */
    public DnOptionPane( Object message, int messageType, int optionType, Icon icon, Object[] options )          
    {
        super( message, messageType, optionType, icon, options );
    }    
    /**
     * Creates an instance of JOptionPane to display a message with the specified 
     * message type, icon, and options, with the initially-selected option specified.
     */
    public DnOptionPane( Object message, int messageType, int optionType, Icon icon, Object[] options, Object initialValue )          
    {
        super( message, messageType, optionType, icon, options, initialValue );
    }    

    private static void setDiversityNavigatorLookAndFeel()
    {
        
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public static void DnShowMessageDialog( Component parent, Object message , String title, int messageType )
    {
        try
        {
            getRootFrame().setIconImage( DiversityNavigatorProperties.getDiversityIcon().getImage() );
           
            // setIcon( DiversityNavigatorProperties.getDiversityIcon() );
        }
        catch( java.lang.NullPointerException ex )
        {
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
        }  
        if( parent == null )
        {
            parent = defaultParentComponent;
        }
        showMessageDialog( parent, message, title, messageType );        
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public static int DnShowConfirmDialog( Component parent, Object message , String title, int option, int messageType )
    {
        try
        {
            getRootFrame().setIconImage( DiversityNavigatorProperties.getDiversityIcon().getImage() );
           
            // setIcon( DiversityNavigatorProperties.getDiversityIcon() );
        }
        catch( java.lang.NullPointerException ex )
        {
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
        }        
        if( parent == null )
        {
            parent = defaultParentComponent;
        }
        return showConfirmDialog( parent, message, title, option, messageType );        
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public static java.lang.String DnShowInputDialog( Component parent, Object message , String title, int messageType )
    {
        try
        {
            getRootFrame().setIconImage( DiversityNavigatorProperties.getDiversityIcon().getImage() );
           
            // setIcon( DiversityNavigatorProperties.getDiversityIcon() );
        }
        catch( java.lang.NullPointerException ex )
        {
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
        }        
        if( parent == null )
        {
            parent = defaultParentComponent;
        }
        return showInputDialog( parent, message, title, messageType );        
    }
    
    
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public static String  DnShowInputDialog(Component parent, Object message, Object initialSelectionValue) 
    {
        try
        {
            getRootFrame().setIconImage( DiversityNavigatorProperties.getDiversityIcon().getImage() );
           
            // setIcon( DiversityNavigatorProperties.getDiversityIcon() );
        }
        catch( java.lang.NullPointerException ex )
        {
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
        }        
        return showInputDialog( parent, message, initialSelectionValue );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------    
    public static void DnShowErrorDialog( Object message )
    {
        try
        {
            getRootFrame().setIconImage( DiversityNavigatorProperties.getDiversityIcon().getImage() );           
            // setIcon( DiversityNavigatorProperties.getDiversityIcon() );
        }
        catch( java.lang.NullPointerException ex )
        {
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
        }        
        showMessageDialog( defaultParentComponent, message, "Error", DnOptionPane.ERROR_MESSAGE );        
    }
    
    // Default parent for DiversityNavigator
    public static void setDefaultParentComponent( Component parent )
    {
        defaultParentComponent = parent;
    }
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args)
    {
        DiversityNavigatorProperties p = new DiversityNavigatorProperties();
        DnOptionPane op = new DnOptionPane();
        op.setIcon( DiversityNavigatorProperties.getDiversityIcon() );
        op.setMessage( "test" );
        op.setVisible( true );
        op.getValue();
        // 
        // DnOptionPane.DnShowMessageDialog( null, "alert", "alert", DnOptionPane.ERROR_MESSAGE );
        String str = DnOptionPane.DnShowInputDialog( null, "Input Description", "Frame header", DnOptionPane.QUESTION_MESSAGE );
        
        System.out.println( "Input: " + str );
    }    
}
