package net.metadiversity.diversity.navigator.gui;

import org.apache.log4j.Logger;

import java.sql.*;
import javax.swing.table.*;

/**
 * Store ResultSet and MetaData for QueryresultSetTable
*/
abstract class QueryResultSetTableModel extends AbstractTableModel
{
    static Logger logger = Logger.getLogger( QueryResultSetTableModel.class.getName() );
    
    private boolean             debugFlag = true;
    
    private java.sql.ResultSet rs;
    private java.sql.ResultSetMetaData rsmd;
    /**
      Construct an new TableModel
      @param aResultSet ResultSet
    */
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public QueryResultSetTableModel( java.sql.ResultSet use_rs )
    {
        rs = use_rs;
        try
        {
            rsmd = rs.getMetaData();
        }
        catch( SQLException ex )
        {
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
        }
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public String getColumnName( int c )
    {
        try
        {
            return rsmd.getColumnName( c + 1 );
        }
        catch( SQLException ex )
        {
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
            return "";
        }
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public int getColumnCount()
    {
        try
        {
            return rsmd.getColumnCount();
        }
        catch( SQLException ex )
        {
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
            return 0;
        }
    }
    //----------------------------------------------------------------------
    //----------------------------------------------------------------------
   /**
      Get ResultSet for this Model
      @return ResultSet
   */
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    protected java.sql.ResultSet getResultSet()
    {
        return rs;
    }
}
