/**
 * Title:        Checklist
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      University Bayreuth
 * @author Dieter Neubacher
 * @version 1.0
 */
package net.metadiversity.diversity.navigator.message;

import javax.swing.*;

import org.apache.log4j.*;

public class DiversityNavigatorMessage
{
    static Logger logger = Logger.getLogger( DiversityNavigatorMessage.class.getName() );
    
    static final String DIVERSITY_NAVIGATOR = "Diversity Navigator";
    static final String WARNING     = "Warning";
    static final String ERROR       = "Error";
    static final String INFORMATION = "Information";
    static final String QUESTION    = "Question";
    static final String PLAIN       = "Plain";
    static final String EXCEPTION   = "Exception";
    
// ???    static javax.swing.JTextArea output;  // Error output area 
    
    private DiversityNavigatorMessage()
    {        
    }
// ???
    /*
    public static void setOutputTextArea( javax.swing.JTextArea o )
    {        
        output = o;
    }
    */
    
    public static int showException( String message )
    {
        return showException( EXCEPTION, message );
    }
    public static int showException( java.lang.Exception e )
    {
        return showException( EXCEPTION, e );
    }
    public static int showException(  String headline, String message )
    {
	Object[] msg = { headline, message };
        return JOptionPane.showConfirmDialog( null, msg, DIVERSITY_NAVIGATOR, JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE );
    }
    public static int showException(  String headline, java.lang.Exception e )
    {
	Object[] msg = { headline, e.getMessage() };
        
        // ??? output.append( e.getMessage() );
        // ??? output.append( e.toString() );
        
        return JOptionPane.showConfirmDialog( null, msg, DIVERSITY_NAVIGATOR, JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE );
    }
    //--------------------------------------------------------------------------
    public static int showWarning( String message )
    {
        return showWarning( WARNING, message );
    }
    public static int showWarning(  String headline, String message )
    {
	Object[] msg = { headline, message };
        return JOptionPane.showConfirmDialog( null, msg, DIVERSITY_NAVIGATOR, JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE );
    }
    //--------------------------------------------------------------------------
    public static int showInformation( String message )
    {
        return showInformation( INFORMATION, message );
    }
    public static int showInformation(  String headline, String message )
    {
	Object[] msg = { headline, message };
        return JOptionPane.showConfirmDialog( null, msg, DIVERSITY_NAVIGATOR, JOptionPane.DEFAULT_OPTION, JOptionPane.INFORMATION_MESSAGE );
    }
    //--------------------------------------------------------------------------
    public static int showQuestion( String message )
    {
        return showQuestion( QUESTION, message );
    }
    public static int showQuestion(  String headline, String message )
    {
	Object[] msg = { headline, message };
        return JOptionPane.showConfirmDialog( null, msg, DIVERSITY_NAVIGATOR, JOptionPane.DEFAULT_OPTION, JOptionPane.QUESTION_MESSAGE );
    }
    //--------------------------------------------------------------------------
    public static int showPlain( String message )
    {
        return showPlain( PLAIN, message );
    }
    public static int showPlain( String headline, String message )
    {
	Object[] msg = { headline, message };
        return JOptionPane.showConfirmDialog( null, msg, DIVERSITY_NAVIGATOR, JOptionPane.DEFAULT_OPTION, JOptionPane.PLAIN_MESSAGE );
    }
    //--------------------------------------------------------------------------
    public static int showError( String message )
    {
        return showError( ERROR, message );
    }
    public static int showError(  String headline, String message )
    {
	Object[] msg = { headline, message };
        return JOptionPane.showConfirmDialog( null, msg, DIVERSITY_NAVIGATOR, JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE );
    }
    //--------------------------------------------------------------------------
    
    
    //--------------------------------------------------------------------------
    
    public static void main( String args[] )
    {
        int ret;
         
        ret = DiversityNavigatorMessage.showWarning(      "default warning text"  );
        
        ret = DiversityNavigatorMessage.showWarning(      "Warning",      "warning text"  );
        ret = DiversityNavigatorMessage.showError(        "Error",        "error text"    );
        ret = DiversityNavigatorMessage.showQuestion(     "Question",     "question text" );
        ret = DiversityNavigatorMessage.showInformation(  "Information",  "information text" );
        ret = DiversityNavigatorMessage.showPlain(        "Plain",        "plain text" );
    }
}
