/*
 * DnDbNode.java
 *
 * Created on 8. Oktober 2003, 12:15
 */

package net.metadiversity.diversity.navigator.project;

import org.apache.log4j.Logger;

/**
 *
 * @author  Dieter Neubacher
 */
public class DnDbNode implements javax.swing.tree.TreeNode
{
    static Logger logger = Logger.getLogger( DnDbNode.class.getName() );
    
    java.lang.String path;
    int level;
    int minLevel;
    int maxLevel;
    
    DnDbNode parent;
    
    java.util.Vector childs;
    
    public static final int LEVEL_ROOT      = 0;
    public static final int LEVEL_PROJECT   = 1;
    public static final int LEVEL_DB_GROUP  = 2;
    public static final int LEVEL_DATABASE  = 3;
    public static final int LEVEL_TABLE     = 4;
    public static final int LEVEL_FIELD     = 5;

    /** Creates a new instance of DnDbNode */
    public DnDbNode( DnDbNode parentNode, java.lang.String path )
    {
        this.path = path;
        this.parent = parentNode;
    
        childs = new java.util.Vector();
        
        minLevel = LEVEL_ROOT;
        maxLevel = LEVEL_FIELD;
        // calculate level
        int pos = 0;
        java.lang.String str = path.toString();
        while( ( pos = str.indexOf( '.' ) ) > 0 )
        {
            if( logger.isDebugEnabled() ) logger.debug( "str: " + str );
            level++;
        }    
    }
    //--------------------------------------------------------------------------
    public java.util.Enumeration children()    
    {
        java.util.Enumeration enumer = childs.elements();
        return enumer;
    }
    //--------------------------------------------------------------------------
    public boolean getAllowsChildren()
    {
        if( level < maxLevel ) 
            return true;
        else
            return false;
    }
    //--------------------------------------------------------------------------
    public javax.swing.tree.TreeNode getChildAt( int param )
    {
        return (DnDbNode) childs.get( param );
    }
    //--------------------------------------------------------------------------
    public int getChildCount()
    {
        return childs.size();
    }
    //--------------------------------------------------------------------------
    public int getIndex(javax.swing.tree.TreeNode treeNode)
    {
        int index = -1;
        for( int i = 0; i < childs.size(); i++ )
        {
            if( treeNode == childs.get( i ) )
            {
                index = i ;
                break;
            }
        }        
        return index;
    }    
    //--------------------------------------------------------------------------
    public javax.swing.tree.TreeNode getParent()
    {
        return parent;
    }    
    //--------------------------------------------------------------------------
    public boolean isLeaf()
    {
        if( level <= maxLevel )
            return true;
        else            
            return false;
    }    
    //--------------------------------------------------------------------------
    public void addChild( DnDbNode node )
    {
        childs.add( node );
    }
}
