package net.metadiversity.diversity.navigator.project;

import javax.swing.event.*;
import javax.swing.tree.*;
import java.util.*;

import org.apache.log4j.Logger;

/**
 *
 * @author  didi
 */
public class ProjectTreeModel implements TreeModel 
{
    static Logger logger = Logger.getLogger( ProjectTreeModel.class.getName() );
    
	private ProjectNode root = null;
	private Vector Listeners = new Vector();
	private ProjectPane inPane;

	public ProjectTreeModel( ProjectPane inPane ) 
        {
		this.inPane = inPane;
		root = new ProjectNode( inPane, null, ProjectNode.NODE_TYPE_PROJECTS_CAPTION, "Projects" );
	}

	public void reload() 
        {
		root.reloadChilds();
		for (Enumeration Enum=Listeners.elements(); Enum.hasMoreElements(); ) 
                {
			TreeModelListener tml = (TreeModelListener)Enum.nextElement();
			Object[] reloadFrom = { root };
			TreeModelEvent tme = new TreeModelEvent(this, reloadFrom);
			tml.treeStructureChanged( tme );
		}
	}
	public void reloadSubTree( ProjectNode reloadFromNode ) 
        {
		root.reloadChilds();
		for( Enumeration Enum=Listeners.elements(); Enum.hasMoreElements(); ) 
                {
			TreeModelListener l = (TreeModelListener)Enum.nextElement();
			Object[] reloadFrom = {reloadFromNode};
			TreeModelEvent e = new TreeModelEvent(this, reloadFrom);
			l.treeStructureChanged(e);
		}
	}
	public void addTreeModelListener(TreeModelListener l) 
        {
		Listeners.add(l);
	}
        //----------------------------------------------------------------------
	public Object getChild( Object parent, int index ) 
        {
		return (Object) (((ProjectNode)parent).getChild( index ) );
	}
        //----------------------------------------------------------------------
	public int getChildCount(Object parent) 
        {
		return ((ProjectNode) parent).getChildCount();
	}        
        //----------------------------------------------------------------------
	public int getIndexOfChild( Object parent, Object child ) 
        {
		return ((ProjectNode) parent).getChildIndex( child );
	}
        //----------------------------------------------------------------------
	public Object getRoot() 
        {
		return (Object) root;
	}
        //----------------------------------------------------------------------
	public boolean isLeaf( Object node ) 
        {
		return ((ProjectNode) node).isLeaf();
	}
        //----------------------------------------------------------------------
	public void removeTreeModelListener( TreeModelListener l ) 
        {
		Listeners.remove(l);
	}
        //----------------------------------------------------------------------
	public void valueForPathChanged( TreePath path, Object newValue ) 
        {
	}
}
