/*
 * UbtCollectionProjectPlugin.java
 *
 * Created on 18. November 2003, 16:15
 */

package net.metadiversity.diversity.navigator.projectPlugin;

import org.apache.log4j.Logger;

//import net.metadiversity.diversity.navigator.gui.ProjectQueryPanel;
import net.metadiversity.diversity.navigator.gui.delta_editor.DeltaEditor;
import net.metadiversity.diversity.navikey.ui.NaviKey;

/**
 *
 * @author  Dieter Neubacher
 */
public class DeltaEditorProjectPlugin extends Plugin
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3257289140801321013L;
    static Logger logger = Logger.getLogger( DeltaEditorProjectPlugin.class.getName() );
    
    public DeltaEditorProjectPlugin()
    {
        super( "LIAS Light", "Diversity Workbench" );

        String delta_editor_database = "LIAS Light Descriptions";
        addProjectDatabase( null, delta_editor_database );
        
        String diversity_taxon_names_database = "Diversity Taxon Names Fungi";
        addProjectDatabase( null, diversity_taxon_names_database );

        String diversity_accepted_names_cache_database = "Diversity AcceptedNames Cache";
        addProjectDatabase( null, diversity_accepted_names_cache_database );

        java.sql.Connection connectionAcceptedNames = null;        
        
        java.sql.Connection namesConnection = null;        
        java.sql.Connection con = null;        
        try
        {
            net.metadiversity.diversity.navigator.connection.ConnectionInfo ci;        
            ci = net.metadiversity.diversity.navigator.connection.ConnectionsManager.getConnectionInfoByName( delta_editor_database );
            logger.info( "Connect to: " + ci.getUrl() );
            con = ci.getConnection();
            
            ci = net.metadiversity.diversity.navigator.connection.ConnectionsManager.getConnectionInfoByName( diversity_taxon_names_database );
            logger.info( "Connect to: " + ci.getUrl() );
            namesConnection = ci.getConnection();
            
            ci = net.metadiversity.diversity.navigator.connection.ConnectionsManager.getConnectionInfoByName( diversity_accepted_names_cache_database );
            logger.info( "Connect to: " + ci.getUrl() );
            connectionAcceptedNames = ci.getConnection();
        }
        catch( java.sql.SQLException ex )
        {
             logger.error( ex.getMessage(), ex.fillInStackTrace() );
        }
        catch( Exception ex )
        {
             logger.error( ex.getMessage(), ex.fillInStackTrace() );
        }
        String tablePrefix = "LIASlight";
        
        
        DeltaEditor p = new DeltaEditor( con, namesConnection, null, tablePrefix, true );
        
        String specs = p.getSpecsString();
        String chars = p.getCharsString();
        String items = p.getItemsString();
        
        NaviKey navikey = new NaviKey( (java.awt.Container) getIdentificationPanel(), specs, chars, items );
        navikey.init();
        this.setGridViewPanel( p );
        this.pack();
        this.setVisible( true );
    }
}
