/*
 * Plugin.java
 *
 * Created on 2. November 2002, 15:47
 */

package net.metadiversity.diversity.navigator.projectPlugin;


import org.apache.log4j.Logger;

import net.metadiversity.diversity.navigator.DiversityNavigatorProperties;
import net.metadiversity.diversity.navigator.gui.ProjectQueryPanel;
import net.metadiversity.diversity.navigator.gui.DnMenuItem;
import net.metadiversity.diversity.navigator.gui.HtmlViewer;
/**
 *
 * @author  didi
 */
public class Plugin extends javax.swing.JInternalFrame 
{    
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3257291344069408057L;

    static Logger logger = Logger.getLogger( Plugin.class.getName() ); 

    String project  = null;
    String dbgroup  = null;
    
    ProjectQueryPanel queryPanel = null;   
    
    /** Creates new form Plugin */
    public Plugin( String project, String group ) 
    {
        this.project = project;
        this.dbgroup = group;
        //---------------------
        // Set Diversity Icon
        //----------------------
        this.setFrameIcon( DiversityNavigatorProperties.getDiversityIcon()  );
        
        initComponents();
        
        addFileMenuItem( "file.exit",     new java.awt.event.ActionListener()
            {
                public void actionPerformed( java.awt.event.ActionEvent evt )
                {
                    dispose();
                }
            }
        );
        
        addHelpMenuItem( "help.help",     new java.awt.event.ActionListener()
            {
                public void actionPerformed( java.awt.event.ActionEvent evt )
                {
                    try 
                    {
                        HtmlViewer browser = new HtmlViewer( "Diversity Navigator Help", "index.html" );
                        //  center gui in main frame
                        java.awt.Point pos = getLocationOnScreen();
                        pos.translate( (int) getWidth() / 2 - browser.getWidth() / 2, (int) getHeight() / 2 - browser.getHeight() / 2 );
                        browser.setLocation( pos );
                        browser.setVisible( true );   
                        logger.debug( "start HelpViewer" );
                        browser.start();
                        // browser.run();
                    }
                    catch(Exception ex ) 
                    {
                        logger.error( "Can't open frame Help : " + ex.toString() );
                        logger.error( ex.getMessage(), ex.fillInStackTrace() );
                    }
                }
            }
        );
        
        // create query panel                        
        queryPanel = new ProjectQueryPanel( this, project, dbgroup );        
        jPanelFilter = queryPanel;
        jPanelFilter.setName( "Filter" );
        tapPane.remove( 0 );       
        tapPane.add( jPanelFilter, 0 );
        

        queryPanel.setQueryResultComponent( tapPane );
/*    
        setFilterPanel( new ProjectQueryPanel( this ) );
        
        java.sql.Connection conDesc = null;
        java.sql.Connection conColl = null;
        
        try
        {
            // conDesc = java.sql.DriverManager.getConnection( "jdbc:postgresql://hongkong:5432/ubt-description-94", "didi", "akiko" );
            // conColl = java.sql.DriverManager.getConnection( "jdbc:postgresql://hongkong:5432/ubt-collection-94", "didi", "akiko" );
            
            net.metadiversity.diversity.navigator.connection.ConnectionInfo ciDesc;        
            ciDesc = net.metadiversity.diversity.navigator.connection.ConnectionsManager.getConnectionInfoByName( "UBT BIOTA Lichen Descriptions" );
            conDesc = ciDesc.getConnection();
            logger.fatal( "Connect to: " + ciDesc.getUrl() );
            
            net.metadiversity.diversity.navigator.connection.ConnectionInfo ciColl;        
            ciColl = net.metadiversity.diversity.navigator.connection.ConnectionsManager.getConnectionInfoByName( "UBT BIOTA Lichen Collections" );
            conColl = ciColl.getConnection();
            logger.fatal( "Connect to: " + ciColl.getUrl() );            
        }
        catch( java.sql.SQLException ex )
        {
             logger.error( ex.getMessage(), ex.fillInStackTrace() );
        }
        catch( Exception ex )
        {
             logger.error( ex.getMessage(), ex.fillInStackTrace() );
        }
        
        setMapPanel( new CollectionTransectGisVisualisation( conDesc, conColl ) );
        // jPanelFilter = new ProjectQueryPanel( this ); 
        // jTabbedPane1.addTab( "Filter", jPanelFilter );
        this.pack();
        this.setVisible( true );
*/
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
/*
    public void addFileMenuItem( java.lang.String text, java.awt.event.ActionListener l )
    {
        int index = 0;
        javax.swing.JMenuItem newItem = new javax.swing.JMenuItem();
        newItem.setText( text );
        newItem.setEnabled( true );
        newItem.setVisible( true );
        if( l != null )
        {
            newItem.addActionListener( l );
        }        
        jProjectFileMenu.add( newItem, index );        
    }
 */
    public void addFileMenuItem( java.lang.String entryName, java.awt.event.ActionListener l )
    {
        int index = 0;
        javax.swing.JMenuItem newItem = new DnMenuItem( entryName );
        if( l != null )
        {
            newItem.addActionListener( l );
        }        
        jProjectFileMenu.add( newItem, index );        
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void addProceduresMenuItem( java.lang.String entryName, java.awt.event.ActionListener l )
    {
        int index = 0;
        javax.swing.JMenuItem newItem = new DnMenuItem( entryName );
        if( l != null )
        {
            newItem.addActionListener( l );
        }        
        jProjectProceduresMenu.add( newItem, index );        
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void addHelpMenuItem( java.lang.String entryName, java.awt.event.ActionListener l )
    {
        int index = 0;
        javax.swing.JMenuItem newItem = new DnMenuItem( entryName );
        if( l != null )
        {
            newItem.addActionListener( l );
        }        
        jProjectHelpMenu.add( newItem, index );        
    }
    //--------------------------------------------------------------------------
    // setup date for database and query accress
    //--------------------------------------------------------------------------
    /* first version
    public void setFilterPanel( javax.swing.JPanel p )    
    {
        jPanelFilter = p;
        jPanelFilter.setName( "Filter" );
        jTabbedPane1.remove( 0 );       
        jTabbedPane1.add( jPanelFilter, 0 );
    }
     **/
    
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void addProjectDatabase( String group, String database )
    {   
        try
        {
            queryPanel.addDatabase( group, database );
        }
        catch( java.sql.SQLException ex )
        {
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
        }
        /*
        queryPanel.addDatabase( dbgroup, "LIAS Checklists" );
        queryPanel.addDatabase( dbgroup, "LIAS Descriptive Data (disabled)" );
        
        jPanelFilter = queryPanel;
        jPanelFilter.setName( "Filter" );
        jTabbedPane1.remove( 0 );       
        jTabbedPane1.add( jPanelFilter, 0 );
         */
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void setDataFormPanel( javax.swing.JPanel p )    
    {
        jPanelForms = p;
        jPanelForms.setName( "Data Form" );
        tapPane.remove( 1 );       
        tapPane.add( jPanelForms, 1 );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void setGridViewPanel( javax.swing.JPanel p )    
    {
        jPanelGrid = p;
        jPanelGrid.setName( "Grid View" );
        tapPane.remove( 2 );       
        tapPane.add( jPanelGrid, 2 );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public java.awt.Component getGridViewPanel()
    {
        return jPanelGrid;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void setReportPanel( javax.swing.JPanel p )    
    {
        jPanelReports = p;
        jPanelReports.setName( "Reports" );
        tapPane.remove( 3 );       
        tapPane.add( jPanelReports, 3 );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void setMapPanel( javax.swing.JPanel p )
    {
        jPanelMap = p;
        jPanelMap.setName( "Visualisation" );
        tapPane.remove( 4 );       
        tapPane.add( jPanelMap, 4 );        
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void setIdentificationPanel( javax.swing.JPanel p )
    {
        jPanelIdentification = p;
        jPanelIdentification.setName( "Identification" );
        tapPane.remove( 5 );       
        tapPane.add( jPanelIdentification, 5 );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public java.awt.Component getIdentificationPanel()
    {
        return jPanelIdentification;
    }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents()//GEN-BEGIN:initComponents
    {
        tapPane = new javax.swing.JTabbedPane();
        jPanelFilter = new javax.swing.JPanel();
        jPanelForms = new javax.swing.JPanel();
        jPanelGrid = new javax.swing.JPanel();
        jPanelReports = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        jButton3 = new javax.swing.JButton();
        jButton4 = new javax.swing.JButton();
        jPanelHeader = new javax.swing.JPanel();
        jLabel20 = new javax.swing.JLabel();
        jTextField2 = new javax.swing.JTextField();
        jButton2 = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        jPanelFooter = new javax.swing.JPanel();
        jLabel19 = new javax.swing.JLabel();
        jTextField1 = new javax.swing.JTextField();
        jButton1 = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTextArea2 = new javax.swing.JTextArea();
        jPanelMap = new javax.swing.JPanel();
        jPanelIdentification = new javax.swing.JPanel();
        jMenuBar1 = new javax.swing.JMenuBar();
        jProjectFileMenu = new javax.swing.JMenu();
        jProjectProceduresMenu = new javax.swing.JMenu();
        jProjectHelpMenu = new javax.swing.JMenu();

        setClosable(true);
        setIconifiable(true);
        setMaximizable(true);
        setResizable(true);
        tapPane.addTab("Filter", jPanelFilter);

        tapPane.addTab("Form View", jPanelForms);

        tapPane.addTab("Grid View", jPanelGrid);

        jPanelReports.setLayout(new javax.swing.BoxLayout(jPanelReports, javax.swing.BoxLayout.Y_AXIS));

        jPanel1.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        jPanel1.setMaximumSize(new java.awt.Dimension(32767, 52));
        jPanel1.setMinimumSize(new java.awt.Dimension(209, 15));
        jPanel1.setPreferredSize(new java.awt.Dimension(209, 35));
        jButton3.setText("Save to file");
        jPanel1.add(jButton3);

        jButton4.setText("Use WebService");
        jButton4.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                jButton4ActionPerformed(evt);
            }
        });

        jPanel1.add(jButton4);

        jPanelReports.add(jPanel1);

        jPanelHeader.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        jPanelHeader.setMaximumSize(new java.awt.Dimension(32767, 32));
        jLabel20.setText("Header :");
        jLabel20.setMaximumSize(new java.awt.Dimension(60, 15));
        jLabel20.setMinimumSize(new java.awt.Dimension(60, 15));
        jLabel20.setPreferredSize(new java.awt.Dimension(60, 15));
        jLabel20.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        jPanelHeader.add(jLabel20);

        jTextField2.setText("http://net.metadiversity.diversity/navigator/ReportHeader.xml  ");
        jPanelHeader.add(jTextField2);

        jButton2.setText("load");
        jPanelHeader.add(jButton2);

        jPanelReports.add(jPanelHeader);

        jScrollPane1.setViewportView(jTextArea1);

        jPanelReports.add(jScrollPane1);

        jPanelFooter.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        jPanelFooter.setMaximumSize(new java.awt.Dimension(32767, 32));
        jLabel19.setText("Footer :");
        jLabel19.setMaximumSize(new java.awt.Dimension(60, 15));
        jLabel19.setMinimumSize(new java.awt.Dimension(60, 15));
        jLabel19.setPreferredSize(new java.awt.Dimension(60, 15));
        jLabel19.setHorizontalTextPosition(javax.swing.SwingConstants.LEFT);
        jPanelFooter.add(jLabel19);

        jTextField1.setText("http://net.metadiversity.diversity/navigator/ReportFooter.xml     ");
        jPanelFooter.add(jTextField1);

        jButton1.setText("load");
        jPanelFooter.add(jButton1);

        jPanelReports.add(jPanelFooter);

        jScrollPane2.setViewportView(jTextArea2);

        jPanelReports.add(jScrollPane2);

        tapPane.addTab("Report", jPanelReports);

        tapPane.addTab("Visualisation", jPanelMap);

        tapPane.addTab("Identification", jPanelIdentification);

        getContentPane().add(tapPane, java.awt.BorderLayout.CENTER);

        jProjectFileMenu.setMnemonic('f');
        jProjectFileMenu.setText("File");
        jMenuBar1.add(jProjectFileMenu);

        jProjectProceduresMenu.setMnemonic('p');
        jProjectProceduresMenu.setText("Procedures");
        jMenuBar1.add(jProjectProceduresMenu);

        jProjectHelpMenu.setMnemonic('h');
        jProjectHelpMenu.setText("Help");
        jMenuBar1.add(jProjectHelpMenu);

        setJMenuBar(jMenuBar1);

        pack();
    }//GEN-END:initComponents

    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
        // Add your handling code here:
        this.dispose();
    }//GEN-LAST:event_jButton4ActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JLabel jLabel19;
    private javax.swing.JLabel jLabel20;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanelFilter;
    private javax.swing.JPanel jPanelFooter;
    private javax.swing.JPanel jPanelForms;
    private javax.swing.JPanel jPanelGrid;
    private javax.swing.JPanel jPanelHeader;
    private javax.swing.JPanel jPanelIdentification;
    private javax.swing.JPanel jPanelMap;
    private javax.swing.JPanel jPanelReports;
    private javax.swing.JMenu jProjectFileMenu;
    private javax.swing.JMenu jProjectHelpMenu;
    private javax.swing.JMenu jProjectProceduresMenu;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JTextArea jTextArea2;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JTextField jTextField2;
    private javax.swing.JTabbedPane tapPane;
    // End of variables declaration//GEN-END:variables

    // Test this form
    public static void main( String args[] )
    {
        javax.swing.JFrame f = new javax.swing.JFrame();
        Plugin test = new Plugin( "Lias", "Diversity Workbench" );
        test.addProjectDatabase( null, "LIAS Checklists" );
        test.addProjectDatabase( null, "LIAS Descriptive Data (disabled)" );
        
        test.show();
        f.getContentPane().add( test );
        f.setSize( 800,600 );
        f.setVisible( true );
    }
}
