/*
 * ExportQueryDataToFile.java
 *
 * Created on 26. November 2003, 11:03
 */

package net.metadiversity.diversity.navigator.util;

import org.apache.log4j.Logger;

import java.sql.*;
import java.io.*;
// import java.util.*;
import java.lang.StringBuffer;

/**
 *
 * @author  Dieter Neubacher
 */
public class ExportQueryDataToFile
{
    static Logger logger = Logger.getLogger( ExportQueryDataToFile.class.getName() );
    
    java.lang.String db_url     = "jdbc:postgresql://hongkong:5432/bsm-email-list";
    java.lang.String db_user    = "didi";
    java.lang.String db_pwd     = "";
    java.lang.String db_driver  = "org.postgresql.Driver";
    java.lang.String file       = ""; 
    
    java.util.Vector columnType    = null;
    java.util.Vector columnName    = null;
    
    Connection con  = null;
    String importFileName = null;
    
    
    final static boolean debugShowValues = false;
    
    
    final static String DATESTYLE_EUROPEAN_GERMAN = "SET DATESTYLE TO EUROPEAN, GERMAN;";
    final static char optionNumberFormatDotCharacter = ',';
    
    
    /** Creates a new instance of ExportQueryDataToFile */
    public ExportQueryDataToFile( String url, String user, String pwd, String filename )
    {
        db_url  = url;
        db_user = user;
        db_pwd  = pwd;
        file    = filename;
        
        System.out.println();
        System.out.println( "Export Data to file: " + filename );
        System.out.println();
    }    
    //--------------------------------------------------------------------------
    //
    //--------------------------------------------------------------------------
    private int connect()
    {
        // load driver and get DB-Connection
        try
        {
            Class.forName( "org.postgresql.Driver" );
            System.out.println( "Load PostgreSQL Driver..." );
        }
        catch( java.lang.ClassNotFoundException ee )
        {
            System.out.println( "ClassNotFoundException: " );
            System.out.println( ee.getMessage() );
            
            return 1;
        }
        try
        {
            con = java.sql.DriverManager.getConnection( db_url, db_user, db_pwd );
        }            
        catch( java.sql.SQLException ex )
        {
            System.out.println( ex.getMessage() );             
            return 2;
        }
        
        return 0;
    }
    //--------------------------------------------------------------------------
    //
    //--------------------------------------------------------------------------
    public int export( String sqlQuery )
    {
        boolean errorFlag = false;
        
        java.lang.StringBuffer lastInsertString = null;        
        java.sql.Statement s;
        java.sql.ResultSet res;
        
/*        
        File f = new File( file );
        if( ! f.canRead() )
        {
            System.out.println( "Can't read input file: " + file );
            return 1;
        }
 */
        try
        {    
            FileOutputStream fos = new java.io.FileOutputStream( file );
            OutputStreamWriter osw = new java.io.OutputStreamWriter( fos, "UTF-8" );
            BufferedWriter bw = new java.io.BufferedWriter( osw );
            
            // ??? NO UTF-8 java.io.BufferedWriter bw = new java.io.BufferedWriter( new java.io.FileWriter( file ) );
            
            connect();
            s = con.createStatement();
            res = s.executeQuery( sqlQuery );
            
            int columnCount = res.getMetaData().getColumnCount() + 1;
            
            while( res.next() )
            {
                StringBuffer sb = new StringBuffer();
                int i = 1;
                String str = res.getString( i++ );
                // ??? while( str != null )
                while( i <= columnCount )
                {    
                    if( i != 2 )
                    {
                        sb.append( '\t' );
                    }
                    sb.append( str );
                    try
                    {
                        str = res.getString( i++ );
                    }    
                    catch( java.sql.SQLException ex )
                    {
                        str = null;
                    }                   
                }
                sb.append( '\n' );
                System.out.println( sb.toString() );
                bw.write( sb.toString() );
                
                // end of results
                
                if( res.isLast() )
                    break;
            }                                               
            bw.close();
        }    
        catch( java.sql.SQLException ex )
        {
            System.out.println( ex.getLocalizedMessage() );             
            errorFlag = true;
/*
            try
            {
                bw.close();
            }
            catch( java.sql.SQLException ex )
            {
            }
*/          
        }
        catch( java.io.IOException ex )
        {
            System.out.println( ex.getLocalizedMessage() );             
            errorFlag = true;
        }
        return 0;
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args)
    {
        String query = null;
        
        // query = "SELECT DISTINCT \"Genus\", \"Species\", \"Rank\", \"InfraspecificEpithet\" FROM \"checklists_data\" WHERE \"SynLevel\" = 0 ORDER BY \"Genus\", \"Species\", \"Rank\", \"InfraspecificEpithet\";";
        // 2004.02.24 query = "SELECT DISTINCT \"Genus\", \"Species\", \"Rank\", \"InfraspecificEpithet\" , \"First\", \"Author\",\"Suffix\", \"TaxonRef\", \"FlorRef\" FROM \"checklists_data\" WHERE \"SynLevel\" = 0 ORDER BY \"Genus\", \"Species\", \"Rank\", \"InfraspecificEpithet\", \"First\", \"Author\";";
        query = "SELECT DISTINCT \"Genus\", \"Species\", \"Rank\", \"InfraspecificEpithet\" , \"First\", \"Author\",\"Suffix\", \"TaxonRef\", \"SynLevel\" FROM \"checklists_data\" ORDER BY \"Genus\", \"Species\", \"Rank\", \"InfraspecificEpithet\", \"First\", \"Author\";";

        
        if( args.length == 0 || args.length > 4 )
        {
            System.out.println( "usage: url user password file" );
            System.out.println( "" );
            System.out.println( "url:       \"jdbc:postgresql://hongkong:5432/db-name\"" );
            System.out.println( "user:      username" );
            System.out.println( "password   password" );
            System.out.println( "file:      Export-File-Name" );
                                   
            // ExportQueryDataToFile exFile = new ExportQueryDataToFile( "jdbc:postgresql://192.168.1.21:5432/checklists", "didi", "", "/home/didi/checklists-export.txt" );
            ExportQueryDataToFile exFile = new ExportQueryDataToFile( "jdbc:postgresql://hongkong:5432/checklists", "didi", "", "/home/didi/checklists-export-2004-06-11.txt" );
            // ExportQueryDataToFile exFile = new ExportQueryDataToFile( "jdbc:postgresql://141.84.65.156:5432/checklists", "didi", "", "/home/didi/checklists-export.txt" );

            exFile.export( query );
        }
        else
        {
            // get paramms
            
            ExportQueryDataToFile exFile = new ExportQueryDataToFile( args[ 0 ], args[ 1 ], args[ 2 ], args[ 3 ] );
            exFile.export( query );
        }
    }
    
}
