package net.metadiversity.diversity.navikey.bo;

import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;


/**
 * @author Noel Cross
 * @author Michael Bartley
 * @author Dieter Neubacher
 */
public class MultiState extends State 
{
    public boolean ordered;
    Integer id;
    
    private int count = 0;
    private Hashtable cache;
    
    public MultiState()
    {
        super();
        cache = new Hashtable();
        count++;        
        ordered = false;
    }
    //----------------------------------------------------------------------    
    public void setId(Object id)
    {
        this.id = (Integer)id;
        if(id != null)
        {
            cache.put(this.id, this);
        }
    }
    
    //----------------------------------------------------------------------    
    public Object getId() 
    {
        return id;
    }
    
    //----------------------------------------------------------------------    
    public void setOrdered() 
    {    
        ordered = true;
    }
    //----------------------------------------------------------------------    
    public void setUnOrdered() 
    {
        ordered = false;
    }
    //----------------------------------------------------------------------    
    public boolean isOrdered() 
    {
        return ordered;
    }
    //----------------------------------------------------------------------    
    public boolean isUnOrdered() 
    {
        return ordered;
    }
    
    //----------------------------------------------------------------------    
    public boolean containedIn(Vector states)
    {
        boolean b = false;
        int limit = states.size();
        for(int i = 0; i < limit; i++)
        {
            State state = (State)states.elementAt(i);
            if(state == this)
            {
                b = true;
            }
        }
        return b;
    }
    
    //----------------------------------------------------------------------    
    public String getStringValue()
    {
        return getName();
    }
    //----------------------------------------------------------------------    
    public String toString()
    {
        return "name: " + getName();
    }
    //----------------------------------------------------------------------    
    public void print()
    {
        System.out.println(toString());
    }
}
