package net.metadiversity.diversity.navikey.bo;

import java.util.Vector;
import net.metadiversity.diversity.navikey.delta.DeltaData;


/**
 * State.java
 * @author Noel Cross
 * @author Michael Bartley
 */
public abstract class State extends BasicState
{    
    private ItemCharacter ic; // The character this state belongs to
 
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public State()
    {
        ic = new ItemCharacter();
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public ItemCharacter getItemCharacter()
    {
        return ic;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void setItemCharacter( ItemCharacter ic )
    {
        this.ic = ic;
        setCharacterId( ic.getId() );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    /** True if this state is contained in a Vector of States */
    public abstract boolean containedIn(Vector states);
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public static State getState( BasicState bs, DeltaData dd )
    {
        ItemCharacter ic = (ItemCharacter) dd.getItemCharacters().get( bs.getCharacterId() );
        
        if( ic == null )    // ???
        {
            return new NumericState( bs, dd );
        }
        else if( ic.isMultiState() )
        {
            Vector states = ic.getStates();
            for( int i=0; i < states.size(); i++ )
            {
                State s = (State)states.elementAt( i );
                if( s.getName().equals( bs.getName() ) )
                {
                    return s;
                }
            }
        }
        else if( ic.isNumeric() )
        {
            return new NumericState( bs, dd );
        }
        return null;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public abstract String getStringValue();
    public abstract void print();
    public abstract String toString();
}

