package net.metadiversity.diversity.navikey.ui;

import java.awt.BorderLayout;
import javax.swing.JList;
import java.util.Vector;

import net.metadiversity.diversity.navikey.bo.BasicItem;

/**
 * ItemsPanel.java
 *
 * @author Michael Bartley
 * 3/25/98
 * @author Dieter Neubacher
 */

class ItemsPanel extends javax.swing.JPanel
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3258132461857551927L;
    private Vector basicItems;
    private JList theList;
    private Vector listData;
    private javax.swing.JScrollPane jScrollPane;

    // ??? private BasicItem selectedItem;
    
    private final static int VISIBLE_ROWS = 15;
    private boolean enableColorSelection = false;
    
    public ItemsPanel()
    {
        super();
        setLayout( new BorderLayout() );
        
        basicItems = null;
        
        listData = new Vector();
        theList = new JList( listData );
        theList.setVisibleRowCount( VISIBLE_ROWS );
        theList.setSelectionMode( javax.swing.ListSelectionModel.SINGLE_SELECTION );
        
        jScrollPane = new javax.swing.JScrollPane();
        jScrollPane.setViewportView( theList );
        
        add( java.awt.BorderLayout.CENTER, jScrollPane );
        
        if( enableColorSelection )
        {
            theList.setBackground(NaviKey.naviKeyBackgroundColor);
            theList.setForeground(NaviKey.itemListColor);            
        }
        setVisible( true );

        theList.addListSelectionListener(new javax.swing.event.ListSelectionListener()
        {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt)
            {
                ValueChanged(evt);
            }
        });
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void ValueChanged(javax.swing.event.ListSelectionEvent evt)
    {
        // System.out.println( "ItemsPanel ValueChanged(): " + evt );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    /*
    private void MouseClicked(java.awt.event.MouseEvent evt)
    {
        System.out.println( evt );
    }
     */
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    /*
    public boolean handleEvent(Event e)
    {
        System.out.println( e );
        
        if(e.id == Event.LIST_SELECT)
        {
            selectedItem = (BasicItem)basicItems.elementAt(theList.getSelectedIndex());
        }
        return false;
    }
     */
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    /*
    public BasicItem getItem()
    {
        return selectedItem;
    }
     */
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public BasicItem getItem( int index )
    {
        // ??? return selectedItem = (BasicItem)basicItems.elementAt( index );
        return (BasicItem)basicItems.elementAt( index );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    /*
    public JList getTheList()
    {
        return theList;
    }
     */
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void updateList()
    {   
        listData.removeAllElements();
        
        if(basicItems == null)
        {    
            System.out.println("Null, idiot");
        }
        else
        {
            for(int i = 0; i < basicItems.size(); i++)
            {
                BasicItem item = (BasicItem)basicItems.elementAt(i);
                //System.out.println("adding : " + item.getName());
                // ??? theList.addItem(item.getName());
                listData.add( item.getName() );
            }
            theList.setListData( listData );
        }
        repaint();
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------    
    public void setItems(Vector basicItems)
    {
        this.basicItems = basicItems;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------    
    public Vector getItems()
    {
        return basicItems;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void addListSelectionListener( javax.swing.event.ListSelectionListener l )
    {
        theList.addListSelectionListener( l );
    }
}
