package net.metadiversity.diversity.navikey.ui;

// import java.awt.Event;

import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JButton;
import javax.swing.JCheckBox;

import javax.swing.JPanel;

import net.metadiversity.diversity.navikey.bo.BasicState;
import net.metadiversity.diversity.navikey.bo.NumericState;

/**
 * NumericStatePanel.java
 *
 * @author Michael Bartley
 * 3/25/98
 * @author Dieter Neubacher
  */

class NumericStatePanel extends javax.swing.JPanel implements java.awt.event.ActionListener
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3834313933862744371L;

    BasicState toBeReturned;
    
    javax.swing.JTextField  singleInput;
    javax.swing.JTextField  lowerRange;
    javax.swing.JTextField  upperRange;
    javax.swing.JCheckBox   single;
    javax.swing.JCheckBox   range;
    javax.swing.ButtonGroup cbg;
    javax.swing.JButton     set;

    private boolean enableColorSelection = false;
    
    private java.awt.event.ActionListener navikeyGuiListener;
    
    public NumericStatePanel()
    {
        super();
        singleInput = new JTextField( 10 );
        
        cbg = new javax.swing.ButtonGroup();
        
        lowerRange  = new JTextField( 10 );
        lowerRange.setEditable( false );
        
        upperRange  = new JTextField( 10 );
        upperRange.setEditable( false );
        
        set = new JButton( "Add" );
        
        cbg = new javax.swing.ButtonGroup();
        single = new JCheckBox( "Single Measurement", true );
        cbg.add( single );
        range  = new JCheckBox( "Measurements fall in the range", false );
        cbg.add( range );
        
        JPanel top = new JPanel();
        top.add( single );
        top.add( singleInput );
        add( top );
        JLabel llower = new JLabel( "Between" );
        JLabel lupper = new JLabel( "And" );
        JPanel bottom = new JPanel();
        add( range );
        bottom.add( llower );
        bottom.add( lowerRange );
        bottom.add( lupper );
        bottom.add( upperRange );
        add( bottom );
        add( set );
        
        set.addActionListener( this );
        single.addActionListener( this );
        range.addActionListener( this );
        
        if( enableColorSelection )
        {
            singleInput.setBackground( NaviKey.boxBGColor );
            singleInput.setForeground( NaviKey.boxFGColor );
           
            lowerRange.setBackground( NaviKey.boxBGColor );
            lowerRange.setForeground( NaviKey.boxFGColor );
            
            upperRange.setBackground( NaviKey.boxBGColor );
            upperRange.setForeground( NaviKey.boxFGColor );
            
            set.setBackground( NaviKey.naviKeyBackgroundColor );
            set.setForeground( NaviKey.buttonColor );
            
            // single.setBackground( NaviKey.naviKeyBackgroundColor );
            // single.setForeground( NaviKey.buttonColor );

            // range.setBackground( NaviKey.naviKeyBackgroundColor );
            // range.setForeground( NaviKey.buttonColor );
        }
        setVisible(true );
    }
    //--------------------------------------------------------------------------    
    //--------------------------------------------------------------------------    
    public void actionPerformed(java.awt.event.ActionEvent actionEvent)    
    {
        System.out.println( "NumericStatePanel : " + actionEvent );
        
        if( actionEvent.getSource() == range )
        {
            System.out.println( "range" );
            
            singleInput.setText( "" );
            singleInput.setEditable( false );
            lowerRange.setEditable( true );
            upperRange.setEditable( true );
        }
        else if( actionEvent.getSource() == single )
        {
            System.out.println( "single" );

            singleInput.setEditable( true );
            lowerRange.setText( "" );
            lowerRange.setEditable( false );
            upperRange.setText( "" );
            upperRange.setEditable( false );
        }
        else if( actionEvent.getSource() == set )
        {
            System.out.println( "set" );

            toBeReturned = new NumericState();
            if( single.isSelected() )
            {
                String temp = singleInput.getText();
                double d = toDouble( temp );
                toBeReturned.setName( ( new Double( d ) ).toString() );
            }
            else if( range.isSelected() )
            {
                String temp = lowerRange.getText();
                double dl = toDouble( temp );
                temp = upperRange.getText();
                double du = toDouble( temp );
                toBeReturned.setName( dl + "-" + du );                
            }
            java.awt.event.ActionEvent ae = new java.awt.event.ActionEvent( this, 1, "Set numeric state" );        
            navikeyGuiListener.actionPerformed( ae );        
        }
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    void updateGui()
    {
        java.awt.event.ActionEvent ae = new java.awt.event.ActionEvent( this, 1, "UpdateGui" );        
        navikeyGuiListener.actionPerformed( ae );        
    }    
    //--------------------------------------------------------------------------    
    //--------------------------------------------------------------------------    
    public BasicState getState()
    {
        return toBeReturned;
    }
    //--------------------------------------------------------------------------    
    //--------------------------------------------------------------------------    
    public double toDouble( String temp )
    {
        double d;
        try
        {
            d = Double.valueOf( temp ).doubleValue();
        }
        catch( NumberFormatException e )
        {
            d = 0;
        }
        return d;
    }
    //--------------------------------------------------------------------------    
    //--------------------------------------------------------------------------    
    public void reset()
    {
        singleInput.setText( "" );
        lowerRange.setText( "" );
        upperRange.setText( "" );
    }
    //--------------------------------------------------------------------------    
    //--------------------------------------------------------------------------    
    public String getInput()
    {
        return singleInput.getText();
    }
    //--------------------------------------------------------------------------    
    //--------------------------------------------------------------------------        
    public void addNavikeyGuiListener( java.awt.event.ActionListener al )
    {
        navikeyGuiListener = al;
    }    
}
