package net.metadiversity.diversity.navigator.db;

import net.metadiversity.diversity.navigator.hibernate.ubt.collection.*;

import net.metadiversity.diversity.navigator.hibernate.ubt.collection.CollectionSpecimen;

//import java.util.Hashtable;
//import java.util.Vector;
//import java.util.Enumeration;

//import java.io.PrintWriter;
//import java.io.InputStreamReader;
//import java.io.Serializable;

import net.sf.hibernate.HibernateException;
import net.sf.hibernate.Session;
import net.sf.hibernate.SessionFactory;
import net.sf.hibernate.Query;
import net.sf.hibernate.Transaction;
import net.sf.hibernate.cfg.Configuration;

//import org.xml.sax.ContentHandler;
//import org.apache.xml.serialize.*;

import net.metadiversity.diversity.navigator.connection.ConnectionInfo;
import net.metadiversity.diversity.navigator.gui.DnOptionPane;

import org.apache.log4j.Logger;

/**
 *
 * @author  didi
 */
public class CollectionBayreuthHibernate 
{    
    static Logger logger = Logger.getLogger( CollectionBayreuthHibernate.class.getName() );
    
    private int             collectionSpecimenCount;
    private java.util.List  collectionSpecimenIdsList;

    
    // ComboBoxModels used by the GUI        
    private javax.swing.DefaultComboBoxModel localisationModel;
    private javax.swing.DefaultComboBoxModel collectionModel;
    private javax.swing.DefaultComboBoxModel materialCategoryModel;
    private javax.swing.DefaultComboBoxModel taxonomicGroupModel;
    private javax.swing.DefaultComboBoxModel identificationQualifierModel;
    private javax.swing.DefaultComboBoxModel dateCategoryModel;
    private javax.swing.DefaultComboBoxModel typeStatusModel;
    private javax.swing.DefaultComboBoxModel labelTypeModel;
    private javax.swing.DefaultComboBoxModel imageTypeModel;
    private javax.swing.DefaultComboBoxModel collectionEditingModel;
    private javax.swing.DefaultComboBoxModel labelTranscriptionModel;
    private javax.swing.DefaultComboBoxModel identificationCategoryModel;
    private javax.swing.DefaultComboBoxModel accessionDateCategoryModel;
    //
    private javax.swing.DefaultComboBoxModel projectModel;
    private javax.swing.DefaultComboBoxModel personModel;
    private javax.swing.DefaultComboBoxModel taxonomicNameModel;
    
    private Session session = null;
    private SessionFactory sf = null;
    
/* ???    
        public class DbComboBoxModel extends javax.swing.DefaultComboBoxModel
        {
            
        };
*/    
    public java.util.HashMap dateCategoryHashMap;
    public java.util.HashMap indentificationCategoryHashMap;
    public java.util.HashMap indentificationQualifierHashMap;
    public java.util.HashMap typeStatusHashMap;
    public java.util.HashMap labelTypeHashMap;
    public java.util.HashMap labelTranscriptionHashMap;
    public java.util.HashMap localisationHashMap;
    public java.util.HashMap taxonomicGroupHashMap;
    public java.util.HashMap accessionDateCategoryHashMap;
    public java.util.HashMap materialCategoryHashMap;
    public java.util.HashMap collectionHashMap;
    
    private java.util.HashMap collectionIdHashmap;
    
    boolean disableDatabaseUpdate = true;

    java.awt.Component myParentComponent;

    public CollectionBayreuthHibernate(ConnectionInfo ci, java.awt.Component parentComponent ) throws Exception
    {        
        myParentComponent = parentComponent;    // used for error messages
        
        // Get configuration from config-directory
        String configDirectory = System.getProperty( "user.home" ) + "/.diversity_navigator/";
        
        // Build a configuration for this Database
        // String serverIP     = ci.getServerName();   // "192.168.1.12";
        // String dbName       = ci.getDatabaseName(); // "ubt-collection-94";
        String dbUser       = ci.getUser();         // "didi";
        // String serverPort   = ci.getDatabasePort(); // "5432";
        String dbPwd        = ci.getPwd();          
        String dbUrl        = ci.getUrl();
        
        collectionIdHashmap         = new java.util.HashMap();
                
        localisationModel           = new javax.swing.DefaultComboBoxModel();
        collectionModel             = new javax.swing.DefaultComboBoxModel();
        materialCategoryModel       = new javax.swing.DefaultComboBoxModel();
        taxonomicGroupModel         = new javax.swing.DefaultComboBoxModel();
        identificationQualifierModel= new javax.swing.DefaultComboBoxModel();
        dateCategoryModel           = new javax.swing.DefaultComboBoxModel();
        typeStatusModel             = new javax.swing.DefaultComboBoxModel();
        labelTypeModel              = new javax.swing.DefaultComboBoxModel();
        imageTypeModel              = new javax.swing.DefaultComboBoxModel();
        collectionEditingModel      = new javax.swing.DefaultComboBoxModel();
        labelTranscriptionModel     = new javax.swing.DefaultComboBoxModel();
        identificationCategoryModel = new javax.swing.DefaultComboBoxModel();
        //
        projectModel                = new javax.swing.DefaultComboBoxModel();
        personModel                 = new javax.swing.DefaultComboBoxModel();
        taxonomicNameModel          = new javax.swing.DefaultComboBoxModel();
        
        dateCategoryHashMap         = new java.util.HashMap();
        indentificationCategoryHashMap = new java.util.HashMap();
        indentificationQualifierHashMap = new java.util.HashMap();
        typeStatusHashMap           = new java.util.HashMap();
        labelTypeHashMap            = new java.util.HashMap();
        labelTranscriptionHashMap   = new java.util.HashMap();
        localisationHashMap         = new java.util.HashMap();
        taxonomicGroupHashMap       = new java.util.HashMap();
        accessionDateCategoryHashMap= new java.util.HashMap();
        materialCategoryHashMap     = new java.util.HashMap();
        collectionHashMap           = new java.util.HashMap();
        
        try
        {
            // Instanzierung von SessionFactory, Session und Start einer Transaktion            
            net.sf.hibernate.cfg.Configuration conf;
            conf = new Configuration();            
            // Set USER and PASSWORD.
            // This settings can be overwitten by setting this properties in "hibernate.cfg.xml"
            // see: file:/home/didi/hibernate/hibernate-2.1/doc/reference/en/html/session-configuration.html
            
            logger.info( "setup hibernate properties" );
            
            conf.setProperty( "hibernate.connection.username", dbUser   );            
            logger.info( "hibernate.connection.username= " + dbUser     );
            conf.setProperty( "hibernate.connection.password", dbPwd    );
            conf.setProperty( "hibernate.connection.url",      dbUrl    );
            logger.info( "hibernate.connection.url = " + dbUrl          );
            
            // hibernate properties
            conf.setProperty( "hibernate.connection.driver_class",  "org.postgresql.Driver" );
            conf.setProperty( "hibernate.connection.pool_size",     "5" );
            conf.setProperty( "dialect",                            "net.sf.hibernate.dialect.PostgreSQLDialect" );
            conf.setProperty( "show_sql",                           "true" );
            conf.setProperty( "use_outer_join",                     "true" );
  
            // set the mapping data
            // !!! "hibernate.cfg.xml" must exist and at least have one mapping definition !!!
            // ??? Don't work ????
            conf.configure();            
            // !!! Don't show password in log-file !!!
            org.apache.log4j.Level level = logger.getEffectiveLevel();
            logger.setLevel( org.apache.log4j.Level.OFF );   
            
            sf = conf.buildSessionFactory();
            logger.setLevel( level );
                    
            // ??? sf = new Configuration().configure().buildSessionFactory();
            // load logging and config from classpath 
            //sf = new Configuration().configure().buildSessionFactory();
            session = sf.openSession();
            Transaction trx = session.beginTransaction();
            
            //----------------------
            // init Collection
            //----------------------
            java.util.List collections = session.find( "select collection from Collection as collection" );
            java.util.Iterator iter = collections.iterator();
            net.metadiversity.diversity.navigator.hibernate.ubt.collection.Collection collection;
            collectionModel.addElement( "" );
            while( iter.hasNext() )
            {
                collection = (net.metadiversity.diversity.navigator.hibernate.ubt.collection.Collection) iter.next();
                
                logger.debug( collection.getCollectionId() );
                logger.debug( collection.getCollectionName() );
                logger.debug( collection.getDescription() );
                logger.debug( collection.getRoom() );
                // setup collectionId's to selecti GUI String
                collectionIdHashmap.put( collection.getCollectionId(), collection.getCollectionName() );
                collectionHashMap.put( collection.getCollectionName(), collection );
                
                collectionModel.addElement( collection.getCollectionName() );
            }
            //------------------------------------------------------------------
            collectionSpecimenIdsList = session.find( "select collectionspecimen.collectionSpecimenId from CollectionSpecimen as collectionspecimen order by collectionspecimen.accessionNumber" );
            
            java.util.List list;
            //----------------------
            // init MaterialCategory
            //----------------------
            net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollMaterialCategoryEnum materialCategory;
            list = session.find( "select materialCategory from XcollMaterialCategoryEnum as materialCategory order by materialCategory.displayOrder" );            
            iter = list.iterator();
            materialCategoryModel.addElement( "" );
            while( iter.hasNext() )
            {
                materialCategory = ( net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollMaterialCategoryEnum ) iter.next();

                logger.debug( materialCategory.getCode() );
                logger.debug( materialCategory.getDescription() );
                
                materialCategoryModel.addElement( materialCategory.getCode() );                
                materialCategoryHashMap.put( materialCategory.getCode(), materialCategory );
            }
            //----------------------
            // init TaxonomicGroup
            //----------------------
            net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollTaxonomicGroupEnum taxonomicGroup;
            list = session.find( "select taxonomicGroup from XcollTaxonomicGroupEnum as taxonomicGroup order by taxonomicGroup.displayOrder" );            
            iter = list.iterator();
            taxonomicGroupModel.addElement( "" );
            while( iter.hasNext() )
            {
                taxonomicGroup = ( net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollTaxonomicGroupEnum ) iter.next();

                logger.debug( taxonomicGroup.getCode() );
                logger.debug( taxonomicGroup.getDescription() );
                
                taxonomicGroupModel.addElement( taxonomicGroup.getCode() );
                
                taxonomicGroupHashMap.put( taxonomicGroup.getCode(), taxonomicGroup );
            }
            //----------------------
            // init IdentificationQualifier
            //----------------------
            net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollIdentificationQualifierEnum identificationQualifier;
            list = session.find( "select identificationQualifier from XcollIdentificationQualifierEnum as identificationQualifier order by identificationQualifier.displayOrder" );            
            iter = list.iterator();
            while( iter.hasNext() )
            {
                identificationQualifier = ( net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollIdentificationQualifierEnum ) iter.next();

                logger.debug( identificationQualifier.getCode() );
                logger.debug( identificationQualifier.getDescription() );
                
                identificationQualifierModel.addElement( identificationQualifier.getCode() );
                
                indentificationQualifierHashMap.put( identificationQualifier.getCode(), identificationQualifier );
            }
            //----------------------
            // init DateCategory
            //----------------------
            net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollDateCategoryEnum dateCategory;
            list = session.find( "select dateCategory from XcollDateCategoryEnum as dateCategory order by dateCategory.displayOrder" );            
            iter = list.iterator();
            dateCategoryModel.addElement( "" );
            while( iter.hasNext() )
            {
                dateCategory = ( net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollDateCategoryEnum ) iter.next();

                logger.debug( dateCategory.getCode() );
                logger.debug( dateCategory.getDescription() );
                
                dateCategoryModel.addElement( dateCategory.getCode() );
                
                dateCategoryHashMap.put( dateCategory.getCode(), dateCategory );
            }
/* ???            
            accessionDateCategoryHashMap
 */
            //----------------------
            // init TypeStatus
            //----------------------
            net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollTypeStatusEnum typeStatus;
            list = session.find( "select typeStatus from XcollTypeStatusEnum as typeStatus order by typeStatus.displayOrder" );            
            iter = list.iterator();
            typeStatusModel.addElement( "" );
            while( iter.hasNext() )
            {
                typeStatus = ( net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollTypeStatusEnum ) iter.next();

                logger.debug( typeStatus.getCode() );
                logger.debug( typeStatus.getDescription() );
                
                typeStatusModel.addElement( typeStatus.getCode() );
                
                typeStatusHashMap.put( typeStatus.getCode(), typeStatus );
            }
            //----------------------
            // init LabelType
            //----------------------
            net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollLabelTypeEnum labelType;
            list = session.find( "select labelType from XcollLabelTypeEnum as labelType order by labelType.displayOrder" );            
            iter = list.iterator();
            labelTypeModel.addElement( "" );
            while( iter.hasNext() )
            {
                labelType = ( net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollLabelTypeEnum ) iter.next();

                logger.debug( labelType.getCode() );
                logger.debug( labelType.getDescription() );
                
                labelTypeModel.addElement( labelType.getCode() );
                
                labelTypeHashMap.put(   labelType.getCode(), labelType );
            }
            //----------------------
            // init ImageType
            //----------------------
            net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollImageTypeEnum imageType;
            list = session.find( "select imageType from XcollImageTypeEnum as imageType order by imageType.displayOrder" );            
            iter = list.iterator();
            imageTypeModel.addElement( "" );
            while( iter.hasNext() )
            {
                imageType = ( net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollImageTypeEnum ) iter.next();

                logger.debug( imageType.getCode() );
                logger.debug( imageType.getDescription() );
                
                imageTypeModel.addElement( imageType.getCode() );
            }
            //----------------------
            // init CollectionEditing
            //----------------------
            net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollCollectionEditingEnum collectionEditing;
            list = session.find( "select collectionEditing from XcollCollectionEditingEnum as collectionEditing order by collectionEditing.displayOrder" );            
            iter = list.iterator();
            collectionEditingModel.addElement( "" );
            while( iter.hasNext() )
            {
                collectionEditing = ( net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollCollectionEditingEnum ) iter.next();

                logger.debug( collectionEditing.getCode() );
                logger.debug( collectionEditing.getDescription() );
                
                collectionEditingModel.addElement( collectionEditing.getCode() );
            }
            //----------------------
            // init LabelTranscription
            //----------------------
            net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollLabelTranscriptionEnum labelTranscription;
            list = session.find( "select labelTranscription from XcollLabelTranscriptionEnum as labelTranscription order by labelTranscription.displayOrder" );            
            iter = list.iterator();
            labelTranscriptionModel.addElement( "" );                
            while( iter.hasNext() )
            {
                labelTranscription = ( net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollLabelTranscriptionEnum ) iter.next();

                logger.debug( labelTranscription.getCode() );                
                logger.debug( labelTranscription.getDescription() );
                
                labelTranscriptionModel.addElement( labelTranscription.getCode() );
                
                labelTranscriptionHashMap.put( labelTranscription.getCode(), labelTranscription );
            }            
            //----------------------
            // init IdentificationCategory
            //----------------------
            net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollIdentificationCategoryEnum identificationCategory;
            list = session.find( "select identificationCategory from XcollIdentificationCategoryEnum as identificationCategory order by identificationCategory.displayOrder" );            
            iter = list.iterator();
            identificationCategoryModel.addElement( "" );
            while( iter.hasNext() )
            {
                identificationCategory = ( net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollIdentificationCategoryEnum ) iter.next();

                logger.debug( identificationCategory.getCode() );
                logger.debug( identificationCategory.getDescription() );
                
                identificationCategoryModel.addElement( identificationCategory.getCode() );
                
                indentificationCategoryHashMap.put( identificationCategory.getCode(), identificationCategory );
            }
            //------------------------
            // init LocalisationSystem
            //------------------------            
            net.metadiversity.diversity.navigator.hibernate.ubt.collection.LocalisationSystem  localisationSystem;
            list = session.find( "select localisationSystem from LocalisationSystem as localisationSystem order by localisationSystem.localisationSystemId" );            
            iter = list.iterator();
            while( iter.hasNext() )
            {
                localisationSystem = ( net.metadiversity.diversity.navigator.hibernate.ubt.collection.LocalisationSystem ) iter.next();
                                
                logger.debug( localisationSystem.getLocalisationSystemId() );
                logger.debug( localisationSystem.getDescription() );
                // ??? set Index ???
                localisationModel.addElement( localisationSystem.getLocalisationSystemName() );
                
                localisationHashMap.put( localisationSystem.getLocalisationSystemName(), localisationSystem );
            }
            //------------------------
            // init Project
            //------------------------
            list = session.find( "select distinct collectionproject.comp_id.diversityProject from CollectionProject as collectionproject" );
            iter = list.iterator();
//            projectModel.addElement( "" );
            while( iter.hasNext() )
            {
                String project = ( String ) iter.next();
                // ??? set Index ???
                projectModel.addElement( project );
            }
            //------------------------
            // init Collection Person
            //------------------------
            list = session.find( "select distinct collectingperson.comp_id.collectorsName from CollectingPerson as collectingperson" );
            iter = list.iterator();
            personModel.addElement( "" );
            while( iter.hasNext() )
            {
                String person = ( String ) iter.next();
                // ??? set Index ???
                personModel.addElement( person );
            }
            //------------------------
            // init TaxonomicName
            //------------------------
            list = session.find( "select distinct identification.taxonomicName from Identification as identification order by identification.taxonomicName asc" );
            iter = list.iterator();
            taxonomicNameModel.addElement( "" );
            while( iter.hasNext() )
            {
                String taxonomicName = ( String ) iter.next();
                // ??? set Index ???
                taxonomicNameModel.addElement( taxonomicName );
            }            
    
            /*
            //----------------------
            // init XXX
            //----------------------
            net.metadiversity.diversity.navigator.hibernate.ubt.collection.XXX xxx;
            list = session.find( "select xxx from XXX as xxx order by xxx.displayOrder" );            
            iter = list.iterator();
            while( iter.hasNext() )
            {
                xxx = ( net.metadiversity.diversity.navigator.hibernate.ubt.collection.XXX ) iter.next();

                logger.debug( xxx.getCode() );
                logger.debug( xxx.getDescription() );
            }
            */

            CollectingPerson x = new CollectingPerson();
            // init collectionSpecimenCount
            java.util.List c = session.find( "SELECT count( * ) from CollectionSpecimen x");
            
            logger.debug( c.get( 0) );
            collectionSpecimenCount = ( (Integer) c.get( 0 ) ).intValue();
            trx.commit();
        }
        catch( HibernateException he )
        {
            he.printStackTrace();
        }
        finally
        {
        }
    }
    //--------------------------------------------------------------------------
    public void disableDatabaseUpdate()
    {
        disableDatabaseUpdate = true;
    }
    //--------------------------------------------------------------------------
    public void enableDatabaseUpdate()
    {
        disableDatabaseUpdate = false;
    }
    //--------------------------------------------------------------------------
    public void update( Object o )
    {        
        try
        {
            if( ! disableDatabaseUpdate )
            {
                Transaction trx = session.beginTransaction();
                session.update( o );
                trx.commit();
            }
            else
            {
                logger.info( "Database update diabled");
            }
        } 
        /*
        catch( java.sql.SQLException sqlEx )
        {
            sqlEx.printStackTrace();
        }
         **/
        catch( HibernateException e )
        {
            String str = e.getLocalizedMessage();
            logger.error( str );
            DnOptionPane.showMessageDialog( myParentComponent, str, "Error" , DnOptionPane.ERROR_MESSAGE );                                     
            e.printStackTrace();
        }
    }
    //--------------------------------------------------------------------------
    public boolean save( Object o )
    {        
        try
        {
            if( ! disableDatabaseUpdate )
            {
                Transaction trx = session.beginTransaction();
                session.save( o );
                session.flush();
                trx.commit();                
                return true;
            }
            else
            {
                logger.info( "Database update disabled");
            }
        } 
        /*
        catch( java.sql.SQLException sqlEx )
        {
            sqlEx.printStackTrace();
        }
         **/
        catch( HibernateException e )
        {
            String str = e.getLocalizedMessage();
            logger.error( str );
            DnOptionPane.showMessageDialog( myParentComponent, str, "Error" , DnOptionPane.ERROR_MESSAGE );                                     
            e.printStackTrace();            
        }
        return false;
    }
    //--------------------------------------------------------------------------
    protected void finalize()
    {
            try
            {
                if (session != null)
                {
                    session.close();
                    System.out.println( "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!" +
                                        "!!! COLSE HIBERNATE SESSION !!!" +
                                        "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
                                      );
                    
                }
                if (sf != null)
                {
                    sf.close();
                }
            } 
            catch (HibernateException e)
            {
                e.printStackTrace();
            }
        
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public boolean addNewCollectionSpecimen()
    {
        CollectionSpecimen ncs = new CollectionSpecimen();
        
        // Set specimen id
        int id = 0;
        for( int i = 0; i < collectionSpecimenIdsList.size(); i++ )
        {
            int val = ((Integer)collectionSpecimenIdsList.get( i )).intValue();            
            if( val > id )
            {
                id = val;
            }
        }                
        ncs.setCollectionSpecimenId( new Integer( ++id ) );
        // add id to list         
        collectionSpecimenIdsList.add(  new Integer( id ) );
        
        try
        {
            if( ! disableDatabaseUpdate )
            {
                Transaction trx = session.beginTransaction();                                            
                session.save( ncs );
                session.flush();
                trx.commit();
                // ???
                session.connection().commit();  // not necessary for JTA datasource
            }            
            return true;
        } 
        /*
         **/
        catch( java.sql.SQLException sqlEx )
        {
            sqlEx.printStackTrace();
            return false;
        }
        catch( HibernateException e )
        {
            e.printStackTrace();
            return false;
        }
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public java.lang.String getCollectionNameByIndex( java.lang.Integer index )
    {
        return ( java.lang.String ) collectionIdHashmap.get( index );
    }
    //--------------------------------------------------------------------------
    public java.lang.String getCollectionNameByIndex( int index )
    {
        return ( java.lang.String ) collectionIdHashmap.get( new java.lang.Integer( index ) );
    }
    //--------------------------------------------------------------------------
    public Integer getCollectionIdFromString( String collectionName )
    {
        Integer id = null;        
        Collection col = (Collection) collectionHashMap.get( collectionName );
        id = col.getCollectionId();
        return id;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public long getCollectionSpecimenCount()
    {
        try
        {
            Transaction trx = session.beginTransaction();
            
            // java.util.List collections = session.find( "select collection from Collection as collection" );
            // init collectionSpecimenCount
            java.util.List c = session.find( "SELECT count( * ) from CollectionSpecimen x");
            
            logger.debug( c.get( 0) );
            collectionSpecimenCount = ( (Integer) c.get( 0 ) ).intValue();
        
            trx.commit();
        }
        catch( HibernateException he )
        {
            he.printStackTrace();
        }
        return collectionSpecimenCount;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public CollectionSpecimen getCollectionSpecimen( int index )
    {
        try
        {
// ????     BUG ???? Add new "Specimen" then add person, ....
            
            session.close();
            session = sf.openSession();
            
            int intId = ((Integer) collectionSpecimenIdsList.get( index -1 )).intValue();
            String id = String.valueOf( intId );
            String queryString = "select collectionspecimen from CollectionSpecimen as collectionspecimen where collectionspecimen.collectionSpecimenId = " + id; 
            logger.debug( queryString );
/*            
// ???            Transaction trx = session.beginTransaction();
            Query query = session.createQuery( queryString );
            java.util.List l = query.list();                     
// ???            trx.commit();
 */
            
            Transaction trx = session.beginTransaction();
            java.util.List l = session.find( queryString );                     
            trx.commit();
            
            return (CollectionSpecimen) l.get( 0);            
        }
        catch( HibernateException he )
        {
            he.printStackTrace();
        }
        catch( java.lang.ClassCastException ex )
        {
            ex.printStackTrace();
        }
        return null;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public CollectionGeography getCollectionGeography( int index )
    {
        try
        {
            
            Transaction trx = session.beginTransaction();
            int intId = ((Integer) collectionSpecimenIdsList.get( index )).intValue();
            String id = String.valueOf( intId );
            String queryString = "select collectiongeography from CollectionGeography as collectiongeography WHERE \"CollectionSpecimenID\" = " + id;
            // String queryString = "select collectiongeography from CollectionGeography as collectiongeography where collectiongeography.collectionSpecimenId = " + id; 
            // String pkQueryString = "select collectiongeography.comp_id from CollectionGeography as collectiongeography where collectiongeography.collectionSpecimenId = " + id;            
            // select collectiongeography.comp_id from CollectionGeography as collectiongeography WHERE "CollectionSpecimenID"=-2147318989
            
            logger.debug( queryString );
            
            Query query = session.createQuery( queryString );
            java.util.List l = query.list();                     
            trx.commit();
            return (CollectionGeography) l.get( 0);            
        }
        catch( HibernateException he )
        {
            he.printStackTrace();
        }
        catch( java.lang.ClassCastException ex )
        {
            ex.printStackTrace();
        }
        return null;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------    
    public Integer getNextIdentificationUnitId()
    {
        String queryString = "select max( identificationunit.comp_id.identificationUnitId ) from IdentificationUnit as identificationunit";
        Integer nextIdValue = null;
        try
        {
            Transaction trx = session.beginTransaction();
            java.util.List c = session.find( queryString );
            int value = ( (Integer) c.get( 0 ) ).intValue();
            nextIdValue = new Integer( ++value );
            trx.commit();
        }
        catch( HibernateException he )
        {
            he.printStackTrace();
        }
        return nextIdValue;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------    
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------    
    private javax.swing.ComboBoxModel copyComboBoxModel( javax.swing.ComboBoxModel model )
    {
        javax.swing.DefaultComboBoxModel newModel = new javax.swing.DefaultComboBoxModel();
        
        // copy model date
        int size = model.getSize();
        
        for( int i = 0; i < size; i++ )
        {
            newModel.addElement( model.getElementAt( i ) );            
        }
        return newModel;        
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------    
    public javax.swing.ComboBoxModel getNewLocalisationModel()
    {
        return copyComboBoxModel( localisationModel );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------    
    public javax.swing.ComboBoxModel getNewCollectionModel()
    {
        return copyComboBoxModel( collectionModel );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------    
    public javax.swing.ComboBoxModel getNewMaterialCategoryModel()
    {
        return copyComboBoxModel( materialCategoryModel );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------    
    public javax.swing.ComboBoxModel getNewTaxonomicGroupModel()
    {
        return copyComboBoxModel( taxonomicGroupModel );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------    
    public javax.swing.ComboBoxModel getNewIdentificationQualifierModel()
    {
        return copyComboBoxModel( identificationQualifierModel );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------    
    public javax.swing.ComboBoxModel getNewDateCategoryModel()
    {
        return copyComboBoxModel( dateCategoryModel );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------    
    public javax.swing.ComboBoxModel getNewTypeStatusModel()
    {
        return copyComboBoxModel( typeStatusModel );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------    
    public javax.swing.ComboBoxModel getNewLabelTypeModel()
    {
        return copyComboBoxModel( labelTypeModel );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------    
    public javax.swing.ComboBoxModel getNewImageTypeModel()
    {
        return copyComboBoxModel( imageTypeModel );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------    
    public javax.swing.ComboBoxModel getNewCollectionEditingModel()
    {
        return copyComboBoxModel( collectionEditingModel );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------    
    public javax.swing.ComboBoxModel getNewLabelTranscriptionModel()
    {
        return copyComboBoxModel( labelTranscriptionModel );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------    
    public javax.swing.ComboBoxModel getNewIdentificationCategoryModel()
    {
        return copyComboBoxModel( identificationCategoryModel );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------    
    /**
     * Getter for property projectModel.
     * @return Value of property projectModel.
     */
    public javax.swing.ComboBoxModel getNewProjectModel()
    {
        return copyComboBoxModel( projectModel );
    }
   
    /**
     * Getter for property personModel.
     * @return Value of property personModel.
     */
    public javax.swing.ComboBoxModel getNewPersonModel()
    {
        return copyComboBoxModel( personModel );
    }
    
    /**
     * Getter for property taxonomicNameModel.
     * @return Value of property taxonomicNameModel.
     */
    public javax.swing.ComboBoxModel getNewTaxonomicNameModel()
    {
        return copyComboBoxModel( taxonomicNameModel );
    }   
           
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) 
    {
        // javax.swing.JFrame frame = new javax.swing.JFrame();

        try
        {
            net.metadiversity.diversity.navigator.connection.ConnectionInfo ci;
        
            ci = new ConnectionInfo( "name", "Description", "org.postgresql.Driver", "jdbc:postgresql://hongkong.didi.dn:5432/DiversityCollection_BIOTAlichencoll", "didi", "" );
        
            CollectionBayreuthHibernate cbh = new CollectionBayreuthHibernate( ci, null );        
        
            // Select Collection
            net.metadiversity.diversity.navigator.gui.collection.SelectCollectionDialog dialog = new net.metadiversity.diversity.navigator.gui.collection.SelectCollectionDialog( null, true, cbh.sf );
            dialog.setVisible( true );
            
            
            /*
            frame.getContentPane().add( cbh );
            frame.setSize( 640, 480 );
            frame.pack();
            frame.show();
             */
        }
        catch ( java.lang.Exception ex )
        {
            ex.printStackTrace();
        }    
    }     
}    
