/*
 * UbtCollectionTabs.java
 *
 * Created on 14. Januar 2003, 17:46
 */

package net.metadiversity.diversity.navigator.db.ub;

import net.metadiversity.diversity.navigator.hibernate.ubt.collection.*;

// Tabs
import net.metadiversity.diversity.navigator.gui.CollectionTabIndentification;
import net.metadiversity.diversity.navigator.gui.CollectionTabGeographicData;
import net.metadiversity.diversity.navigator.gui.CollectionTabMiscellaneous;
import net.metadiversity.diversity.navigator.gui.CollectionTabCollectorTimeLocation;
import net.metadiversity.diversity.navigator.gui.CollectionTabImages;
import  net.metadiversity.diversity.navigator.db.ub.UbtCollectionHeader;

import net.metadiversity.diversity.navigator.db.ub.DnDataRecordSelector;

import javax.swing.JOptionPane;

import org.apache.log4j.Logger;

/**
 * This class ist used to display and work with the tab-sheets for the collection (UBT-Version 98 Luciana)
 * There are 5 Tab Sheets for the formular data.
 * The TabSheets use the "com.jgoodies.forms.layout" 
 *
 * This panel ist the upper part of the "UbtCollectionMainFrame"
 *
 * @author  didi
 */
public class UbtCollectionTabs_096 extends javax.swing.JPanel implements java.awt.event.ActionListener
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3688782574843802419L;

    static Logger logger = Logger.getLogger( UbtCollectionTabs_096.class.getName() );
    
    net.metadiversity.diversity.navigator.db.CollectionBayreuthHibernate                hibernateCollection;

    //----------
    // hibernate 
    //----------
    net.metadiversity.diversity.navigator.hibernate.ubt.collection.Collection           collection; 
    net.metadiversity.diversity.navigator.hibernate.ubt.collection.CollectionSpecimen   specimen;
    net.metadiversity.diversity.navigator.hibernate.ubt.collection.CollectionGeography  geography;
    net.metadiversity.diversity.navigator.hibernate.ubt.collection.CollectingPerson     person;
    net.metadiversity.diversity.navigator.hibernate.ubt.collection.Identification       identification;
    net.metadiversity.diversity.navigator.hibernate.ubt.collection.IdentificationUnit   identificationUnit;
    net.metadiversity.diversity.navigator.hibernate.ubt.collection.CollectionProject    project;
    net.metadiversity.diversity.navigator.hibernate.ubt.collection.CollectionStorage    storage;
    net.metadiversity.diversity.navigator.hibernate.ubt.collection.CollectionDuplicate  duplicate;
    net.metadiversity.diversity.navigator.hibernate.ubt.collection.CollectionImage      image;
    //
    int collectionSetSize; 
    int specimenSetSize;
    int geographySetSize;
    int personSetSize;
    int identificationSetSize;
    int identificationUnitSetSize;
    int projectSetSize;
    int storageSetSize;
    int duplicateSetSize;
    int imageSetSize;

    net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollDateCategoryEnum            categoryEnum;
    net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollIdentificationCategoryEnum  identificationCategoryEnum;
    net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollIdentificationQualifierEnum identificationQualifierEnum;
    net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollLabelTypeEnum               labelTypeEnum;
    net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollLabelTranscriptionEnum      labelTranscriptionEnum;
    net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollTaxonomicGroupEnum          taxonomicGroupEnum;
    net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollTypeStatusEnum              typeStatusEnum;
    //-----------
    // GUI tabs
    //-----------
    CollectionTabCollectorTimeLocation  p1;
    CollectionTabGeographicData         p2;
    CollectionTabIndentification        p3;   
    CollectionTabMiscellaneous          p4;
    CollectionTabImages                 p5;
    //
    // Record selections
    //
    static String recordAction =            "Record Action";
    static String projectRecordAction =     "Project Record Action";
    static String personRecordAction  =     "Person Record Action";
    static String geographyRecordAction  =  "Geography Record Action";
    static String identificationUnitAction  = "IdentificationUnit Record Action";
    static String identificationAction  =   "Identification Record Action";
    static String storageAction  =          "Storage Record Action";
    static String duplicateAction  =        "Duplicate Record Action";
    static String imageAction  =            "Image Record Action";

    int actualSpecimenIndex;
    
    java.util.Set       personSet;    
    java.util.Set       projectSet;
    java.util.Set       geographySet;
    java.util.Set       identificationUnitSet;
    java.util.Set       identificationSet;
    java.util.Set       storageSet;
    java.util.Set       duplicateSet;    
    java.util.Set       imageSet;    

    DnDataRecordSelector records;
    // GUI TOP Position of form
    net.metadiversity.diversity.navigator.db.ub.UbtCollectionHeader collectionHeader;
    boolean             DEBUG_GUI_ACTION    = true;
    
    javax.swing.JComponent myParentComponent;
    
    /** Creates new form UbtCollectionTabs */
    public UbtCollectionTabs_096( DnDataRecordSelector records, net.metadiversity.diversity.navigator.db.CollectionBayreuthHibernate collection, UbtCollectionHeader collectionHeader ) 
    {        
        this.records = records;
        this.collectionHeader = collectionHeader;
        
        myParentComponent = this;
        
        hibernateCollection = collection;
        try
        {
            long count = hibernateCollection.getCollectionSpecimenCount();
            logger.debug( "Collection Specimen entries : " +  count );
            records.setRecordMaxValue( count );
        }
        catch ( java.lang.Exception ex )
        {
            ex.printStackTrace();
        }            
        
        initComponents();
        
        p1 = new CollectionTabCollectorTimeLocation();
        javax.swing.JPanel jPanelCollectorTimeLocation = p1.getPanel();
        javax.swing.JScrollPane         s1 = new javax.swing.JScrollPane( jPanelCollectorTimeLocation );
        
        p2 = new CollectionTabGeographicData();
        javax.swing.JPanel jPanelGeographicData = p2.getPanel();
        javax.swing.JScrollPane         s2 = new javax.swing.JScrollPane( jPanelGeographicData );
        //
        p3 = new CollectionTabIndentification();
        javax.swing.JPanel jPanelIdentification = p3.getPanel();
        javax.swing.JScrollPane         s3 = new javax.swing.JScrollPane( jPanelIdentification );
        //
        p4 = new CollectionTabMiscellaneous();
        javax.swing.JPanel jPanelMiscellaneousData = p4.getPanel();
        javax.swing.JScrollPane         s4 = new javax.swing.JScrollPane( jPanelMiscellaneousData );
        //
        p5 = new CollectionTabImages();
        javax.swing.JPanel jPanelImages = p5.getPanel();
        javax.swing.JScrollPane         s5 = new javax.swing.JScrollPane( jPanelImages );
        
        //
        jTabbedPaneCollectionTabs.removeAll();
        
        jTabbedPaneCollectionTabs.addTab( "Collector, time and location", s1 );
        jTabbedPaneCollectionTabs.addTab( "Geograpic data", s2 );
        jTabbedPaneCollectionTabs.addTab( "Identification", s3 );
        jTabbedPaneCollectionTabs.addTab( "Miscellaneous",  s4 );
        jTabbedPaneCollectionTabs.addTab( "Images",         s5 );

        //-----------------
        // Record selection
        //-----------------
        GuiAction a;
        a = new GuiAction( recordAction );        
        records.addDnGuiListener( a );
        
        a = new GuiAction( personRecordAction );        
        p1.personRecords.addDnGuiListener( a );
        
        a = new GuiAction( projectRecordAction );        
        p1.projectRecords.addDnGuiListener( a );

        a = new GuiAction( geographyRecordAction );
        p2.localityRecords.addDnGuiListener( a );
        
        a = new GuiAction( identificationUnitAction );
        p3.identificationUnitRecords.addDnGuiListener( a );
        
        a = new GuiAction( identificationAction );
        p3.identificationRecords.addDnGuiListener( a );
        
        a = new GuiAction( storageAction );
        p4.storageRecords.addDnGuiListener( a );
        
        a = new GuiAction( duplicateAction );
        p4.duplicateRecords.addDnGuiListener( a );
        
        a = new GuiAction( imageAction );
        p5.imageRecords.addDnGuiListener( a );
        
        //----------------------------------------------------------------------
        // add action lisenters: UPDATE DATA
        //----------------------------------
        // TAB: Collector, time and location
        //----------------------------------------------------------------------

        p1.getJComboBoxPersonOrGroups().setBackground( java.awt.Color.RED );
        p1.getJComboBoxPersonOrGroups().setEnabled( false );
        /*
        p1.getJComboBoxPersonOrGroups().addActionListener( new java.awt.event.ActionListener() 
        { 
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( specimen != null )
                {   
                    if( person != null )
                    {
                        String s = (String) p1.getJComboBoxPersonOrGroups().getSelectedItem();                
                        if( s.compareTo( person.getComp_id().getCollectorsName() ) != 0 )
                        {
        // ???                    
                            CollectingPersonPK cppk = (CollectingPersonPK) person.getComp_id();
                            cppk.setCollectorsName( s );
                            person.setComp_id( cppk );
                            hibernateCollection.update( person );
                            hibernateCollection.update( specimen );
                        }
        // ???                specimen.getCollectingPersons().
                    }
                }
            } 
        } );
        */
        p1.getJTextFieldCollectionNumber().addFocusListener( new java.awt.event.FocusAdapter()
        { 
            public void focusLost(java.awt.event.FocusEvent evt)
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( person != null )
                {
                    String s = p1.getJTextFieldCollectionNumber().getText();
                    person.setCollectorsNumber( s );                
                    hibernateCollection.update( person );
                }
            } 
        } );
        
        p1.getJComboBoxProject().setBackground( java.awt.Color.RED );
        p1.getJComboBoxProject().setEnabled( false );
        /*
        p1.getJComboBoxProject().addActionListener( new java.awt.event.ActionListener() 
        { 
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( specimen != null && project != null )
                {
                    String s = (String) p1.getJComboBoxProject().getSelectedItem();
// ???                    if( s != null && s.compareTo( project.getComp_id().getDiversityProject() ) != 0 )
                    {
                        project.getComp_id().setDiversityProject( s );
                        hibernateCollection.update( project );
                        hibernateCollection.update( specimen );
                    }
                }
            } 
        } );
        */
        //----------------
        // Collection Date
        //----------------
        p1.getJTextFieldDateDD().addFocusListener( new java.awt.event.FocusAdapter()
        { 
            public void focusLost(java.awt.event.FocusEvent evt)
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( specimen != null )
                {
                    Short s = new Short( p1.getJTextFieldDateDD().getText() );
                    specimen.setCollectionDay( s );                
                    hibernateCollection.update( specimen );
                }
            } 
        } );
        p1.getJTextFieldDateMM().addFocusListener( new java.awt.event.FocusAdapter()
        { 
            public void focusLost(java.awt.event.FocusEvent evt)
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( specimen != null )
                {
                    Short s = new Short( p1.getJTextFieldDateMM().getText() );
                    specimen.setCollectionMonth( s );                
                    hibernateCollection.update( specimen );
                }
            } 
        } );
        p1.getJTextFieldDateYYYY().addFocusListener( new java.awt.event.FocusAdapter()
        { 
            public void focusLost(java.awt.event.FocusEvent evt)
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( specimen != null )
                {
                    Short s = new Short( p1.getJTextFieldDateYYYY().getText() );
                    specimen.setCollectionYear( s );                
                    hibernateCollection.update( specimen );
                }
            } 
        } );
        p1.getJTextFieldDateSuppl().addFocusListener( new java.awt.event.FocusAdapter()
        { 
            public void focusLost(java.awt.event.FocusEvent evt)
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( specimen != null )
                {
                    String s = p1.getJTextFieldDateSuppl().getText();
                    specimen.setCollectionDateSupplement( s );                
                    hibernateCollection.update( specimen );
                }
            } 
        } );        
        p1.getJComboBoxDateCategory().addActionListener( new java.awt.event.ActionListener() 
        { 
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( specimen != null )
                {
                    String s = (String) p1.getJComboBoxDateCategory().getSelectedItem();                
                    specimen.setXcollDateCategoryEnumByCollectionDateCategory( (XcollDateCategoryEnum) hibernateCollection.dateCategoryHashMap.get( s ) );                
                    hibernateCollection.update( specimen );
                }
            } 
        } );        
        p1.getJTextLocalityHabitat().addFocusListener( new java.awt.event.FocusAdapter()
        {
            public void focusLost(java.awt.event.FocusEvent evt)
            {
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( specimen != null )
                {
                    String s = p1.getJTextLocalityHabitat().getText();
                    specimen.setLocalityDescription( s );                
                    hibernateCollection.update( specimen );
                }
            } 
        } );        
        p1.getJTextOriginalNotes().addFocusListener( new java.awt.event.FocusAdapter()
        {
            public void focusLost(java.awt.event.FocusEvent evt)
            {
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( specimen != null )
                {
                    String s = p1.getJTextOriginalNotes().getText();
                    specimen.setOriginalNotes( s );                
                    hibernateCollection.update( specimen );
                }
            } 
        } );        
        p1.getJTextAdditionalNotes().addFocusListener( new java.awt.event.FocusAdapter()
        {
            public void focusLost(java.awt.event.FocusEvent evt)
            {
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( specimen != null )
                {
                    String s = p1.getJTextAdditionalNotes().getText();
                    specimen.setAdditionalNotes( s );                
                    hibernateCollection.update( specimen );
                }
            } 
        } );        
        //-------
        p1.getJCheckBoxPrintLabel().addActionListener( new java.awt.event.ActionListener() 
        { 
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( specimen != null )
                {
                    Boolean b = new Boolean( p1.getJCheckBoxPrintLabel().isSelected() );
                    specimen.setPrintLabel( b );
                    hibernateCollection.update( specimen );
                }
            } 
        } );        
        p1.getJTextFieldLabelTitle().addFocusListener( new java.awt.event.FocusAdapter()
        {
            public void focusLost(java.awt.event.FocusEvent evt)
            {
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( specimen != null )
                {
                    String s = p1.getJTextFieldLabelTitle().getText();
                    specimen.setLabelTitle( s );                
                    hibernateCollection.update( specimen );
                }
            } 
        } );        
        
        p1.getJComboBoxLabelType().addActionListener( new java.awt.event.ActionListener() 
        { 
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( specimen != null )
                {                
                    String s = (String) p1.getJComboBoxLabelType().getSelectedItem();                
                    specimen.setXcollLabelTypeEnum( (XcollLabelTypeEnum) hibernateCollection.labelTypeHashMap.get( s ) );                
                    hibernateCollection.update( specimen );
                }
            } 
        } );
        p1.getJComboBoxLableTranscription().addActionListener( new java.awt.event.ActionListener() 
        { 
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( specimen != null )
                {
                    String s = (String) p1.getJComboBoxLableTranscription().getSelectedItem();                
                    specimen.setXcollLabelTranscriptionEnum( (XcollLabelTranscriptionEnum) hibernateCollection.labelTranscriptionHashMap.get( s ) );
                    hibernateCollection.update( specimen );
                }
            } 
        } );
        //------
        p1.getJTextLabelNotes().addFocusListener( new java.awt.event.FocusAdapter()
        {
            public void focusLost(java.awt.event.FocusEvent evt)
            {
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( specimen != null )
                {                
                    String s = p1.getJTextLabelNotes().getText();
                    specimen.setLabelTranscriptionNotes( s );                
                    hibernateCollection.update( specimen );
                }
            } 
        } );        
        p1.getJTextProblems().addFocusListener( new java.awt.event.FocusAdapter()
        {
            public void focusLost(java.awt.event.FocusEvent evt)
            {
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( specimen != null )
                {
                    String s = p1.getJTextProblems().getText();
                    specimen.setProblems( s );                
                    hibernateCollection.update( specimen );
                }
            } 
        } );        
        //----------------------------------------------------------------------
        // Geographic data
        //----------------------------------------------------------------------
        p2.getJTextPaneLocalityHabitat().addFocusListener( new java.awt.event.FocusAdapter()
        {
            public void focusLost(java.awt.event.FocusEvent evt)
            {
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( specimen != null )
                {
                    String s = p2.getJTextPaneLocalityHabitat().getText();
                    specimen.setLocalityDescription( s );                
                    hibernateCollection.update( specimen );
                }
            } 
        } );        
        p2.getJTextPaneLocalityProblems().addFocusListener( new java.awt.event.FocusAdapter()
        {
            public void focusLost(java.awt.event.FocusEvent evt)
            {
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( specimen != null )
                {
                    String s = p2.getJTextPaneLocalityProblems().getText();
                    specimen.setProblems( s );                
                    hibernateCollection.update( specimen );
                }
            } 
        } );        
        //
        p2.getJTextFieldLatitude().addFocusListener( new java.awt.event.FocusAdapter()
        {
            public void focusLost(java.awt.event.FocusEvent evt)
            {
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( geography != null )
                {
                    String s = p2.getJTextFieldLatitude().getText();
                    geography.setLocation2( s );                
                    hibernateCollection.update( geography );
                }
            } 
        } );        
        
        p2.getJTextFieldLongitude().addFocusListener( new java.awt.event.FocusAdapter()
        {
            public void focusLost(java.awt.event.FocusEvent evt)
            {
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( geography != null )
                {
                    String s = p2.getJTextFieldLongitude().getText();
                    geography.setLocation1( s );                
                    hibernateCollection.update( geography );
                }
            } 
        } );        
        
        p2.getJComboBoxLocationSystem().setBackground( java.awt.Color.RED );
        p2.getJComboBoxLocationSystem().setEnabled( false );
        /*
        p2.getJComboBoxLocationSystem().addActionListener( new java.awt.event.ActionListener() 
        { 
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( geography != null )
                {
                    String s = (String) p2.getJComboBoxLocationSystem().getSelectedItem();
// ???                    if( s != null && s.compareTo( ((LocalisationSystem) geography.getLocalisationSystem()).getLocalisationSystemName() ) != 0 )
                    {
                        geography.setLocalisationSystem( (LocalisationSystem) hibernateCollection.localisationHashMap.get( s ) );                
                        hibernateCollection.update( geography );
                    }
                }
            } 
        } );    
        */
        p2.getJComboBoxResponsible().addActionListener( new java.awt.event.ActionListener() 
        { 
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( geography != null )
                {
                    String s = (String) p2.getJComboBoxResponsible().getSelectedItem();

// ???                    if( s != null && s.compareTo( geography.getResponsible() ) != 0 )
                    {
                        geography.setResponsible( s );
                        hibernateCollection.update( geography );
                    }
                }
            } 
        } );
        p2.getJTextFieldDate().addFocusListener( new java.awt.event.FocusAdapter()
        { 
            public void focusLost(java.awt.event.FocusEvent evt)
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( geography != null )
                {
                    String s = p2.getJTextFieldDate().getText();
                    try
                    {
                        java.util.Date d = java.text.DateFormat.getDateInstance().parse( s );
                        geography.setDeterminationDate( d );                
                        hibernateCollection.update( geography );
                    }
                    catch( java.text.ParseException ex )
                    {
                        // ???
                        logger.error( "Invalid date format: " + s );
                    }
                }
            } 
        } );
        //-------------------------------
        //----------------------------------------------------------------------
        // Identification
        //----------------------------------------------------------------------
        
        p3.getJComboBoxTaxonomicGroup().setBackground( java.awt.Color.RED );
        p3.getJComboBoxTaxonomicGroup().setEnabled( false );
        /*
        p3.getJComboBoxTaxonomicGroup().addActionListener( new java.awt.event.ActionListener() 
        { 
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( identificationUnit != null )
                {
                    String s = (String) p3.getJComboBoxTaxonomicGroup().getSelectedItem();
                    identificationUnit.setXcollTaxonomicGroupEnum( (XcollTaxonomicGroupEnum) hibernateCollection.taxonomicGroupHashMap.get( s ) );
                    hibernateCollection.update( identificationUnit );
                }
            } 
        } );        
        */
        p3.getJTextFieldTypifiedTaxonAndState().addFocusListener( new java.awt.event.FocusAdapter() 
        { 
            public void focusLost(java.awt.event.FocusEvent evt)
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( identificationUnit != null )
                {
                    String s = p3.getJTextFieldTypifiedTaxonAndState().getText();
                    identificationUnit.setTypifiedTaxon( s );                
                    hibernateCollection.update( identificationUnit );
                }
            } 
        } );
        
        p3.getJComboBoxTypifiedTaxonAndState().addActionListener( new java.awt.event.ActionListener() 
        { 
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( identificationUnit != null )
                {
                    String s = (String) p3.getJComboBoxTypifiedTaxonAndState().getSelectedItem();
                    identificationUnit.setXcollTypeStatusEnum( ( XcollTypeStatusEnum ) hibernateCollection.typeStatusHashMap.get( s ) );
                    hibernateCollection.update( identificationUnit );
                }
            } 
        } );                
        //----------------------        
        // Identification
        //----------------------
        p3.getJComboBoxTaxonomicName().setBackground( java.awt.Color.RED );
        p3.getJComboBoxTaxonomicName().setEnabled( false );
        /*
        p3.getJComboBoxTaxonomicName().addActionListener( new java.awt.event.ActionListener() 
        { 
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( identification != null )
                {
                    String s = (String) p3.getJComboBoxTaxonomicName().getSelectedItem();
                    identification.setTaxonomicName( s );
                    hibernateCollection.update( identification );
                }
            } 
        } );
        */
        p3.getJTextFieldVernacularName().addFocusListener( new java.awt.event.FocusAdapter()
        { 
            public void focusLost(java.awt.event.FocusEvent evt)
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( identification != null )
                {
                    String s = p3.getJTextFieldVernacularName().getText();
                    identification.setVernacularName( s );
                    hibernateCollection.update( identification );
                }
            } 
        } );
        
        p3.getJTextFieldDateDD().addFocusListener( new java.awt.event.FocusAdapter()
        { 
            public void focusLost(java.awt.event.FocusEvent evt)
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( identification != null )
                {
                    Short s = new Short( p3.getJTextFieldDateDD().getText() );
                    identification.setIdentificationDay( s ); 
                    hibernateCollection.update( identification );
                }
            } 
        } );
        
        p3.getJTextFieldDateMM().addFocusListener( new java.awt.event.FocusAdapter()
        { 
            public void focusLost(java.awt.event.FocusEvent evt)
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( identification != null )
                {
                    Short s = new Short( p3.getJTextFieldDateMM().getText() );
                    identification.setIdentificationMonth( s );
                    hibernateCollection.update( identification );
                }
            } 
        } );
        
        p3.getJTextFieldDateYYYY().addFocusListener( new java.awt.event.FocusAdapter()
        { 
            public void focusLost(java.awt.event.FocusEvent evt)
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( identification != null )
                {
                    Short s = new Short( p3.getJTextFieldDateYYYY().getText() );
                    identification.setIdentificationYear( s ); 
                    hibernateCollection.update( identification );
                }
            } 
        } );
        
        p3.getJTextFieldDateSupl().addFocusListener( new java.awt.event.FocusAdapter()
        { 
            public void focusLost(java.awt.event.FocusEvent evt)
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( identification != null )
                {
                    String s = p3.getJTextFieldDateSupl().getText();
                    identification.setIdentificationDateSupplement( s );
                    hibernateCollection.update( identification );
                }
            } 
        } );
        
        p3.getJComboBoxDateCategory().addActionListener( new java.awt.event.ActionListener() 
        { 
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( identification != null )
                {
                    String s = (String) p3.getJComboBoxDateCategory().getSelectedItem();
                    identification.setXcollDateCategoryEnum( ( XcollDateCategoryEnum ) hibernateCollection.dateCategoryHashMap.get( s ) );
                    hibernateCollection.update( identification );
                }
            } 
        } );        
        
        p3.getJComboBoxCategory().addActionListener( new java.awt.event.ActionListener() 
        { 
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( identification != null )
                {
                    String s = (String) p3.getJComboBoxCategory().getSelectedItem();
                    identification.setXcollIdentificationCategoryEnum( ( XcollIdentificationCategoryEnum ) hibernateCollection.indentificationCategoryHashMap.get( s ) );
                    hibernateCollection.update( identification );
                }
            } 
        } );
        
        p3.getJComboBoxQualifier().addActionListener( new java.awt.event.ActionListener() 
        { 
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( identification != null )
                {
                    String s = (String) p3.getJComboBoxQualifier().getSelectedItem();
                    identification.setXcollIdentificationQualifierEnum( ( XcollIdentificationQualifierEnum ) hibernateCollection.indentificationQualifierHashMap.get( s ) );
                    hibernateCollection.update( identification );
                }
            } 
        } );
        
        p3.getJTextFieldLiteratureUsed().addFocusListener( new java.awt.event.FocusAdapter() 
        { 
            public void focusLost(java.awt.event.FocusEvent evt)
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( identification != null )
                {
                    String s = p3.getJTextFieldLiteratureUsed().getText();
                    identification.setLiteratureUsed( s );
                    hibernateCollection.update( identification );
                }
            } 
        } );
        
        p3.getJComboBoxResponsible().addActionListener( new java.awt.event.ActionListener() 
        { 
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( identification != null )
                {
                    String s = (String) p3.getJComboBoxResponsible().getSelectedItem();
// ???                    if( s != null && s.compareTo( identification.getResponsibleName() ) != 0 )
                    {
                        identification.setResponsibleName( s );
                        hibernateCollection.update( identification );
                    }
                }
            } 
        } );
        
        p3.getJCheckBoxExsiccatum().addActionListener( new java.awt.event.ActionListener() 
        { 
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( identification != null )
                {
                    Boolean b = new Boolean( p3.getJCheckBoxExsiccatum().isSelected() );
                    identification.setIsexsiccataTaxon( b );
                    hibernateCollection.update( identification );
                }
            } 
        } );        
        
        p3.getJTextFieldNotes().addFocusListener( new java.awt.event.FocusAdapter()
        { 
            public void focusLost(java.awt.event.FocusEvent evt)
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( identification != null )
                {
                    String s = p3.getJTextFieldNotes().getText();
                    identification.setNotes( s );
                    hibernateCollection.update( identification );
                }
            } 
        } );
        
        //---------------------
        // IdentificationUnit
        //---------------------
        
        p3.getJTextFieldColonizedPart().addFocusListener( new java.awt.event.FocusAdapter()
        { 
            public void focusLost(java.awt.event.FocusEvent evt)
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( identificationUnit != null )
                {
                    String s = p3.getJTextFieldColonizedPart().getText();
                    identificationUnit.setColonisedPart( s );                
                    hibernateCollection.update( identificationUnit );
                }
            } 
        } );
        // ???
        // ??? p3.getJComboBoxGrowingLivingOn()
        // ???
        p3.getJTextFieldLifeState().addFocusListener( new java.awt.event.FocusAdapter()
        { 
            public void focusLost(java.awt.event.FocusEvent evt)
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( identificationUnit != null )
                {
                    String s = p3.getJTextFieldLifeState().getText();
                    identificationUnit.setLifeStage( s );                
                    hibernateCollection.update( identificationUnit );
                }
            } 
        } );
        
        p3.getJCheckBoxOnlyObserved().addActionListener( new java.awt.event.ActionListener() 
        { 
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( identificationUnit != null )
                {
                    Boolean b = new Boolean( p3.getJCheckBoxOnlyObserved().isSelected() );
                    identificationUnit.setOnlyObserved( b.booleanValue() );
                    hibernateCollection.update( identificationUnit );
                }
            } 
        } );        
        
        p3.getJTextFieldNotes2().addFocusListener( new java.awt.event.FocusAdapter() 
        { 
            public void focusLost(java.awt.event.FocusEvent evt)
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( identificationUnit != null )
                {
                    String s = p3.getJTextFieldNotes2().getText();
                    identificationUnit.setNotes( s );                
                    hibernateCollection.update( identificationUnit );
                }
            } 
        } );
        
        //----------------------------------------------------------------------
        // Miscellaneous
        //----------------------------------------------------------------------        
        // Collection
        //----------------------------------------------------------------------        
        
        p4.getJComboBoxCollection().setBackground( java.awt.Color.RED );
        p4.getJComboBoxCollection().setEnabled( false );
/* ????        
        p4.getJComboBoxCollection().addActionListener( new java.awt.event.ActionListener() 
        { 
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                String s = (String) p4.getJComboBoxCollection().getSelectedItem();
                ??? storage.getComp_id()..setXcollMaterialCategoryEnum( (XcollMaterialCategoryEnum) hibernateCollection.materialCategoryHashMap.get( s ) );
                hibernateCollection.update( identification );
            } 
        } );
*/        
        p4.getJTextFieldStorageLocationE_G().addFocusListener( new java.awt.event.FocusAdapter()
        { 
            public void focusLost(java.awt.event.FocusEvent evt)
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( storage != null )
                {
                    String s = p4.getJTextFieldStorageLocationE_G().getText();
                    storage.setStorageLocation( s );                
                    hibernateCollection.update( storage );
                }
            } 
        } );
        // is part of primary key
        p4.getJComboBoxMaterialCategory().setBackground( java.awt.Color.RED );
        p4.getJComboBoxMaterialCategory().setEnabled( false );
        /*
        p4.getJComboBoxMaterialCategory().addActionListener( new java.awt.event.ActionListener() 
        { 
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( storage != null )
                {
                    String s = (String) p4.getJComboBoxMaterialCategory().getSelectedItem();
                    storage.setXcollMaterialCategoryEnum( (XcollMaterialCategoryEnum) hibernateCollection.materialCategoryHashMap.get( s ) );
                    hibernateCollection.update( storage );
                }
            } 
        } );
         */
        //-------------
        // Duplicates
        //-------------
        p4.getJComboBoxDuplicatesCollection().setBackground( java.awt.Color.RED );
        p4.getJComboBoxDuplicatesCollection().setEnabled( false );
        /*
        p4.getJComboBoxDuplicatesCollection().addActionListener( new java.awt.event.ActionListener() 
        { 
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( storage != null )
                {
                    String s = (String) p4.getJComboBoxDuplicatesCollection().getSelectedItem();
// ???                    duplicate.setCollection( ??? );
// ???                    hibernateCollection.update( duplicate );
                }
            } 
        } );
        */
        p4.getJTextFieldAccessionNumber().setBackground( java.awt.Color.RED );
        p4.getJTextFieldAccessionNumber().setEnabled( false );
        /*
        p4.getJTextFieldAccessionNumber().addFocusListener( new java.awt.event.FocusAdapter()
        { 
            public void focusLost(java.awt.event.FocusEvent evt)
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( duplicate != null )
                {
                    String s = p4.getJTextFieldAccessionNumber().getText();
                    duplicate.getComp_id().setAccessionNumber( s );                
                    hibernateCollection.update( duplicate );
                }
            } 
        } );
         */
        p4.getJTextFieldDuplicatesNotes().addFocusListener( new java.awt.event.FocusAdapter()
        { 
            public void focusLost(java.awt.event.FocusEvent evt)
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( duplicate != null )
                {
                    String s = p4.getJTextFieldDuplicatesNotes().getText();
                    duplicate.setNotes( s );                
                    hibernateCollection.update( duplicate );
                }
            } 
        } );

        // Exsic
        p4.getJTextFieldExsicAbbrev().addFocusListener( new java.awt.event.FocusAdapter()
        { 
            public void focusLost(java.awt.event.FocusEvent evt)
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( specimen != null )
                {
                    String s = p4.getJTextFieldExsicAbbrev().getText();
                    specimen.setExsiccataAbbreviation( s );                
                    hibernateCollection.update( specimen );
                }
            } 
        } );        
        p4.getJTextFieldExsicNr().addFocusListener( new java.awt.event.FocusAdapter()
        { 
            public void focusLost(java.awt.event.FocusEvent evt)
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( specimen != null )
                {
                    String s = p4.getJTextFieldExsicNr().getText();
                    specimen.setExsiccataNumber( s );                
                    hibernateCollection.update( specimen );
                }
            } 
        } );
        
        p4.getJCheckBoxIsExsccate().setBackground( java.awt.Color.RED );
        p4.getJCheckBoxIsExsccate().setEnabled( false );
/* ??? Database Field ???       
        p4.getJCheckBoxIsExsccate().addActionListener( new java.awt.event.ActionListener() 
        { 
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                Boolean b = new Boolean( p4.getJCheckBoxIsExsccate().isSelected() );
                specimen.set 
                identification.setIsexsiccataTaxon( b );
                hibernateCollection.update( identification );
            } 
        } );        
*/        
        // Accession
        p4.getJTextFieldAccessionNr().addFocusListener( new java.awt.event.FocusAdapter()
        { 
            public void focusLost(java.awt.event.FocusEvent evt)
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( specimen != null )
                {
                    String s = p4.getJTextFieldAccessionNr().getText();
                    specimen.setAccessionNumber( s );                
                    hibernateCollection.update( specimen );
                    // Update GUI Header
                    updateGuiHeader();
                }
            } 
        } );
        p4.getJTextFieldDateDD().addFocusListener( new java.awt.event.FocusAdapter()
        { 
            public void focusLost(java.awt.event.FocusEvent evt)
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( specimen != null )
                {
                    Short s = new Short( p4.getJTextFieldDateDD().getText() );
                    specimen.setAccessionDay( s );                
                    hibernateCollection.update( specimen );
                }
            } 
        } );
        p4.getJTextFieldDateMM().addFocusListener( new java.awt.event.FocusAdapter()
        { 
            public void focusLost(java.awt.event.FocusEvent evt)
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( specimen != null )
                {
                    Short s = new Short( p4.getJTextFieldDateMM().getText() );
                    specimen.setAccessionMonth( s );                
                    hibernateCollection.update( specimen );
                }
            } 
        } );
        p4.getJTextFieldDateYYYY().addFocusListener( new java.awt.event.FocusAdapter()
        { 
            public void focusLost(java.awt.event.FocusEvent evt)
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( specimen != null )
                {
                    Short s = new Short( p4.getJTextFieldDateYYYY().getText() );
                    specimen.setAccessionYear( s );                
                    hibernateCollection.update( specimen );
                }
            } 
        } );
        p4.getJTextFieldDateSup().addFocusListener( new java.awt.event.FocusAdapter()
        { 
            public void focusLost(java.awt.event.FocusEvent evt)
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( specimen != null )
                {
                    String s = p4.getJTextFieldDateSup().getText();
                    specimen.setAccessionDateSupplement( s );                
                    hibernateCollection.update( specimen );
                }
            } 
        } );
        p4.getJComboBoxDateCategory().addActionListener( new java.awt.event.ActionListener() 
        { 
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( specimen != null )
                {
                    String s = (String) p4.getJComboBoxDateCategory().getSelectedItem();
                    specimen.setXcollDateCategoryEnumByAccessionDateCategory( (XcollDateCategoryEnum) hibernateCollection.dateCategoryHashMap.get( s ) );
                    hibernateCollection.update( specimen );
                }
            } 
        } );
        p4.getJComboBoxDepositorName().addActionListener( new java.awt.event.ActionListener() 
        { 
            public void actionPerformed(java.awt.event.ActionEvent evt) 
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( specimen != null )
                {
                    String s = (String) p4.getJComboBoxDepositorName().getSelectedItem();
                    specimen.setDepositorsName( s );                
                    hibernateCollection.update( specimen );
                }
            } 
        } );
        
        p4.getJTextFieldDepositorNr().addFocusListener( new java.awt.event.FocusAdapter()
        { 
            public void focusLost(java.awt.event.FocusEvent evt)
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( specimen != null )
                {
                    String s = p4.getJTextFieldDepositorNr().getText();
                    specimen.setDepositorsAccessionNumber( s );                
                    hibernateCollection.update( specimen );
                }
            } 
        } );
        
        // Borrrow & loan        
        p4.getJTextPaneBorrowLoan().addFocusListener( new java.awt.event.FocusAdapter()
        {
            public void focusLost(java.awt.event.FocusEvent evt)
            {
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( specimen != null )
                {
                    String s = p4.getJTextPaneBorrowLoan().getText();
                    specimen.setLoanInformation( s );                
                    hibernateCollection.update( specimen );
                }
            } 
        } );
        // Image        
        p5.getJTextFieldPath().addFocusListener( new java.awt.event.FocusAdapter()
        { 
            public void focusLost(java.awt.event.FocusEvent evt)
            { 
                if( DEBUG_GUI_ACTION ) logger.info( evt.toString() );
                if( image != null )
                {
                    String s = p5.getJTextFieldPath().getText();
// ??? part of primary key                    
                    image.getComp_id().setImagePath( s );                
                    hibernateCollection.update( image );
                }
            } 
        } );
        
        // Start index is 1 (first record)
        update( 1 );
        
    }
    //--------------------------------------------------------------------------
    // Update GUI Data for    
    //--------------------------------------------------------------------------
    public void update( int index )
    {
        try
        {
            if( hibernateCollection != null )
            {                
                actualSpecimenIndex = index;
                specimen    = hibernateCollection.getCollectionSpecimen( index );

                hibernateCollection.disableDatabaseUpdate();
                //----------------
                // collection
                //----------------
                
                //----------------
                // Project
                //----------------
                projectSet = specimen.getCollectionProjects();
                if( projectSet == null )
                {
                    projectSetSize = 0;
                    project = null;
                }
                else
                {
                    projectSetSize = projectSet.size();
                    java.util.Iterator iterProject = projectSet.iterator();
                    if( iterProject.hasNext() )
                    {
                        project = ( CollectionProject ) iterProject.next();
                    }
                    else
                    {                
                        project = null;
                    }
                }                    
                logger.info( "Project Set Size: " + projectSetSize );
                //----------------
                // Person Groups
                //----------------
                personSet = specimen.getCollectingPersons();
                if( personSet == null )
                {
                    personSetSize = 0;
                    person = null;
                }
                else
                {
                    java.util.Iterator iterPerson = personSet.iterator();
                    personSetSize = personSet.size();
                    if( iterPerson.hasNext() )
                    {   
                        person = ( CollectingPerson ) iterPerson.next();
                    }
                    else
                    {                
                        person = null;
                    }
                }
                logger.info( "Person Set Size: " + personSetSize );
                //------------
                // geography
                //------------                
                geographySet = specimen.getCollectionGeographies();
                if( geographySet == null )
                {
                    geographySetSize = 0;
                    geography = null;
                }
                else
                {
                    java.util.Iterator iterGeo = geographySet.iterator();
                    geographySetSize = geographySet.size();
                    if( iterGeo.hasNext() )
                    {
                        geography = ( CollectionGeography ) iterGeo.next();
                    }
                    else
                    {                
                        geography = null;
                    }
                }
                logger.info( "Geography Set Size: " + geographySetSize );
                //---------------------
                // Identification Units
                //---------------------
                identificationUnitSet = specimen.getIdentificationUnits();
                if( identificationUnitSet == null )
                {
                    identificationUnitSetSize = 0;
                    identificationUnit = null;
                }
                else
                {
                    java.util.Iterator iterUnit = identificationUnitSet.iterator();
                    identificationUnitSetSize = identificationUnitSet.size();
                    if( iterUnit.hasNext() )
                    {
                        identificationUnit = ( IdentificationUnit ) iterUnit.next();
                    }
                    else
                    {
                        identificationUnit = null;
                    }            
                }
                logger.info( "Identification Units Set Size: " + identificationUnitSetSize );
                //---------------------
                // Identification 
                //---------------------
                if( identificationUnit != null )
                {
                    java.util.Set identificationSet = identificationUnit.getIdentifications();
                    if( identificationSet != null )
                    {
                        java.util.Iterator iterIdentification = identificationSet.iterator();
                        identificationSetSize = identificationSet.size();
                        logger.info( "Identification Set Size: " + identificationSetSize );
                        if( iterIdentification.hasNext() )
                        {
                            identification = ( Identification ) iterIdentification.next();
                        }
                        else
                        {
                            identification = null;
                        }                                            
                    }
                    else
                    {
                        identification = null;
                    }                                            
                }
                else
                {
                    identification = null;
                    identificationSetSize = 0;
                }
                //---------------------
                // Storage
                //---------------------
                storageSet = specimen.getCollectionStorages();                
                if( storageSet == null )
                {
                    storageSetSize = 0;
                    storage = null;
                }
                else
                {                    
                    java.util.Iterator iterStorage = storageSet.iterator();
                    storageSetSize = storageSet.size();
                    if( iterStorage.hasNext() )
                    {
                        storage = ( CollectionStorage ) iterStorage.next();
                    }
                    else
                    {
                        storage = null;
                    }
                }
                logger.info( "Storage Set Size: " + storageSetSize );
                //----------------------
                // CollectionDuplicate
                //----------------------
                duplicateSet = specimen.getCollectionDuplicates();                
                if( duplicateSet == null )
                {
                    duplicateSetSize = 0;
                    duplicate = null;
                }
                else
                {
                    java.util.Iterator iterDuplicate = duplicateSet.iterator();
                    duplicateSetSize = duplicateSet.size();
                    if( iterDuplicate.hasNext() )
                    {
                        duplicate = ( CollectionDuplicate ) iterDuplicate.next();
                    }
                    else
                    {
                        duplicate = null;
                    }
                }
                
                logger.info( "Duplicate Set Size: " + duplicateSetSize );
                
                //------------------------
                // images
                //------------------------

                imageSet = specimen.getCollectionImages();                
                if( imageSet == null )
                {
                    imageSetSize = 0;
                    image = null;
                }
                else
                {
                    java.util.Iterator iterImage = imageSet.iterator();
                    imageSetSize = imageSet.size();
                    if( iterImage.hasNext() )
                    {
                        image = ( CollectionImage ) iterImage.next();
                    }
                    else
                    {
                        image = null;
                    }
                }
                
                logger.info( "Image Set Size: " + imageSetSize );
                
                
                //-----------------------------------------
                // Setup selection models 
                //-----------------------------------------
                p1.getJComboBoxDateCategory().setModel( hibernateCollection.getNewDateCategoryModel() );
                p3.getJComboBoxDateCategory().setModel( hibernateCollection.getNewDateCategoryModel() );
                p4.getJComboBoxDateCategory().setModel( hibernateCollection.getNewDateCategoryModel() );
                
                p1.getJComboBoxLabelType().setModel(     hibernateCollection.getNewLabelTypeModel()    );
                p1.getJComboBoxLableTranscription().setModel(     hibernateCollection.getNewLabelTranscriptionModel() );
                
                p1.getJComboBoxPersonOrGroups().setModel( hibernateCollection.getNewPersonModel() );
                p1.getJComboBoxProject().setModel( hibernateCollection.getNewProjectModel() );
                
                p2.getJComboBoxLocationSystem().setModel( hibernateCollection.getNewLocalisationModel() );
                p2.getJComboBoxResponsible().setModel( hibernateCollection.getNewPersonModel() );
                
                p3.getJComboBoxCategory().setModel(     hibernateCollection.getNewIdentificationCategoryModel()    );
                p3.getJComboBoxQualifier().setModel(    hibernateCollection.getNewIdentificationQualifierModel()   );
                // ??? p3.getJComboBoxGrowingLivingOn()
                p3.getJComboBoxResponsible().setModel( hibernateCollection.getNewPersonModel() );
                p3.getJComboBoxTaxonomicGroup().setModel(    hibernateCollection.getNewTaxonomicGroupModel()       );
                p3.getJComboBoxTaxonomicName().setModel(    hibernateCollection.getNewTaxonomicNameModel()         );
                p3.getJComboBoxTypifiedTaxonAndState().setModel(    hibernateCollection.getNewTypeStatusModel()    );
                                
                p4.getJComboBoxCollection().setModel( hibernateCollection.getNewCollectionModel()  );
                // ??? p4.getJComboBoxDepositorName()
                p4.getJComboBoxDepositorName().setBackground( java.awt.Color.RED );
                p4.getJComboBoxDuplicatesCollection().setModel( hibernateCollection.getNewCollectionModel()  );
                p4.getJComboBoxMaterialCategory().setModel( hibernateCollection.getNewMaterialCategoryModel() );
                                
                
                //-----------------------------------------
                // Setup Record selectors
                //-----------------------------------------
                p1.personRecords.setRecordMaxValue( personSetSize );
                p1.projectRecords.setRecordMaxValue( projectSetSize );
                //
                p2.localityRecords.setRecordMaxValue( geographySetSize );
                //
                p3.identificationRecords.setRecordMaxValue( identificationSetSize );
                p3.identificationUnitRecords.setRecordMaxValue( identificationUnitSetSize );
                //
                p4.duplicateRecords.setRecordMaxValue( duplicateSetSize );
                p4.storageRecords.setRecordMaxValue( storageSetSize );
                //
                p5.imageRecords.setRecordMaxValue( imageSetSize );
                
                //-------------------------
                // update record selectors
                //-------------------------                
                
                p1.personRecords.setSelectedIndex( ( person == null ) ? 0 : 1 );
                p1.projectRecords.setSelectedIndex( ( project == null ) ? 0 : 1 );
                p2.localityRecords.setSelectedIndex( ( geography == null ) ? 0 : 1 );
                p3.identificationUnitRecords.setSelectedIndex( ( identificationUnit == null ) ? 0 : 1 );
                p3.identificationRecords.setSelectedIndex( (identification == null ) ? 0 : 1 );
                p4.storageRecords.setSelectedIndex( ( storage == null ) ? 0 : 1 );
                p4.duplicateRecords.setSelectedIndex( ( duplicate == null ) ? 0 : 1 );
                p5.imageRecords.setSelectedIndex( ( image == null ) ? 0 : 1 );
                
                //------------------------------------------
                //------------------------------------------
                // This always update visible GUI date
                updatePersonData();
                updateProjectData();
                updateSpecimenData();
                updateGeographyData();
                updateIdentificationUnitData();
                updateIdentificationData();
                updateDuplicateData();
                updateStorageData();
                updateImageData();
                hibernateCollection.enableDatabaseUpdate();
            }
        }    
        catch ( java.lang.Exception ex )
        {
            ex.printStackTrace();
        }            
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void updateSpecimenData()
    {
        hibernateCollection.disableDatabaseUpdate();
        if( specimen == null )
        {
            logger.info( "No specimen data found" );
            clearSpecimenData();
            return;
        }
        //-----------------------------------------
        // Tab-Sheet (1) Collector, time and location                
        //-----------------------------------------
        setFieldData( p1.getJTextFieldDateDD(),              specimen.getCollectionDay()    );
        setFieldData( p1.getJTextFieldDateMM(),              specimen.getCollectionMonth()  );
        setFieldData( p1.getJTextFieldDateYYYY(),            specimen.getCollectionYear()   );
        setFieldData( p1.getJTextFieldDateSuppl(),           specimen.getCollectionDateSupplement() );
        //
        categoryEnum = (XcollDateCategoryEnum) specimen.getXcollDateCategoryEnumByCollectionDateCategory();
        setComboBoxSelection( p1.getJComboBoxDateCategory(), (categoryEnum != null) ? categoryEnum.getCode() : null );
        //
        setFieldData( p1.getJTextFieldLabelTitle(),          specimen.getLabelTitle()       );
        //
        labelTranscriptionEnum = (XcollLabelTranscriptionEnum) specimen.getXcollLabelTranscriptionEnum();
        setComboBoxSelection( p1.getJComboBoxLableTranscription(), (labelTranscriptionEnum != null) ? labelTranscriptionEnum.getCode() : null );
        //
        labelTypeEnum = (XcollLabelTypeEnum) specimen.getXcollLabelTypeEnum();
        setComboBoxSelection( p1.getJComboBoxLabelType(), (labelTypeEnum != null) ? labelTypeEnum.getCode() : null );
        //
        setFieldData( p1.getJCheckBoxPrintLabel(),          specimen.getPrintLabel()       );
        setFieldData( p1.getJTextLabelNotes(),              specimen.getLabelTranscriptionNotes() );
        //
        setFieldData( p1.getJTextLocalityHabitat(),         specimen.getLocalityDescription()  );
        setFieldData( p1.getJTextOriginalNotes(),           specimen.getOriginalNotes()    );
        setFieldData( p1.getJTextAdditionalNotes(),         specimen.getAdditionalNotes()  );
        setFieldData( p1.getJTextProblems(),                specimen.getProblems()         );
//                setFieldData( p1 );
        //-----------------------------------------
        // Tab-Sheet (2) GeographicData
        //-----------------------------------------                
        setFieldData( p2.getJTextPaneLocalityHabitat(),     specimen.getLocalityDescription() );
        // Problems
        setFieldData( p2.getJTextPaneLocalityProblems(),    specimen.getProblems() );                               
        //-----------------------------------------
        // Tab-Sheet (4)  Miscellaneous
        //-----------------------------------------
// ???                
        // Exsiccata
        setFieldData( p4.getJTextFieldExsicAbbrev(),        specimen.getExsiccataAbbreviation() );
        setFieldData( p4.getJTextFieldExsicNr(),            specimen.getExsiccataNumber()       );
//???                setFieldData( p4.getJCheckBoxIsExsccate(),          specimen.get );        
        // Accession
        setFieldData( p4.getJTextFieldAccessionNr(),        specimen.getAccessionNumber()   );
        setFieldData( p4.getJTextFieldDateDD(),             specimen.getAccessionDay()      );
        setFieldData( p4.getJTextFieldDateMM(),             specimen.getAccessionMonth()    );
        setFieldData( p4.getJTextFieldDateYYYY(),           specimen.getAccessionYear()     );
        setFieldData( p4.getJTextFieldDateSup(),            specimen.getAccessionDateSupplement() );
        XcollDateCategoryEnum accessionDateCategoryEnum;         
        accessionDateCategoryEnum = specimen.getXcollDateCategoryEnumByAccessionDateCategory();
        setComboBoxSelection( p4.getJComboBoxDateCategory(), ( accessionDateCategoryEnum != null ) ? accessionDateCategoryEnum.getCode() : null );
        // descriptor
        setComboBoxSelection( p4.getJComboBoxDepositorName(), specimen.getDepositorsName()  );        
        setFieldData( p4.getJTextFieldDepositorNr(),        specimen.getDepositorsAccessionNumber() );
        // Borrow and loan
        setFieldData( p4.getJTextPaneBorrowLoan(),          specimen.getLoanInformation() );                
        
        //------------------------------------------
        // Form header
        //------------------------------------------
        updateGuiHeader();
        
        hibernateCollection.enableDatabaseUpdate();
}
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void updateGuiHeader()
    {
        //------------------------------------------
        // Form header
        //------------------------------------------
        
        collectionHeader.setAcccessionNumber( specimen.getAccessionNumber() );
        collectionHeader.setCollectionName( "Herbarium Luciana Zedda" );        
    }
    private void clearSpecimenData()
    {
        hibernateCollection.disableDatabaseUpdate();
        //-----------------------------------------
        // Tab-Sheet (1) Collector, time and location                
        //-----------------------------------------
        setFieldData( p1.getJTextFieldDateDD(),              ""  );
        setFieldData( p1.getJTextFieldDateMM(),              ""  );
        setFieldData( p1.getJTextFieldDateYYYY(),            ""  );
        setFieldData( p1.getJTextFieldDateSuppl(),           ""  );
        setComboBoxSelection( p1.getJComboBoxDateCategory(), ""  );
        setFieldData( p1.getJTextFieldLabelTitle(),          ""  );
        setComboBoxSelection( p1.getJComboBoxLableTranscription(), "" );
        //
        setComboBoxSelection( p1.getJComboBoxLabelType(),   "" );
        //
        setFieldData( p1.getJCheckBoxPrintLabel(),          null );
        setFieldData( p1.getJTextLabelNotes(),              "" );
        //
        setFieldData( p1.getJTextLocalityHabitat(),         "" );
        setFieldData( p1.getJTextOriginalNotes(),           "" );
        setFieldData( p1.getJTextAdditionalNotes(),         "" );
        setFieldData( p1.getJTextProblems(),                "" );
        //-----------------------------------------
        // Tab-Sheet (2) GeographicData
        //-----------------------------------------                
        setFieldData( p2.getJTextPaneLocalityHabitat(),     "" );
        // Problems
        setFieldData( p2.getJTextPaneLocalityProblems(),    "" );                               
        //-----------------------------------------
        // Tab-Sheet (4)  Miscellaneous
        //-----------------------------------------
// ???                
        // Exsiccata
        setFieldData( p4.getJTextFieldExsicAbbrev(),        "" );
        setFieldData( p4.getJTextFieldExsicNr(),            ""  );
//???                setFieldData( p4.getJCheckBoxIsExsccate(),          specimen.get );
        p4.getJCheckBoxIsExsccate().setBackground( java.awt.Color.RED );
        // Accession
        setFieldData( p4.getJTextFieldAccessionNr(),        "" );
        setFieldData( p4.getJTextFieldDateDD(),             "" );
        setFieldData( p4.getJTextFieldDateMM(),             "" );
        setFieldData( p4.getJTextFieldDateYYYY(),           "" );
        setFieldData( p4.getJTextFieldDateSup(),            "" );
        // descriptor
        setComboBoxSelection( p4.getJComboBoxDepositorName(), "" );        
        setFieldData( p4.getJTextFieldDepositorNr(),        "" );
        // Borrow and loan
        setFieldData( p4.getJTextPaneBorrowLoan(),          "" );                
        
        hibernateCollection.enableDatabaseUpdate();
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void updateDuplicateData()
    {
        hibernateCollection.disableDatabaseUpdate();
        if( duplicate == null )
        {
            logger.info( "No duplicate data found" );
            clearDuplicateData();
            return;
        }
        //--------------------------------------------------------------
        // Duplicates
        String collectionName = "";
        try
        {
            collectionName = duplicate.getCollection().getCollectionName();
            setComboBoxSelection( p4.getJComboBoxDuplicatesCollection(), collectionName );
        }
        catch( java.lang.NullPointerException ex )
        {
            logger.info( "Duplicate not found");
        }
        setFieldData( p4.getJTextFieldAccessionNumber(),    duplicate.getComp_id().getAccessionNumber() );
        setFieldData( p4.getJTextFieldDuplicatesNotes(),    duplicate.getNotes() );
        
        hibernateCollection.enableDatabaseUpdate();
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void clearDuplicateData()
    {
        hibernateCollection.disableDatabaseUpdate();
        
        setComboBoxSelection( p4.getJComboBoxDuplicatesCollection(),    "" );
// ???                setFieldData( p4.getJTextFieldAccessionNumber(),    duplicate.getComp_id().getAccessionNumber() );
        p4.getJTextFieldAccessionNumber().setBackground( java.awt.Color.red );
        setFieldData( p4.getJTextFieldDuplicatesNotes(),                "" );
        
        hibernateCollection.enableDatabaseUpdate();
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void updateStorageData()
    {
        hibernateCollection.disableDatabaseUpdate();
        if( storage == null )
        {
            logger.info( "No storage data found" );
            clearStorageData();
            return;
        }
        //-----------------------------------------
        // Tab-Sheet (4)  Miscellaneous
        //-----------------------------------------
        // Storage
        String collectionName = hibernateCollection.getCollectionNameByIndex( storage.getComp_id().getCollectionId() );
        setComboBoxSelection( p4.getJComboBoxCollection(),  collectionName ); 
        setFieldData( p4.getJTextFieldStorageLocationE_G(), storage.getStorageLocation() );
        setComboBoxSelection( p4.getJComboBoxMaterialCategory(), storage.getComp_id().getMaterialCategory() );    
        
        hibernateCollection.enableDatabaseUpdate();
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void clearStorageData()
    {
        hibernateCollection.disableDatabaseUpdate();
        //-----------------------------------------
        // Tab-Sheet (4)  Miscellaneous
        //-----------------------------------------
        // Storage
        setComboBoxSelection( p4.getJComboBoxCollection(),      "" ); 
        setFieldData( p4.getJTextFieldStorageLocationE_G(),     "" );
        setComboBoxSelection( p4.getJComboBoxMaterialCategory(),"" );    
        
        hibernateCollection.enableDatabaseUpdate();
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void updateIdentificationData()
    {
        hibernateCollection.disableDatabaseUpdate();
        
        if( identification == null )
        {
            logger.info( "No identification data found" );
            clearIdentificationData();
            return;
        }
        //-----------------------------------------
        // Tab-Sheet (3) Indentification
        //-----------------------------------------
        setComboBoxSelection( p3.getJComboBoxTaxonomicName(),   identification.getTaxonomicName()       );
        //
        setFieldData( p3.getJTextFieldVernacularName(),         identification.getVernacularName()      );
        //
        setFieldData( p3.getJTextFieldDateDD(),                 identification.getIdentificationDay()   );
        setFieldData( p3.getJTextFieldDateMM(),                 identification.getIdentificationMonth() );
        setFieldData( p3.getJTextFieldDateYYYY(),               identification.getIdentificationYear()  );  
        setFieldData( p3.getJTextFieldDateSupl(),               identification.getIdentificationDateSupplement() );
        //--------------------------------------------------------------
        categoryEnum = (XcollDateCategoryEnum) identification.getXcollDateCategoryEnum();
        setComboBoxSelection( p3.getJComboBoxDateCategory(), (categoryEnum != null) ? categoryEnum.getCode() : null );
        //--------------------------------------------------------------
        identificationCategoryEnum = (XcollIdentificationCategoryEnum) identification.getXcollIdentificationCategoryEnum();
        setComboBoxSelection( p3.getJComboBoxCategory(), (identificationCategoryEnum != null) ? identificationCategoryEnum.getCode() : null );
        //--------------------------------------------------------------
        identificationQualifierEnum = (XcollIdentificationQualifierEnum) identification.getXcollIdentificationQualifierEnum();
        setComboBoxSelection( p3.getJComboBoxQualifier(), (identificationQualifierEnum != null) ? identificationQualifierEnum.getCode() : null );
        //
        setFieldData( p3.getJTextFieldLiteratureUsed(), identification.getLiteratureUsed() );
        //
        setComboBoxSelection( p3.getJComboBoxResponsible(), identification.getResponsibleName() );
        // Exsiccatum
        setFieldData( p3.getJCheckBoxExsiccatum(),          identification.getIsexsiccataTaxon() );
        // Notes
        setFieldData( p3.getJTextFieldNotes(),              identification.getNotes()           );    

        hibernateCollection.enableDatabaseUpdate();
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void clearIdentificationData()
    {
        hibernateCollection.disableDatabaseUpdate();
        
        //-----------------------------------------
        // Tab-Sheet (3) Indentification
        //-----------------------------------------
        setComboBoxSelection( p3.getJComboBoxTaxonomicName(),   "" );
        //
        setFieldData( p3.getJTextFieldVernacularName(),         "" );
        //
        setFieldData( p3.getJTextFieldDateDD(),                 "" );
        setFieldData( p3.getJTextFieldDateMM(),                 "" );
        setFieldData( p3.getJTextFieldDateYYYY(),               "" );  
        setFieldData( p3.getJTextFieldDateSupl(),               "" );
        //--------------------------------------------------------------
        setComboBoxSelection( p3.getJComboBoxDateCategory(),    "" );
        //--------------------------------------------------------------
        setComboBoxSelection( p3.getJComboBoxCategory(),        "" );
        //--------------------------------------------------------------
        setComboBoxSelection( p3.getJComboBoxQualifier(),       "" );
        //
        setFieldData( p3.getJTextFieldLiteratureUsed(),         "" );
        //
        setComboBoxSelection( p3.getJComboBoxResponsible(),     "" );
        // Exsiccatum
        setFieldData( p3.getJCheckBoxExsiccatum(),              null );
        // Notes
        setFieldData( p3.getJTextFieldNotes(),                  "" );    
        
        hibernateCollection.enableDatabaseUpdate();
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void updateIdentificationUnitData()
    {
        hibernateCollection.disableDatabaseUpdate();
        
        if( identificationUnit == null )
        {
            logger.info( "No identificationUnit data found" );
            clearIdentificationUnitData();
            return;
        }
        // Taxonomic group
        taxonomicGroupEnum = identificationUnit.getXcollTaxonomicGroupEnum();
        setComboBoxSelection( p3.getJComboBoxTaxonomicGroup(), (taxonomicGroupEnum != null) ? taxonomicGroupEnum.getCode() : null   );
        //
        setFieldData( p3.getJTextFieldTypifiedTaxonAndState(),  identificationUnit.getTypifiedTaxon()   );
        // ??? 
        typeStatusEnum = identificationUnit.getXcollTypeStatusEnum();
        setComboBoxSelection( p3.getJComboBoxTypifiedTaxonAndState(), ( typeStatusEnum != null ) ? typeStatusEnum.getCode() : null  );
        //
        setFieldData( p3.getJTextFieldColonizedPart(),      identificationUnit.getColonisedPart() );
        // ???
        // setComboBoxSelection( p3.getJComboBoxGrowingLivingOn(), identificationUnit.getColonisedPart() );
        p3.getJComboBoxGrowingLivingOn().setBackground( java.awt.Color.RED );
        setFieldData( p3.getJTextFieldLifeState(),          identificationUnit.getLifeStage() );        
        setFieldData( p3.getJCheckBoxOnlyObserved(),        new java.lang.Boolean( identificationUnit.isOnlyObserved() ) );
        setFieldData( p3.getJTextFieldNotes2(),             identificationUnit.getNotes() );
        
        hibernateCollection.enableDatabaseUpdate();
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void clearIdentificationUnitData()
    {
        hibernateCollection.disableDatabaseUpdate();
        // Taxonomic group
        setComboBoxSelection( p3.getJComboBoxTaxonomicGroup(),  "" );
        //
        setFieldData( p3.getJTextFieldTypifiedTaxonAndState(),  "" );
        // 
        setComboBoxSelection( p3.getJComboBoxTypifiedTaxonAndState(),   "" );
        //
        setFieldData( p3.getJTextFieldColonizedPart(),          "" );
        // ???
        p3.getJComboBoxGrowingLivingOn().setBackground( java.awt.Color.RED );
        setComboBoxSelection( p3.getJComboBoxGrowingLivingOn(), "" );
        setFieldData( p3.getJTextFieldLifeState(),              "" );                
        setFieldData( p3.getJCheckBoxOnlyObserved(),            null );
        setFieldData( p3.getJTextFieldNotes2(),                 "" );
        
        hibernateCollection.enableDatabaseUpdate();
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void updateGeographyData()
    {
        hibernateCollection.disableDatabaseUpdate();
        
        if( geography == null )
        {
            logger.info( "No geography data found" );
            clearGeographyData();
            return;
        }
        //------------------------------------------
        setFieldData( p2.getJTextFieldDate(),               geography.getDeterminationDate()  );
        //------------------------------------------                
        setFieldData( p2.getJTextFieldLatitude(),           geography.getLocation2() );
        //------------------------------------------                                
        setFieldData( p2.getJTextFieldLongitude(),          geography.getLocation1() );
        // LocalisatinSystem
        // System.out.println( ((LocalisationSystem) geography.getLocalisationSystem()).getLocalisationSystemName() );
        setComboBoxSelection( p2.getJComboBoxLocationSystem(), ((LocalisationSystem) geography.getLocalisationSystem()).getLocalisationSystemName() );
        //
        setComboBoxSelection( p2.getJComboBoxResponsible(), geography.getResponsible() );
        
        hibernateCollection.enableDatabaseUpdate();
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void clearGeographyData()
    {
        hibernateCollection.disableDatabaseUpdate();
        
        //------------------------------------------
        setFieldData( p2.getJTextFieldDate(),               "" );
        //------------------------------------------                
        setFieldData( p2.getJTextFieldLatitude(),           "" );
        //------------------------------------------                                
        setFieldData( p2.getJTextFieldLongitude(),          "" );
        // LocalisatinSystem
        setComboBoxSelection( p2.getJComboBoxLocationSystem(), "" );
        //
        setComboBoxSelection( p2.getJComboBoxResponsible(), "" );
        
        hibernateCollection.enableDatabaseUpdate();
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void updatePersonData()
    {
        hibernateCollection.disableDatabaseUpdate();
        
        if( person == null )
        {
            logger.info( "No person data found" );
            clearPersonData();
            return;
        }
        //-----------------------------------------
        // Tab-Sheet (1) Collector, time and location                
        //-----------------------------------------
        setComboBoxSelection( p1.getJComboBoxPersonOrGroups(), person.getComp_id().getCollectorsName() );
        //
        setFieldData( p1.getJTextFieldCollectionNumber(),    person.getCollectorsNumber()   );
        
        hibernateCollection.enableDatabaseUpdate();
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void clearPersonData()
    {
        hibernateCollection.disableDatabaseUpdate();
        //-----------------------------------------
        // Tab-Sheet (1) Collector, time and location                
        //-----------------------------------------
        setComboBoxSelection( p1.getJComboBoxPersonOrGroups(),  "" );
        //
        setFieldData( p1.getJTextFieldCollectionNumber(),       ""   );
        
        hibernateCollection.enableDatabaseUpdate();
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void updateProjectData()
    {
        hibernateCollection.disableDatabaseUpdate();
        
        if( project == null )
        {
            logger.info( "No project data found" );
            clearProjectData();
            return;
        }
        //-----------------------------------------
        // Tab-Sheet (1) Collector, time and location                
        //-----------------------------------------
        // ??? Project
        // ??? String projectSelection = project.
        setComboBoxSelection( p1.getJComboBoxProject(),      project.getComp_id().getDiversityProject() );                    
        
        hibernateCollection.enableDatabaseUpdate();
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void clearProjectData()
    {
        hibernateCollection.disableDatabaseUpdate();
        //-----------------------------------------
        // Tab-Sheet (1) Collector, time and location                
        //-----------------------------------------
        setComboBoxSelection( p1.getJComboBoxProject(),      "" );                    

        hibernateCollection.enableDatabaseUpdate();       
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void updateImageData()
    {
        hibernateCollection.disableDatabaseUpdate();
        
        if( image == null )
        {
            logger.info( "No image data found" );
            clearImageData();
            return;
        }
        setFieldData( p5.getJTextFieldFolder(), ""   );
        setFieldData( p5.getJTextFieldPath(),   image.getComp_id().getImagePath()   );
        
        hibernateCollection.enableDatabaseUpdate();
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void clearImageData()
    {
        hibernateCollection.disableDatabaseUpdate();
        setFieldData( p5.getJTextFieldFolder(), ""   );
        setFieldData( p5.getJTextFieldPath(),   ""   );

        hibernateCollection.enableDatabaseUpdate();       
    }
    //--------------------------------------------------------------------------
    private void setComboBoxSelection( javax.swing.JComboBox cb, java.lang.String selection )
    {
        if( selection == null )
        {
            cb.setSelectedItem( "" );
        }
        else
        {
            cb.setSelectedItem( selection );            
        }
    }
    //--------------------------------------------------------------------------
    private void setFieldData( javax.swing.JCheckBox field, java.lang.Boolean b )
    {
        if( b == null )
        {
            // ??? field.setText( "" );
        }
        else
        {
            field.setSelected( b.booleanValue() );
        }
    }
    //--------------------------------------------------------------------------
    private void setFieldData( javax.swing.JTextField field, java.util.Date date )
    {
        if( date == null )
        {
            field.setText( "" );
        }
        else
        {
            java.lang.String str = date.toString();
            if( str == null )
            {
                field.setText( "" );
            }
            else
            {
                field.setText( str );
            }
        }
        field.select( 0, 0 );        
    }
    //--------------------------------------------------------------------------
    private void setFieldData( javax.swing.JTextField field, java.lang.String str )
    {
        if( str == null )
        {
            field.setText( "" );
        }
        else
        {
            field.setText( str );
        }
        field.select( 0, 0 );        
    }
    //--------------------------------------------------------------------------
    private void setFieldData( javax.swing.JTextPane field, java.lang.String str )
    {
        if( str == null )
        {
            field.setText( "" );
        }
        else
        {
            field.setText( str );
        }
        field.select( 0, 0 );        
    }
    //--------------------------------------------------------------------------
    private void setFieldData( javax.swing.JTextArea field, java.lang.String str )
    {
        if( str == null )
        {
            field.setText( "" );
        }
        else
        {
            field.setText( str );
        }
        field.select( 0, 0 );        
    }
    //--------------------------------------------------------------------------
    private void setFieldData( javax.swing.JTextField field, Integer val )
    {
        if( val == null )
        {
            field.setText( "" );
        }
        else
        {
            field.setText( val.toString() );
        }
        field.select( 0, 0 );        
    }
    //--------------------------------------------------------------------------
    private void setFieldData( javax.swing.JTextField field, Short val )
    {
        if( val == null )
        {
            field.setText( "" );
        }
        else
        {
            field.setText( val.toString() );
        }
        field.select( 0, 0 );        
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
     public void actionPerformed(java.awt.event.ActionEvent evt)
     {
           logger.info( evt );
     }
            
    

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents()//GEN-BEGIN:initComponents
    {
        javax.swing.ButtonGroup buttonGroupType;

        buttonGroupType = new javax.swing.ButtonGroup();
        jTabbedPaneCollectionTabs = new javax.swing.JTabbedPane();

        setLayout(new java.awt.BorderLayout());

        setPreferredSize(new java.awt.Dimension(640, 234));
        jTabbedPaneCollectionTabs.setMinimumSize(new java.awt.Dimension(640, 189));
        add(jTabbedPaneCollectionTabs, java.awt.BorderLayout.CENTER);

    }//GEN-END:initComponents

    public void stateChanged(javax.swing.event.ChangeEvent evt )
    {
           logger.info( evt );
    }    
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTabbedPane jTabbedPaneCollectionTabs;
    // End of variables declaration//GEN-END:variables
    
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private class GuiAction extends javax.swing.AbstractAction
    {        
        /**
         * Comment for <code>serialVersionUID</code>
         */
        private static final long serialVersionUID = 3833748767756595512L;
        
        public GuiAction( String text )
        {
            super( text );
        }        
        public void actionPerformed(java.awt.event.ActionEvent e)
        {
            String name = (String) this.getValue( "Name" );
            
            logger.info( "GuiAction: " + name + " [" + e.getActionCommand() + "]" );
            
            int index = getRecordIndex( e.getActionCommand() );                           
            
            if( name.compareTo( recordAction ) == 0 )
            {              
                if( index < 0 )
                {
                    // add new entry
                    logger.info( "Create new specimen entry" );
                    if( hibernateCollection.addNewCollectionSpecimen() == true )
                    {
                        // update Record Selector
                        long count = hibernateCollection.getCollectionSpecimenCount();
                        records.setRecordMaxValue( count );
                        update( (int) count );
                    }
                }
                else
                {
                    update( index );
                }
            }            
            else if( name.compareTo( personRecordAction ) == 0 )
            {
                if( index < 0 )
                {
                    // add new entry
                    logger.info( "Create new person entry" );
                    
                    javax.swing.JPanel selectionPanel = new javax.swing.JPanel();                    
                    selectionPanel.setLayout( new java.awt.GridLayout( 2, 1 ) );
                    
                    selectionPanel.add( new javax.swing.JLabel( "Collecting person or groups" ) );
                    javax.swing.JComboBox selection = new javax.swing.JComboBox();
                    selection.setModel( hibernateCollection.getNewPersonModel() );
                    selection.setEditable( true );
                    selectionPanel.add( selection );
                    
                    int test = javax.swing.JOptionPane.showConfirmDialog( myParentComponent, selectionPanel, "Pleace select or input:", JOptionPane.OK_CANCEL_OPTION, JOptionPane.INFORMATION_MESSAGE );
                    
                    if( test == JOptionPane.OK_OPTION )
                    {
                        CollectingPersonPK pk = new CollectingPersonPK();                        
                        pk.setCollectorsName( selection.getSelectedItem().toString() );
                        pk.setCollectionSpecimenId( specimen.getCollectionSpecimenId() );
                        person = new CollectingPerson( pk );
                        person.setCollectionSpecimen( specimen );
                        if( hibernateCollection.save( person ) == true )
                        {
                            // update Data and GUI
                            /*
                            java.util.Set s = specimen.getCollectingPersons();
                            if( s == null )
                            {
                                // add a new Set for this data
                                s = new net.sf.hibernate.collection.Set();
                                // s = (java.util.Set) new java.util.TreeSet();
                                specimen.setCollectingPersons( s );
                            }
                             */
                            // ??? hibernateCollection.update( specimen );
//                            specimen = hibernateCollection.getCollectionSpecimen( actualSpecimenIndex );
                            
                            specimen.getCollectingPersons().add( person );
                            
                            int maxVal = specimen.getCollectingPersons().size();
                            p1.personRecords.setRecordMaxValue( maxVal );
                            p1.personRecords.setSelectedIndex( maxVal );
                            updatePersonData();                        
                        }
                    }
                }
                else
                {
                    person = ( CollectingPerson ) getObject( index, personSet );
                    updatePersonData();
                }
            }
            else if( name.compareTo( projectRecordAction ) == 0 )
            {
                if( index < 0 )
                {
                    // add new entry
                    logger.info( "Create new project entry" );

                    javax.swing.JPanel selectionPanel = new javax.swing.JPanel();
                    selectionPanel.setLayout( new java.awt.GridLayout( 2, 1 ) );
                    
                    selectionPanel.add( new javax.swing.JLabel( "Prpject " ) );
                    javax.swing.JComboBox selection = new javax.swing.JComboBox();                    
                    selection.setModel( hibernateCollection.getNewProjectModel() );
                    selection.setEditable( true );
                    selectionPanel.add( selection );
                    
                    int test = javax.swing.JOptionPane.showConfirmDialog( myParentComponent, selectionPanel, "Pleace select or input:", JOptionPane.OK_CANCEL_OPTION, JOptionPane.INFORMATION_MESSAGE );
                    
                    if( test == JOptionPane.OK_OPTION )
                    {
                        CollectionProjectPK pk = new CollectionProjectPK();
                        pk.setDiversityProject( selection.getSelectedItem().toString() );
                        pk.setCollectionSpecimenId( specimen.getCollectionSpecimenId() );
                        project = new CollectionProject( pk );
                        project.setCollectionSpecimen( specimen );
                        if( hibernateCollection.save( project ) == true )
                        {
                            // update GUI
                            specimen.getCollectionProjects().add( project );
                            
                            int maxVal = specimen.getCollectionProjects().size();
                            p1.projectRecords.setRecordMaxValue( maxVal );
                            p1.projectRecords.setSelectedIndex( maxVal );
                            updateProjectData();                        
                        }
                    }
                }
                else
                {
                    project = ( CollectionProject ) getObject( index, projectSet );
                    updateProjectData();
                }
            }            
            else if( name.compareTo( geographyRecordAction ) == 0 )
            {
                if( index < 0 )
                {
                    // add new entry
                    logger.info( "Create new geography entry" );
                    
                    javax.swing.JPanel selectionPanel = new javax.swing.JPanel();
                    selectionPanel.setLayout( new java.awt.GridLayout( 2, 1 ) );
                    
                    selectionPanel.add( new javax.swing.JLabel( "Localisation system" ) );
                    javax.swing.JComboBox selection = new javax.swing.JComboBox();
                    selection.setModel( hibernateCollection.getNewLocalisationModel() );
                    selectionPanel.add( selection );
                    // selection.setEditable( true );
                    int test = javax.swing.JOptionPane.showConfirmDialog( myParentComponent, selectionPanel, "Pleace select or input:", JOptionPane.OK_CANCEL_OPTION, JOptionPane.INFORMATION_MESSAGE );
                    
                    if( test == JOptionPane.OK_OPTION )
                    {
                        CollectionGeographyPK pk = new CollectionGeographyPK();
                        
                        LocalisationSystem ls = (LocalisationSystem) hibernateCollection.localisationHashMap.get( selection.getSelectedItem().toString() );
                        pk.setLocalisationSystemId( ls.getLocalisationSystemId() );
                        pk.setCollectionSpecimenId( specimen.getCollectionSpecimenId() );
                        geography = new CollectionGeography( pk );
                        // ??? warum setLocalisationSystemId() und setLocalisationSystem()
                        geography.setLocalisationSystem( ls );
                        geography.setCollectionSpecimen( specimen );
                        if( hibernateCollection.save( geography ) == true )
                        {
                            // update GUI
                            specimen.getCollectionGeographies().add( geography );
                            
                            int maxVal = specimen.getCollectionGeographies().size();
                            p2.localityRecords.setRecordMaxValue( maxVal );
                            p2.localityRecords.setSelectedIndex( maxVal );
                            updateGeographyData();                        
                        }
                    }
                }
                else
                {
                    geography = ( CollectionGeography ) getObject( index, geographySet );
                    updateGeographyData();
                }
            }            
            else if( name.compareTo( identificationUnitAction ) == 0 )
            {
                if( index < 0 )
                {
                    // add new entry
                    logger.info( "Create new identificationUnit entry" );
                    
                    javax.swing.JPanel selectionPanel = new javax.swing.JPanel();
                    selectionPanel.setLayout( new java.awt.GridLayout( 4, 1 ) );
                    
                    selectionPanel.add( new javax.swing.JLabel( "Taxonomic group" ) );
                    javax.swing.JComboBox selection = new javax.swing.JComboBox();
                    selection.setModel( hibernateCollection.getNewTaxonomicGroupModel() );
                    // selection.setEditable( true );
                    selectionPanel.add( selection );
                    
                    selectionPanel.add( new javax.swing.JLabel( "Only observed" ) );                    
                    javax.swing.JCheckBox onlyObservedCheckBox = new javax.swing.JCheckBox();                    
                    selectionPanel.add( onlyObservedCheckBox );
                    
                    int test = javax.swing.JOptionPane.showConfirmDialog( myParentComponent, selectionPanel, "Pleace select or input:", JOptionPane.OK_CANCEL_OPTION, JOptionPane.INFORMATION_MESSAGE );
                    
                    if( test == JOptionPane.OK_OPTION )
                    {
// ??? set ID                        
                        IdentificationUnitPK pk = new IdentificationUnitPK();
                        pk.setIdentificationUnitId( hibernateCollection.getNextIdentificationUnitId() );
                        pk.setCollectionSpecimenId( specimen.getCollectionSpecimenId() );
                        identificationUnit = new IdentificationUnit();
                        identificationUnit.setComp_id( pk );
                        identificationUnit.setXcollTaxonomicGroupEnum( (XcollTaxonomicGroupEnum) hibernateCollection.taxonomicGroupHashMap.get( selection.getSelectedItem().toString() ) );
                        identificationUnit.setOnlyObserved( onlyObservedCheckBox.isSelected() );
                        identificationUnit.setCollectionSpecimen( specimen );
                        if( hibernateCollection.save( identificationUnit ) == true )
                        {
                            // update GUI
                            specimen.getIdentificationUnits().add( identificationUnit );
                            
                            int maxVal = specimen.getIdentificationUnits().size();
                            p3.identificationUnitRecords.setRecordMaxValue( maxVal );
                            p3.identificationUnitRecords.setSelectedIndex( maxVal );
                            identification = null;
                            updateIdentificationUnitData();                        
                            updateIdentificationData();                        
                        }
                    }
                }
                else
                {
                    identificationUnit = ( IdentificationUnit ) getObject( index, identificationUnitSet );
                    updateIdentificationUnitData();
                    if( identificationUnit != null )
                    {
                        // update depending data
                        identificationSet = identificationUnit.getIdentifications();
                        if( identificationSet != null )
                        {
                            p3.identificationRecords.setRecordMaxValue( identificationSet.size() );
                            p3.identificationRecords.setSelectedIndex( 1 );
                            updateIdentificationData();
                        }
                    }
                    else
                    {
                        p3.identificationRecords.setSelectedIndex( 0 );
                        clearIdentificationData();
                    }
                }
            }            
            else if( name.compareTo( identificationAction ) == 0 )
            {
                if( index < 0 )
                {
                    // add new entry
                    logger.info( "Create new identification entry" );
                    
                    if( identificationUnit != null )
                    {
                        IdentificationPK pk = new IdentificationPK();
                        pk.setIdentificationUnitId( identificationUnit.getComp_id().getIdentificationUnitId() );
                        pk.setCollectionSpecimenId( specimen.getCollectionSpecimenId() );
                        pk.setIdentificationSequence( new java.util.Date() );
                        identification = new Identification();
                        identification.setComp_id( pk );
                        identification.setIdentificationUnit( identificationUnit );
                        if( hibernateCollection.save( identification ) == true )
                        {
                            // update GUI
                            identificationUnit.getIdentifications().add( identification );
                            
                            int maxVal = identificationUnit.getIdentifications().size();
                            p3.identificationRecords.setRecordMaxValue( maxVal );
                            p3.identificationRecords.setSelectedIndex( maxVal );
                            updateIdentificationData();                        
                        }
                    }
                }
                else
                {
                    identification = ( Identification ) getObject( index, identificationSet );
                    updateIdentificationData();
                }
            }            
            else if( name.compareTo( storageAction ) == 0 )
            {
                if( index < 0 )
                {
                    // add new entry
                    logger.info( "Create new storage entry" );
                                        
                    // need user input for Collection ans MaterialCategory
                    javax.swing.JPanel selectionPanel = new javax.swing.JPanel();
                    selectionPanel.setLayout( new java.awt.GridLayout( 4, 1 ) );
                    
                    selectionPanel.add( new javax.swing.JLabel( "Collection" ) );
                    javax.swing.JComboBox selectionCollection = new javax.swing.JComboBox();
                    selectionCollection.setModel( hibernateCollection.getNewCollectionModel() );
                    selectionPanel.add( selectionCollection );
                    
                    selectionPanel.add( new javax.swing.JLabel( "Material category" ) );                    
                    javax.swing.JComboBox selectionMaterial = new javax.swing.JComboBox();
                    selectionMaterial.setModel( hibernateCollection.getNewMaterialCategoryModel() );
                    selectionPanel.add( selectionMaterial );
                    
                    int test = javax.swing.JOptionPane.showConfirmDialog( myParentComponent, selectionPanel, "Pleace select or input:", JOptionPane.OK_CANCEL_OPTION, JOptionPane.INFORMATION_MESSAGE );
                    
                    if( test == JOptionPane.OK_OPTION )
                    {
// ??? set ID                        
                        CollectionStoragePK pk = new CollectionStoragePK();
                        pk.setCollectionSpecimenId( specimen.getCollectionSpecimenId() );
                        pk.setCollectionId( hibernateCollection.getCollectionIdFromString( (String) selectionCollection.getSelectedItem() ) );
                        // String s = (String) selectionMaterial.getSelectedItem();
                        // storage.setXcollMaterialCategoryEnum( (XcollMaterialCategoryEnum) hibernateCollection.materialCategoryHashMap.get( s ) );
                        pk.setMaterialCategory( (String) selectionMaterial.getSelectedItem() );
                        
                        storage = new CollectionStorage();
                        storage.setComp_id( pk );
                        storage.setCollectionSpecimen( specimen );
                        if( hibernateCollection.save( storage ) == true )
                        {
                            // update GUI
                            specimen.getCollectionStorages().add( storage );
                            
                            int maxVal = specimen.getCollectionStorages().size();
                            p4.storageRecords.setRecordMaxValue( maxVal );
                            p4.storageRecords.setSelectedIndex( maxVal );
                            updateStorageData();
                        }
                    }
                }
                else
                {
                    storage = ( CollectionStorage ) getObject( index, storageSet );
                    updateStorageData();
                }
            }            
            else if( name.compareTo( duplicateAction ) == 0 )
            {
                if( index < 0 )
                {
                    // add new entry
                    logger.info( "Create new duplicate entry" );
                    
                    // need user input for AccessionNumber
                    
                    javax.swing.JPanel selectionPanel = new javax.swing.JPanel();
                    selectionPanel.setLayout( new java.awt.GridLayout( 2, 1 ) );
                    
                    selectionPanel.add( new javax.swing.JLabel( "Collection" ) );
                    javax.swing.JComboBox selectionCollection = new javax.swing.JComboBox();
                    selectionCollection.setModel( hibernateCollection.getNewCollectionModel() );
                    selectionPanel.add( selectionCollection );
                    
                    selectionPanel.add( new javax.swing.JLabel( "Accession Number" ) );
                    javax.swing.JTextField selection = new javax.swing.JTextField();
                    selectionPanel.add( selection );

                    int test = javax.swing.JOptionPane.showConfirmDialog( myParentComponent, selectionPanel, "Pleace select or input:", JOptionPane.OK_CANCEL_OPTION, JOptionPane.INFORMATION_MESSAGE );
                    
                    if( test == JOptionPane.OK_OPTION )
                    {
                        CollectionDuplicatePK pk = new CollectionDuplicatePK();
                        pk.setCollectionSpecimenId( specimen.getCollectionSpecimenId() );
                        pk.setAccessionNumber( selection.getText() );                    
                        duplicate = new CollectionDuplicate();
                        duplicate.setComp_id( pk );
                        duplicate.setCollectionSpecimen( specimen );
// ???                        
                        duplicate.setCollection( (Collection) hibernateCollection.collectionHashMap.get( ( String) selectionCollection.getSelectedItem() ) );
// ???                        duplicate.setCollection( collection );
                        
                        if( hibernateCollection.save( duplicate ) == true )
                        {
                            // update GUI
                            specimen.getCollectionDuplicates().add( duplicate );
                            
                            int maxVal = specimen.getCollectionDuplicates().size();
                            p4.duplicateRecords.setRecordMaxValue( maxVal );
                            p4.duplicateRecords.setSelectedIndex( maxVal );
                            updateDuplicateData();                        
                        }
                    }
                }
                else
                {
                    duplicate = ( CollectionDuplicate ) getObject( index, duplicateSet );
                    updateDuplicateData();
                }
            }                  
            else if( name.compareTo( imageAction ) == 0 )
            {
                if( index < 0 )
                {
                    // add new entry
                    logger.info( "Create new image entry" );
                    
                    javax.swing.JPanel selectionPanel = new javax.swing.JPanel();
                    selectionPanel.setLayout( new java.awt.GridLayout( 2, 1 ) );
                    
                    selectionPanel.add( new javax.swing.JLabel( "Image path" ) );
                    javax.swing.JTextField selection = new javax.swing.JTextField();
                    selectionPanel.add( selection );

                    int test = javax.swing.JOptionPane.showConfirmDialog( myParentComponent, selectionPanel, "Pleace select or input:", JOptionPane.OK_CANCEL_OPTION, JOptionPane.INFORMATION_MESSAGE );
                    
                    if( test == JOptionPane.OK_OPTION )
                    {
                        CollectionImagePK pk = new CollectionImagePK();
                        pk.setCollectionSpecimenId( specimen.getCollectionSpecimenId() );
                        pk.setImagePath( selection.getText() );                    
                        image = new CollectionImage();
                        image.setComp_id( pk );
                        image.setCollectionSpecimen( specimen );
                        
                        if( hibernateCollection.save( image ) == true )
                        {
                            // update GUI
                            specimen.getCollectionImages().add( image );
                            
                            int maxVal = specimen.getCollectionImages().size();
                            p5.imageRecords.setRecordMaxValue( maxVal );
                            p5.imageRecords.setSelectedIndex( maxVal );
                            updateImageData();                        
                        }
                    }
                }
                else
                {
                    image = ( CollectionImage ) getObject( index, imageSet );
                    updateImageData();
                }
            }                  
            
        }    
        //----------------------------------------------------------------------
        private int getRecordIndex( String s )
        {
            int index = 0;
            try
            {
                index = java.lang.Integer.decode( s ).intValue();
            }
            catch( java.lang.NumberFormatException ex )
            {
                index = -1;
            }
            return index;
        }
        //----------------------------------------------------------------------
        private java.lang.Object getObject( int index, java.util.Set set )
        {
            if( set == null )
            {
                return null;
            }
            java.util.Iterator  iter = set.iterator();
            int pos = 1;
            while( iter.hasNext() && pos <= index )
            {
                if( pos == index )
                {
                    return iter.next();                
                }
                iter.next();
                pos++;
            }              
            return null;
        }
    }
}
