package net.metadiversity.diversity.navigator.gui;

import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

import org.apache.log4j.*;

public class AskDialog extends JDialog 
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3616444588127499572L;

    static Logger logger = Logger.getLogger( AskDialog.class.getName() );
    
    private boolean ok = false;
    //----------------------------------------------------------------------
    //----------------------------------------------------------------------
    public boolean getOK() 
    {
        return ok;
    }
    //----------------------------------------------------------------------
    //----------------------------------------------------------------------
    public AskDialog( String title, String question ) 
    {
        super();
        setTitle( title );
        getContentPane().setLayout(new BorderLayout());

        //Question
        JLabel questionLable = new JLabel( question );
        questionLable.setHorizontalAlignment( SwingConstants.LEFT );
        getContentPane().add( questionLable, BorderLayout.CENTER );

        // Buttons
        Box buttons = new Box( BoxLayout.X_AXIS );
        buttons.add( Box.createGlue() );
        JButton cmdOK = new JButton( "OK" );
        cmdOK.addActionListener(new ActionListener() 
        {
            public void actionPerformed( ActionEvent e ) 
            {
                ok = true; 
                setVisible( false );
            }
        });
        buttons.add( cmdOK );
        buttons.add( Box.createHorizontalStrut( 5 ) );
        JButton cmdCancel = new JButton( "Cancel" );
        cmdCancel.addActionListener(new ActionListener() 
        {
            public void actionPerformed( ActionEvent e ) 
            { 
                ok = false; 
                setVisible( false );
            }
        });
        buttons.add( cmdCancel );		
        getContentPane().add( buttons, BorderLayout.SOUTH );

        // Resize
        Dimension D = Toolkit.getDefaultToolkit().getScreenSize();		
        pack();
        setBounds((int)(D.getWidth()/2 - getWidth()/2), (int)(D.getHeight()/2 - getHeight()/2), getWidth(),getHeight());
    }
    //----------------------------------------------------------------------
    //----------------------------------------------------------------------
    public boolean Ask()         
    {
        setModal( true );
        setVisible( true );
        return getOK();
    }
}
