/*
 * CollectionTabIndentification.java
 *
 * Created on 15. September 2004, 11:39
 */

package net.metadiversity.diversity.navigator.gui;

import com.jgoodies.forms.layout.*;
import com.jgoodies.forms.layout.ColumnSpec;

import net.metadiversity.diversity.navigator.db.ub.DnDataRecordSelector;

/**
 *
 * @author  didi
 */
public class CollectionTabCollectorTimeLocation extends com.jgoodies.forms.builder.PanelBuilder
{
    com.jgoodies.forms.builder.PanelBuilder     builder;
    // default format values
    static final String DEFAULT_COLUMNE_FORMAT = "fill:d:grow";
    static final String PAD_COLUMNE_FORMAT     = "fill:3dlu:nogrow";
    static final String DEFAULT_ROW_FORMAT     = "fill:d:nogrow";
    static final String PAD_ROW_FORMAT         = "fill:3dlu:nogrow";    
    // Form parameter
    int xMaxFormPos;
    int yMaxFormPos;
    // debug
    boolean DEBUG_ADD_COMPONENT = false;
    boolean DEBUG_LINE_AND_ROW_NUMBERS = false;
    //
    CellConstraints cc;
    
    //
    public DnDataRecordSelector        projectRecords;
    public DnDataRecordSelector        personRecords;
    
    public void showLineNumbers( boolean b )
    {
        DEBUG_LINE_AND_ROW_NUMBERS = b;
    }
    
    public CollectionTabCollectorTimeLocation()
    {
        super( new com.jgoodies.forms.layout.FormLayout( "", "" ) );
        showLineNumbers( false );
        cc = new CellConstraints();
        xMaxFormPos = 12;
        yMaxFormPos = 10;
        
        ColumnSpec colPad = new com.jgoodies.forms.layout.ColumnSpec( PAD_COLUMNE_FORMAT );              
        ColumnSpec colDef = new com.jgoodies.forms.layout.ColumnSpec( DEFAULT_COLUMNE_FORMAT );              
        
        RowSpec rowPad = new com.jgoodies.forms.layout.RowSpec( PAD_ROW_FORMAT );              
        RowSpec rowDef = new com.jgoodies.forms.layout.RowSpec( DEFAULT_ROW_FORMAT );              

        
        if( DEBUG_LINE_AND_ROW_NUMBERS )
        {
            appendColumn( colDef );
            appendRow( rowDef );
        }
        else
        {
            appendColumn( colPad );
            appendRow( rowPad );                
        }
        
        for( int col = 1; col <= xMaxFormPos; col++ )
        {
            appendColumn( colDef );
            if( DEBUG_LINE_AND_ROW_NUMBERS && col == xMaxFormPos )
            {
                appendColumn( colDef );
            }
            else
            {
                appendColumn( colPad );
            }
        }
        for( int row = 1; row <= yMaxFormPos; row++ )
        {   
            appendRow( rowDef );
            if( DEBUG_LINE_AND_ROW_NUMBERS && row == yMaxFormPos )
            {
                appendRow( rowDef );
            }
            else
            {
                appendRow( rowPad );                   
            }
            if( DEBUG_LINE_AND_ROW_NUMBERS )
            {
                // Set line numbers 
                javax.swing.JLabel l1 = new javax.swing.JLabel( String.valueOf( row ) );
                add( l1, cc.xy( 1 , row * 2 ) );
                javax.swing.JLabel l2 = new javax.swing.JLabel( String.valueOf( row ) );
                add( l2, cc.xy( xMaxFormPos * 2 + 1, row * 2 ) );
            }
            else
            {
                javax.swing.JLabel l1 = new javax.swing.JLabel( " " );
                add( l1, cc.xy( 1 , row * 2 ) );                
            }
        }
        
        for( int col = 1; col <= xMaxFormPos; col++ )
        {
            if( DEBUG_LINE_AND_ROW_NUMBERS )
            {
                // set column numbers
                javax.swing.JLabel l1 = new javax.swing.JLabel( String.valueOf( col ) );
                add( l1, cc.xy( col * 2, 1 ) );
                javax.swing.JLabel l2 = new javax.swing.JLabel( String.valueOf( col ) );
                add( l2, cc.xy( col * 2, yMaxFormPos * 2 + 1 ) );
            }
        }
        
        //----------------------------------------------------------------------
        // Change Layout for "Date"
        //----------------------------------------------------------------------
        int dateStartPos = 8;
        
        com.jgoodies.forms.layout.FormLayout layout = getLayout();
        
        if( ! DEBUG_LINE_AND_ROW_NUMBERS )
        {
            // !!! remove / add columns from the right side !!!
            // dd
            layout.removeColumn( dateStartPos +  0 );
            layout.insertColumn( dateStartPos +  0, new com.jgoodies.forms.layout.ColumnSpec( "fill:12dlu:nogrow" ) );
            // mm
            layout.removeColumn( dateStartPos +  2 );
            layout.insertColumn( dateStartPos +  2, new com.jgoodies.forms.layout.ColumnSpec( "fill:12dlu:nogrow" ) );
            // yyyy
            layout.removeColumn( dateStartPos +  4 );
            layout.insertColumn( dateStartPos +  4, new com.jgoodies.forms.layout.ColumnSpec( "fill:20dlu:nogrow" ) );
        }
        
        //----------------------------------------------------------------------
        // Add Record selector for Project and CollectionPerson
        //----------------------------------------------------------------------
        projectRecords  = new DnDataRecordSelector();
        personRecords   = new DnDataRecordSelector();
        
        java.awt.GridBagConstraints gridBagConstraints;
        
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        add( personRecords, gridBagConstraints );
        
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 9;
        add( projectRecords, gridBagConstraints );
        
        initComponents();                
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void debug( int x, int y, int l, int h )
    {
        System.out.println( "x: " + x +  " \ty: " + y + " \tl:" + l );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private void setLayout( java.awt.LayoutManager lm )
    {
        
    }
    void add( javax.swing.JComponent c, java.awt.GridBagConstraints gbc )    
    {
        cc = new CellConstraints();
        System.out.println( c );
        // Don't show Lable outside the form
        if( gbc.gridx > xMaxFormPos || gbc.gridy > yMaxFormPos )
        {
            return;
        }
        cc.xywh( ( gbc.gridx + 1 ) * 2, ( gbc.gridy + 1 ) * 2, ( gbc.gridwidth * 2 ) -1, ( gbc.gridheight * 2 ) -1 );
        System.out.println( cc );        
        add( c, cc );
        
    }
    /** This method is called from within the constructor to     
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents()//GEN-BEGIN:initComponents
    {
        java.awt.GridBagConstraints gridBagConstraints;

        jLabelCollectingPersonOrGroups = new javax.swing.JLabel();
        jLabelCollectionNumber = new javax.swing.JLabel();
        jLabelDate = new javax.swing.JLabel();
        jTextFieldDateDD = new javax.swing.JTextField();
        jTextFieldDateMM = new javax.swing.JTextField();
        jTextFieldDateYYYY = new javax.swing.JTextField();
        jTextFieldDateSuppl = new javax.swing.JTextField();
        jComboBoxDateCategory = new javax.swing.JComboBox();
        jLabelDateFormat = new javax.swing.JLabel();
        jComboBoxPersonOrGroups = new javax.swing.JComboBox();
        jTextFieldCollectionNumber = new javax.swing.JTextField();
        jLabelLocality = new javax.swing.JLabel();
        jLabelHabitat = new javax.swing.JLabel();
        jLabelOriginal = new javax.swing.JLabel();
        jLabelOriginalNotes = new javax.swing.JLabel();
        jLabelAdditional = new javax.swing.JLabel();
        jLabelAdditionalNotes = new javax.swing.JLabel();
        jScrollPaneLocalityHabitat = new javax.swing.JScrollPane();
        jTextAreaLocalityHabitat = new javax.swing.JTextArea();
        jScrollPaneOriginalNotes = new javax.swing.JScrollPane();
        jTextAreaOriginalNotes = new javax.swing.JTextArea();
        jScrollPaneAdditionalNotes = new javax.swing.JScrollPane();
        jTextAreaAdditionalNotes = new javax.swing.JTextArea();
        jLabelProject = new javax.swing.JLabel();
        jComboBoxProject = new javax.swing.JComboBox();
        jLabelLabel = new javax.swing.JLabel();
        jLabelTitle = new javax.swing.JLabel();
        jLabelType = new javax.swing.JLabel();
        jLabelTranscription = new javax.swing.JLabel();
        jLabelNotes = new javax.swing.JLabel();
        jLabelProblem = new javax.swing.JLabel();
        jCheckBoxPrintLabel = new javax.swing.JCheckBox();
        jTextFieldLabelTitle = new javax.swing.JTextField();
        jComboBoxLabelType = new javax.swing.JComboBox();
        jComboBoxLableTranscription = new javax.swing.JComboBox();
        jScrollPaneLabelNotes = new javax.swing.JScrollPane();
        jTextAreaLabelNotes = new javax.swing.JTextArea();
        jScrollPaneProblems = new javax.swing.JScrollPane();
        jTextAreaProblems = new javax.swing.JTextArea();

        setLayout(new java.awt.GridBagLayout());

        jLabelCollectingPersonOrGroups.setText("Collecting person or group");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        add(jLabelCollectingPersonOrGroups, gridBagConstraints);

        jLabelCollectionNumber.setText("collection number");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jLabelCollectionNumber, gridBagConstraints);

        jLabelDate.setText("Date");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jLabelDate, gridBagConstraints);

        jTextFieldDateDD.setText("dd");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jTextFieldDateDD, gridBagConstraints);

        jTextFieldDateMM.setText("mm");
        jTextFieldDateMM.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                jTextFieldDateMMActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 4;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jTextFieldDateMM, gridBagConstraints);

        jTextFieldDateYYYY.setText("yyyy");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 5;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jTextFieldDateYYYY, gridBagConstraints);

        jTextFieldDateSuppl.setText("suppl.");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 6;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jTextFieldDateSuppl, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 7;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jComboBoxDateCategory, gridBagConstraints);

        jLabelDateFormat.setText("(day|month|year|supplement|category)");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 8;
        gridBagConstraints.gridy = 0;
        add(jLabelDateFormat, gridBagConstraints);

        jComboBoxPersonOrGroups.setEditable(true);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jComboBoxPersonOrGroups, gridBagConstraints);

        jTextFieldCollectionNumber.setText("collection number");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jTextFieldCollectionNumber, gridBagConstraints);

        jLabelLocality.setText("Locality /");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 1;
        add(jLabelLocality, gridBagConstraints);

        jLabelHabitat.setText("habitat");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 2;
        add(jLabelHabitat, gridBagConstraints);

        jLabelOriginal.setText("Original");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 4;
        add(jLabelOriginal, gridBagConstraints);

        jLabelOriginalNotes.setText("notes");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 5;
        add(jLabelOriginalNotes, gridBagConstraints);

        jLabelAdditional.setText("Additional");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 7;
        add(jLabelAdditional, gridBagConstraints);

        jLabelAdditionalNotes.setText("notes");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 2;
        gridBagConstraints.gridy = 8;
        add(jLabelAdditionalNotes, gridBagConstraints);

        jScrollPaneLocalityHabitat.setViewportView(jTextAreaLocalityHabitat);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 6;
        gridBagConstraints.gridheight = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        add(jScrollPaneLocalityHabitat, gridBagConstraints);

        jScrollPaneOriginalNotes.setViewportView(jTextAreaOriginalNotes);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 6;
        gridBagConstraints.gridheight = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        add(jScrollPaneOriginalNotes, gridBagConstraints);

        jScrollPaneAdditionalNotes.setViewportView(jTextAreaAdditionalNotes);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridwidth = 6;
        gridBagConstraints.gridheight = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        add(jScrollPaneAdditionalNotes, gridBagConstraints);

        jLabelProject.setText("Project");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jLabelProject, gridBagConstraints);

        jComboBoxProject.setEditable(true);
        jComboBoxProject.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                jComboBoxProjectActionPerformed(evt);
            }
        });

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 8;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jComboBoxProject, gridBagConstraints);

        jLabelLabel.setText("Label");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 9;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jLabelLabel, gridBagConstraints);

        jLabelTitle.setText("Title");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 9;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jLabelTitle, gridBagConstraints);

        jLabelType.setText("Type");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 9;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jLabelType, gridBagConstraints);

        jLabelTranscription.setText("Trans.");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 9;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jLabelTranscription, gridBagConstraints);

        jLabelNotes.setText("Notes");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 9;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jLabelNotes, gridBagConstraints);

        jLabelProblem.setText("Problem");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 9;
        gridBagConstraints.gridy = 7;
        add(jLabelProblem, gridBagConstraints);

        jCheckBoxPrintLabel.setText("Print label");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 10;
        gridBagConstraints.gridy = 0;
        add(jCheckBoxPrintLabel, gridBagConstraints);

        jTextFieldLabelTitle.setText("label title");
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 10;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jTextFieldLabelTitle, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 10;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jComboBoxLabelType, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 10;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(jComboBoxLableTranscription, gridBagConstraints);

        jScrollPaneLabelNotes.setViewportView(jTextAreaLabelNotes);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 10;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridheight = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        add(jScrollPaneLabelNotes, gridBagConstraints);

        jScrollPaneProblems.setViewportView(jTextAreaProblems);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 10;
        gridBagConstraints.gridy = 7;
        gridBagConstraints.gridheight = 3;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        add(jScrollPaneProblems, gridBagConstraints);

    }//GEN-END:initComponents

    private void jComboBoxProjectActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jComboBoxProjectActionPerformed
    {//GEN-HEADEREND:event_jComboBoxProjectActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jComboBoxProjectActionPerformed

    private void jTextFieldDateMMActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jTextFieldDateMMActionPerformed
    {//GEN-HEADEREND:event_jTextFieldDateMMActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_jTextFieldDateMMActionPerformed
    
    public static void main( String [] args  )
    {
        CollectionTabCollectorTimeLocation p = new CollectionTabCollectorTimeLocation();
        
        javax.swing.JFrame f = new javax.swing.JFrame();        
        f.getContentPane().add( p.getPanel() );
        f.setVisible( true );
        f.setDefaultCloseOperation( javax.swing.JFrame.DISPOSE_ON_CLOSE );
    }
    
    /**
     * Getter for property jTextFieldCollectionNumber.
     * @return Value of property jTextFieldCollectionNumber.
     */
    public javax.swing.JTextField getJTextFieldCollectionNumber()
    {
        return jTextFieldCollectionNumber;
    }    
    
    /**
     * Setter for property jTextFieldCollectionNumber.
     * @param jTextFieldCollectionNumber New value of property jTextFieldCollectionNumber.
     */
    public void setJTextFieldCollectionNumber(javax.swing.JTextField jTextFieldCollectionNumber)
    {
        this.jTextFieldCollectionNumber = jTextFieldCollectionNumber;
    }
    
    /**
     * Getter for property jTextFieldDateDD.
     * @return Value of property jTextFieldDateDD.
     */
    public javax.swing.JTextField getJTextFieldDateDD()
    {
        return jTextFieldDateDD;
    }
    
    /**
     * Setter for property jTextFieldDateDD.
     * @param jTextFieldDateDD New value of property jTextFieldDateDD.
     */
    public void setJTextFieldDateDD(javax.swing.JTextField jTextFieldDateDD)
    {
        this.jTextFieldDateDD = jTextFieldDateDD;
    }
    
    /**
     * Getter for property jTextFieldDateMM.
     * @return Value of property jTextFieldDateMM.
     */
    public javax.swing.JTextField getJTextFieldDateMM()
    {
        return jTextFieldDateMM;
    }
    
    /**
     * Setter for property jTextFieldDateMM.
     * @param jTextFieldDateMM New value of property jTextFieldDateMM.
     */
    public void setJTextFieldDateMM(javax.swing.JTextField jTextFieldDateMM)
    {
        this.jTextFieldDateMM = jTextFieldDateMM;
    }
    
    /**
     * Getter for property jTextFieldDateSuppl.
     * @return Value of property jTextFieldDateSuppl.
     */
    public javax.swing.JTextField getJTextFieldDateSuppl()
    {
        return jTextFieldDateSuppl;
    }
    
    /**
     * Setter for property jTextFieldDateSuppl.
     * @param jTextFieldDateSuppl New value of property jTextFieldDateSuppl.
     */
    public void setJTextFieldDateSuppl(javax.swing.JTextField jTextFieldDateSuppl)
    {
        this.jTextFieldDateSuppl = jTextFieldDateSuppl;
    }
    
    /**
     * Getter for property jTextFieldDateYYYY.
     * @return Value of property jTextFieldDateYYYY.
     */
    public javax.swing.JTextField getJTextFieldDateYYYY()
    {
        return jTextFieldDateYYYY;
    }
    
    /**
     * Setter for property jTextFieldDateYYYY.
     * @param jTextFieldDateYYYY New value of property jTextFieldDateYYYY.
     */
    public void setJTextFieldDateYYYY(javax.swing.JTextField jTextFieldDateYYYY)
    {
        this.jTextFieldDateYYYY = jTextFieldDateYYYY;
    }
    
    /**
     * Getter for property jTextFieldLabelTitle.
     * @return Value of property jTextFieldLabelTitle.
     */
    public javax.swing.JTextField getJTextFieldLabelTitle()
    {
        return jTextFieldLabelTitle;
    }
    
    /**
     * Setter for property jTextFieldLabelTitle.
     * @param jTextFieldLabelTitle New value of property jTextFieldLabelTitle.
     */
    public void setJTextFieldLabelTitle(javax.swing.JTextField jTextFieldLabelTitle)
    {
        this.jTextFieldLabelTitle = jTextFieldLabelTitle;
    }
    
    /**
     * Getter for property jTextPaneAreaAdditionalNotes.
     * @return Value of property jTextPaneAreaAdditionalNotes.
     */
    public javax.swing.JTextArea getJTextAdditionalNotes()
    {
        return jTextAreaAdditionalNotes;
    }
    /**
     * Getter for property jTextPaneLabelNotes.
     * @return Value of property jTextPaneLabelNotes.
     */
    public javax.swing.JTextArea getJTextLabelNotes()
    {
        return jTextAreaLabelNotes;
    }
    
    /**
     * Getter for property jTextPaneLocalityHabitat.
     * @return Value of property jTextPaneLocalityHabitat.
     */
    public javax.swing.JTextArea getJTextLocalityHabitat()
    {
        return jTextAreaLocalityHabitat;
    }
    
    
    /**
     * Getter for property jTextPaneOriginalNotes.
     * @return Value of property jTextPaneOriginalNotes.
     */
    public javax.swing.JTextArea getJTextOriginalNotes()
    {
        return jTextAreaOriginalNotes;
    }
    
    /**
     * Getter for property jTextPaneProblems.
     * @return Value of property jTextPaneProblems.
     */
    public javax.swing.JTextArea getJTextProblems()
    {
        return jTextAreaProblems;
    }
    
    /**
     * Getter for property jCheckBoxPrintLabel.
     * @return Value of property jCheckBoxPrintLabel.
     */
    public javax.swing.JCheckBox getJCheckBoxPrintLabel()
    {
        return jCheckBoxPrintLabel;
    }
    
    /**
     * Setter for property jCheckBoxPrintLabel.
     * @param jCheckBoxPrintLabel New value of property jCheckBoxPrintLabel.
     */
    public void setJCheckBoxPrintLabel(javax.swing.JCheckBox jCheckBoxPrintLabel)
    {
        this.jCheckBoxPrintLabel = jCheckBoxPrintLabel;
    }
    
    /**
     * Getter for property jComboBoxDateCategory.
     * @return Value of property jComboBoxDateCategory.
     */
    public javax.swing.JComboBox getJComboBoxDateCategory()
    {
        return jComboBoxDateCategory;
    }
    
    /**
     * Setter for property jComboBoxDateCategory.
     * @param jComboBoxDateCategory New value of property jComboBoxDateCategory.
     */
    public void setJComboBoxDateCategory(javax.swing.JComboBox jComboBoxDateCategory)
    {
        this.jComboBoxDateCategory = jComboBoxDateCategory;
    }
    
    /**
     * Getter for property jComboBoxLabelType.
     * @return Value of property jComboBoxLabelType.
     */
    public javax.swing.JComboBox getJComboBoxLabelType()
    {
        return jComboBoxLabelType;
    }
    
    /**
     * Setter for property jComboBoxLabelType.
     * @param jComboBoxLabelType New value of property jComboBoxLabelType.
     */
    public void setJComboBoxLabelType(javax.swing.JComboBox jComboBoxLabelType)
    {
        this.jComboBoxLabelType = jComboBoxLabelType;
    }
    
    /**
     * Getter for property jComboBoxLableTranscription.
     * @return Value of property jComboBoxLableTranscription.
     */
    public javax.swing.JComboBox getJComboBoxLableTranscription()
    {
        return jComboBoxLableTranscription;
    }
    
    /**
     * Setter for property jComboBoxLableTranscription.
     * @param jComboBoxLableTranscription New value of property jComboBoxLableTranscription.
     */
    public void setJComboBoxLableTranscription(javax.swing.JComboBox jComboBoxLableTranscription)
    {
        this.jComboBoxLableTranscription = jComboBoxLableTranscription;
    }
    
    /**
     * Getter for property jComboBoxPersonOrGroups.
     * @return Value of property jComboBoxPersonOrGroups.
     */
    public javax.swing.JComboBox getJComboBoxPersonOrGroups()
    {
        return jComboBoxPersonOrGroups;
    }
    
    /**
     * Setter for property jComboBoxPersonOrGroups.
     * @param jComboBoxPersonOrGroups New value of property jComboBoxPersonOrGroups.
     */
    public void setJComboBoxPersonOrGroups(javax.swing.JComboBox jComboBoxPersonOrGroups)
    {
        this.jComboBoxPersonOrGroups = jComboBoxPersonOrGroups;
    }
    
    /**
     * Getter for property jComboBoxProject.
     * @return Value of property jComboBoxProject.
     */
    public javax.swing.JComboBox getJComboBoxProject()
    {
        return jComboBoxProject;
    }
    
    /**
     * Setter for property jComboBoxProject.
     * @param jComboBoxProject New value of property jComboBoxProject.
     */
    public void setJComboBoxProject(javax.swing.JComboBox jComboBoxProject)
    {
        this.jComboBoxProject = jComboBoxProject;
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox jCheckBoxPrintLabel;
    private javax.swing.JComboBox jComboBoxDateCategory;
    private javax.swing.JComboBox jComboBoxLabelType;
    private javax.swing.JComboBox jComboBoxLableTranscription;
    private javax.swing.JComboBox jComboBoxPersonOrGroups;
    private javax.swing.JComboBox jComboBoxProject;
    private javax.swing.JLabel jLabelAdditional;
    private javax.swing.JLabel jLabelAdditionalNotes;
    private javax.swing.JLabel jLabelCollectingPersonOrGroups;
    private javax.swing.JLabel jLabelCollectionNumber;
    private javax.swing.JLabel jLabelDate;
    private javax.swing.JLabel jLabelDateFormat;
    private javax.swing.JLabel jLabelHabitat;
    private javax.swing.JLabel jLabelLabel;
    private javax.swing.JLabel jLabelLocality;
    private javax.swing.JLabel jLabelNotes;
    private javax.swing.JLabel jLabelOriginal;
    private javax.swing.JLabel jLabelOriginalNotes;
    private javax.swing.JLabel jLabelProblem;
    private javax.swing.JLabel jLabelProject;
    private javax.swing.JLabel jLabelTitle;
    private javax.swing.JLabel jLabelTranscription;
    private javax.swing.JLabel jLabelType;
    private javax.swing.JScrollPane jScrollPaneAdditionalNotes;
    private javax.swing.JScrollPane jScrollPaneLabelNotes;
    private javax.swing.JScrollPane jScrollPaneLocalityHabitat;
    private javax.swing.JScrollPane jScrollPaneOriginalNotes;
    private javax.swing.JScrollPane jScrollPaneProblems;
    private javax.swing.JTextArea jTextAreaAdditionalNotes;
    private javax.swing.JTextArea jTextAreaLabelNotes;
    private javax.swing.JTextArea jTextAreaLocalityHabitat;
    private javax.swing.JTextArea jTextAreaOriginalNotes;
    private javax.swing.JTextArea jTextAreaProblems;
    private javax.swing.JTextField jTextFieldCollectionNumber;
    private javax.swing.JTextField jTextFieldDateDD;
    private javax.swing.JTextField jTextFieldDateMM;
    private javax.swing.JTextField jTextFieldDateSuppl;
    private javax.swing.JTextField jTextFieldDateYYYY;
    private javax.swing.JTextField jTextFieldLabelTitle;
    // End of variables declaration//GEN-END:variables
    
}
