/*
 * ImportBsmEmailList.java
 *
 * Created on 2. September 2003, 10:22
 */

package net.metadiversity.diversity.navigator.util;

import org.apache.log4j.Logger;
import org.apache.log4j.Level;

import java.sql.*;
import java.io.*;

/**
 *
 * @author  Dieter Neubacher
 */
public class ImportBsmEmailList
{
    static Logger logger = Logger.getLogger( ImportBsmEmailList.class.getName() );
    
    static java.lang.String db_url     = "jdbc:postgresql://hongkong:5432/bsm-email-list";
    static java.lang.String db_user    = "didi";
    static java.lang.String db_pwd     = "";
    
    /** Creates a new instance of ImportBsmEmailList */
    public ImportBsmEmailList()
    {
    }
    //--------------------------------------------------------------------------
    //
    //--------------------------------------------------------------------------
    public static void usage()
    {
        logger.error( "java net.metadiversity.diversity.navigator.utilImportBsmEmailList [ -my, -py ] import-file-name db-url db-user db-pwd" );
        logger.error( "-my        Mycologie Email list" );
        logger.error( "-ph        Phycologie Email list" );
        logger.error( "db-url     jdbc:postgresql://141.84.65.156:5432/bsm-email-list" );
        logger.error( "db-user    username" );
        logger.error( "db-pwd     password" );
    }
    //--------------------------------------------------------------------------
    // import data structure
    // id   Name    email
    //--------------------------------------------------------------------------
    public static void importMyData( java.sql.Connection con, java.io.BufferedReader input ) throws  java.io.IOException, java.sql.SQLException
    {   
        java.lang.String str;
        java.lang.String firstName;
        java.lang.String lastName;
        java.lang.String emailAddress;
        
        java.lang.String line = null;
        
        java.sql.PreparedStatement pstmt = con.prepareStatement( "INSERT INTO \"EmailList\" ( group_id, first_name, last_name, email, visible, created_at ) VALUES ( 'MY', ?, ?, ?, true, now() );" );
        
        while( (line = input.readLine()) != null )
        {  
            java.util.StringTokenizer st = new java.util.StringTokenizer( line, "\t", false );
            // read id
            if( st.hasMoreTokens() )
            {
                st.nextToken();
            }
            else continue;
            // read name
            if( st.hasMoreTokens() )
            {
                str = (java.lang.String) st.nextToken();
                // split name
                int index = str.indexOf( " " );
                if( index > 0 )
                {    
                    lastName = str.substring( 0, index ).trim();
                    firstName  = str.substring( index ).trim();
                }
                else
                {
                    lastName  = str;
                    firstName = "";
                }    
            }
            else continue;
            if( st.hasMoreTokens() )
            {
                emailAddress = st.nextToken().trim();
            }
            else
            {
                emailAddress = "";
            }
            // logger.info( "FirstName: " + firstName + " LastName: " + lastName + " Email: " + emailAddress );
            pstmt.setString( 1,  firstName );
            pstmt.setString( 2,  lastName );
            pstmt.setString( 3,  emailAddress );
            // logger.error( pstmt.toString() );
            pstmt.execute();
        }   
    }
    //--------------------------------------------------------------------------
    //
    //--------------------------------------------------------------------------
    public static void importPhData( java.sql.Connection con, java.io.BufferedReader input ) throws  java.io.IOException, java.sql.SQLException
    {
        java.lang.String str;
        java.lang.String firstName;
        java.lang.String lastName;
        java.lang.String emailAddress;
        
        java.lang.String line = null;
        
        java.sql.PreparedStatement pstmt = con.prepareStatement( "INSERT INTO \"EmailList\" ( group_id, first_name, last_name, email, visible, created_at ) VALUES ( 'PH', ?, ?, ?, true, now() );" );
        
        while( (line = input.readLine()) != null )
        {  
            java.util.StringTokenizer st = new java.util.StringTokenizer( line, "\t", false );
            // read id
            if( st.hasMoreTokens() )
            {
                st.nextToken();
            }
            else continue;
            // read last name
            if( st.hasMoreTokens() )
            {
                lastName = st.nextToken().trim();
            }
            else
            {    
                lastName = "";    
            }    
            // read first name 
            if( st.hasMoreTokens() )
            {
                firstName = st.nextToken().trim();
            }
            else
            {    
                firstName = "";    
            }    
            if( st.hasMoreTokens() )
            {
                emailAddress = st.nextToken().trim();
            }
            else
            {
                emailAddress = "";
            }
            // logger.info( "FirstName: " + firstName + " LastName: " + lastName + " Email: " + emailAddress );
            pstmt.setString( 1,  firstName );
            pstmt.setString( 2,  lastName );
            pstmt.setString( 3,  emailAddress );
            // logger.error( pstmt.toString() );
            pstmt.execute();
        }
    }
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args)
    {
        boolean myFlag  = false;
        boolean phFlag  = false;
        Connection con  = null;
        String importFileName = null;
        
        try
        {
            org.apache.log4j.BasicConfigurator.configure();
            logger.setLevel( Level.DEBUG );
        }
        finally
        {
        }                
        // get args
        if( args.length < 2 )
        {
            usage();
            System.exit( 1 );
        }
        if( args[ 0 ].compareTo( "-my" ) == 0 ) myFlag = true;
        if( args[ 0 ].compareTo( "-ph" ) == 0 ) phFlag = true;
        if( ! (myFlag || phFlag) ) 
        {
            usage();
            System.exit( 1 );
        }
        importFileName = args[ 1 ];
        
        java.io.File file = new java.io.File( importFileName );
        // ???
        if( ! (file != null && file.exists() && file.canRead()) )
        {
            logger.error( "can't read import file." );
            System.exit( 2 );
        }            
        if( args.length >= 3 ) db_url  = args[ 2 ];
        if( args.length >= 4 ) db_user = args[ 3 ];
        if( args.length >= 5 ) db_pwd  = args[ 4 ];
        if( args.length >= 6 || db_url == null || db_user == null || db_pwd == null ) 
        {
            usage();
            System.exit( 1 );
        }
        // get DB-Connection
        try
        {
            Class.forName( "org.postgresql.Driver" );
            logger.info( "Load PostgreSQL Driver..." );
        }
        catch( java.lang.ClassNotFoundException ee )
        {
            logger.error( "ClassNotFoundException: " );
            logger.error( ee.getMessage() );
        }
        
        try
        {
            con = java.sql.DriverManager.getConnection( db_url, db_user, db_pwd );
            FileInputStream     fis = new FileInputStream( file );
            InputStreamReader   isr = new InputStreamReader( fis, "UTF-8" );
            BufferedReader input    = new BufferedReader( isr );
            
            if( myFlag ) 
            {
                logger.info( "Import MY-Data from file: " + file.getAbsolutePath() );
                importMyData( con, input );
            }
            if( phFlag ) 
            {
                logger.info( "Import PH-Data from file: " + file.getAbsolutePath() );
                importPhData( con, input );
            }
            con.commit();
            con.close();
            
        }
        catch( java.io.FileNotFoundException ex )
        {
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
        }
        catch( java.io.UnsupportedEncodingException ex )
        {
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
        }
        catch( java.io.IOException ex )
        {
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
        }
        catch( java.sql.SQLException ex )
        {
             logger.error( ex.getMessage(), ex.fillInStackTrace() );
        }
        finally
        {   
            try
            {
                if( con != null ) con.close();
            }
            catch( java.sql.SQLException ex )
            {
                 logger.error( ex.getMessage(), ex.fillInStackTrace() );
            }            
        }
    }    
}
