package net.metadiversity.diversity.navikey.bo;

import net.metadiversity.diversity.navikey.ui.NaviKey;

import java.util.Vector;

/**
 * ResourceAttribute is a special TextAttribute -- it deals with Resources or
 * multimedia objects
 * @author Michael Bartley
 * 7/16/98
 */

public class ResourceAttribute extends Attribute
{
    private Vector resources;
    
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public ResourceAttribute()
    {
        super();
        resources = new Vector();
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public Vector getResources()
    {
        return resources;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void addResource(Resource r)
    {
        resources.addElement(new ResourceState(r));
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public int countResources()
    {
        return resources.size();
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    //FOLLOWING MUST BE IMPLEMENTED DUE TO INHERITENCE, but may be meaningless
    //////////////////////////////////////
    public void addCommentedState(State st, String comment)
    {
        return;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public Vector getCommentedStates()
    {
        return resources;
    }
    
    public boolean containsState(State s)
    {
        return false;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public Vector getStates()
    {
        return resources;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public boolean sameAs( NaviKey navikey, Attribute a)
    {
        return false;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public String toString()
    {
        StringBuffer sb = new StringBuffer();
        for(int i=0; i< resources.size(); i++)
        {
            sb.append(((Resource)resources.elementAt(i)).toString());
        }
        return new String(sb);
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void print()
    {
        System.out.println(toString());
    }
}
