package net.metadiversity.diversity.navikey.delta;

/**
 * DeltaFilePeer.java
 * @author Noel Cross
 * @author Michael Bartley
 */

import java.io.BufferedReader;

public class DeltaFilePeer
{
    private BufferedReader  specsReader;
    private BufferedReader  charsReader;
    private BufferedReader  itemsReader;
    
    private boolean         removeCharsCommentFlag;
    private boolean         removeItemsCommentFlag;
    private boolean         removeSpecsCommentFlag;
    
    private boolean         removeCharsStatesCommentFlag;
    private boolean         removeItemsStatesCommentFlag;
    private boolean         removeSpecsStatesCommentFlag;
    
    public DeltaFilePeer( BufferedReader specs, 
                          boolean removeSpecsCommentFlag, 
                          boolean removeSpecsStatesCommentFlag, 
                          BufferedReader chars, 
                          boolean removeCharsCommentFlag, 
                          boolean removeCharsStatesCommentFlag, 
                          BufferedReader items, 
                          boolean removeItemsCommentFlag, 
                          boolean removeItemsStatesCommentFlag 
                        )
    {        
        specsReader = specs;
        charsReader = chars;
        itemsReader = items;
        
        this.removeCharsCommentFlag = removeCharsCommentFlag;
        this.removeItemsCommentFlag = removeItemsCommentFlag;
        this.removeSpecsCommentFlag = removeSpecsCommentFlag;
        
        this.removeCharsStatesCommentFlag = removeCharsStatesCommentFlag;
        this.removeItemsStatesCommentFlag = removeItemsStatesCommentFlag;
        this.removeSpecsStatesCommentFlag = removeSpecsStatesCommentFlag;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public DeltaData loadDeltaData()
    {        
        DeltaData dd = new DeltaData();
        
        SpecsFileReader sfr = new SpecsFileReader();
        CharsFileReader cfr = new CharsFileReader();
        ItemsFileReader ifr = new ItemsFileReader();
        
        sfr.read( specsReader, removeSpecsCommentFlag, removeSpecsStatesCommentFlag );
        sfr.makeItemCharacterTypes();
        
        dd.setItemCharacterTypesVector( sfr.getItemCharacterTypes() );
        
        cfr.setItemCharacterTypes( sfr.getItemCharacterTypes() );
        cfr.read( charsReader, removeCharsCommentFlag, removeCharsStatesCommentFlag );

        dd.setItemCharacters( cfr.getItemCharacters() );
        
        // ??? No functionallity ??? ifr.setItemCharacters( cfr.getItemCharacters() );
        ifr.read( itemsReader, removeItemsCommentFlag, removeItemsStatesCommentFlag, dd );
        
        dd.setItemsVector( ifr.getItems() );
        
        return dd;
    }
}
