/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/**
 * Title:        Checklist
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      University Bayreuth
 * @author Dieter Neubacher
 * @version 1.0
 */

package net.metadiversity.diversity.navigator.checklists.taxon;

import net.metadiversity.diversity.navigator.checklists.*;
//import net.metadiversity.diversity.navigator.checklists.taxon.*;

public class Synonym extends javax.swing.JPanel
{
/**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3618417129301226544L;

// Variables declaration - do not modify
private javax.swing.JLabel jLabelTaxon;

private javax.swing.JPanel jPanelInputFieldsTaxon;
private javax.swing.JPanel jPanelValidity;
private javax.swing.JPanel jPanelRadioButtons;
private javax.swing.JPanel jPanelOutputLine;
private javax.swing.JPanel jPanelLiterature;
private javax.swing.JPanel jPanel_OGU_type;
private javax.swing.JPanel jPanel_OGU;
private javax.swing.JPanel jPanelNotice;
private javax.swing.JPanel jPanelReference;

private javax.swing.JLabel jLabelOutputLine;

private javax.swing.JTextField jTextFieldLiterature;
private javax.swing.JTextField jTextFieldLiteratureYear;
private javax.swing.JTextField jTextFieldReference;
private javax.swing.JTextField jTextField_OGU_type;

private javax.swing.JTextArea jTextAreaNotice;

private javax.swing.JLabel jLabelValidity;
private javax.swing.JLabel jLabelLiterature;
private javax.swing.JLabel jLabelLiteratureYear;
private javax.swing.JLabel jLabelNotice;


private javax.swing.JLabel jLabel_OGU_type;
private javax.swing.JLabel jLabelReference;
private javax.swing.JLabel jLabelReferenceAuthor;

// End of variables declaration

    /** Creates new form Taxon */
    public Synonym()
    {
        initComponents();
    }
    private void initComponents ()
    {
        jPanelInputFieldsTaxon   = new javax.swing.JPanel();
        jPanelValidity           = new javax.swing.JPanel();
        jPanelRadioButtons       = new javax.swing.JPanel();
        jPanelOutputLine         = new javax.swing.JPanel();
        jPanelLiterature         = new javax.swing.JPanel();
        jPanel_OGU               = new javax.swing.JPanel();
        jPanel_OGU_type          = new javax.swing.JPanel();
        jPanelNotice             = new javax.swing.JPanel();
        jPanelReference          = new javax.swing.JPanel();

        jLabelTaxon              = new javax.swing.JLabel();

	jLabelOutputLine         = new javax.swing.JLabel();
        jLabelOutputLine.setForeground( java.awt.Color.red );
        jLabelOutputLine.setFont( new java.awt.Font ( "Dialog", 1, 12 ) );
        jLabelOutputLine.setHorizontalAlignment( javax.swing.SwingConstants.CENTER );

        jLabelValidity           = new javax.swing.JLabel ();

        jLabelLiterature = new javax.swing.JLabel ();
        jTextFieldLiterature = new javax.swing.JTextField ();
        jLabelLiteratureYear = new javax.swing.JLabel ();
        jTextFieldLiteratureYear = new javax.swing.JTextField ();
        jLabel_OGU_type = new javax.swing.JLabel ();
        jTextField_OGU_type = new javax.swing.JTextField ();
        jLabelNotice = new javax.swing.JLabel ();
        jTextAreaNotice = new javax.swing.JTextArea ();
        jLabelReference = new javax.swing.JLabel ();
        jTextFieldReference = new javax.swing.JTextField ();
        jLabelReferenceAuthor = new javax.swing.JLabel ();
	//-------------------------------------------------------------------------
	//-------------------------------------------------------------------------
        setLayout( new java.awt.GridLayout( 10, 1) );

	//-----------------------
	// Headline
	//-----------------------

        jLabelTaxon.setText( "Synonym:" );
        jLabelTaxon.setHorizontalAlignment( javax.swing.SwingConstants.CENTER );
        jLabelTaxon.setFont( new java.awt.Font( "Dialog", 0, 18) );
        add( jLabelTaxon);

        TaxonSearchInput t = new TaxonSearchInput( jLabelTaxon );
        add( t );
	//-----------------------
	// Input Fields for taxon
	//-----------------------
        // TaxonInput jPanelInputFieldsTaxon = new TaxonInput( jLabelOutputLine );
        // add( jPanelInputFieldsTaxon );
        TaxonSearchInput synonymSearchInput = new TaxonSearchInput( jLabelTaxon );
        add( synonymSearchInput  );

        InputRankFlags jPanelRankFlags = new InputRankFlags();
        add( jPanelRankFlags );

        // BasionymFlagInput jPanelBasionymInputFlags = new BasionymFlagInput( );
        // add( jPanelBasionymInputFlags );
        // FlagInput jPanelInputFlags = new FlagInput( );
        // add( jPanelInputFlags );
	//-------------------------------------------------------------------------
	// Output Line
	//-------------------------------------------------------------------------
	jLabelOutputLine.setText( "..." );
	jLabelOutputLine.setHorizontalAlignment( javax.swing.SwingConstants.CENTER );
	jLabelOutputLine.setVerticalAlignment(   javax.swing.SwingConstants.CENTER );

	jPanelOutputLine.add( jLabelOutputLine );

	//-------------------------------------------------------------------------
	//-------------------------------------------------------------------------
	// Literature (taxon)
	//--------------------
          jPanelLiterature.setLayout( new java.awt.FlowLayout (0, 5, 5) );

	  //jPanelLiterature.setMaximumSize(   new java.awt.Dimension( 600, 30 ) );
	  //jPanelLiterature.setMinimumSize(   new java.awt.Dimension( 600, 30 ) );
	  //jPanelLiterature.setPreferredSize( new java.awt.Dimension( 600, 30 ) );
	  jPanelLiterature.setSize( new java.awt.Dimension( 600, 30 ) );

            jLabelLiterature.setText( "Literature (taxon) ");
            jPanelLiterature.add( jLabelLiterature);
            jTextFieldLiterature.setPreferredSize( new java.awt.Dimension( 200, 16) );
            jTextFieldLiterature.setMinimumSize(   new java.awt.Dimension( 200, 16) );
            jTextFieldLiterature.setText( "" );
            jTextFieldLiterature.addActionListener (new java.awt.event.ActionListener()
            {
                public void actionPerformed (java.awt.event.ActionEvent evt)
                {
                    jTextFieldLiteratureActionPerformed (evt);
                }
            }
            );
            jPanelLiterature.add( jTextFieldLiterature);
            jLabelLiteratureYear.setText (" Year ");
            jPanelLiterature.add( jLabelLiteratureYear );
            jTextFieldLiteratureYear.setPreferredSize( new java.awt.Dimension( 50, 16) );
            jTextFieldLiteratureYear.setMinimumSize(   new java.awt.Dimension( 50, 16) );
            jTextFieldLiteratureYear.setText( "" );
            jTextFieldLiteratureYear.addActionListener( new java.awt.event.ActionListener()
            {
                public void actionPerformed (java.awt.event.ActionEvent evt)
                {
                    jTextFieldLiteratureYearActionPerformed (evt);
                }
            }
            );
        add( jPanelOutputLine );
            jPanelLiterature.add( jTextFieldLiteratureYear);
         add( jPanelLiterature);
	 //------------------------------------
	 // Operational geographical unit: type
	 //------------------------------------
//          jPanel_OGU_type.setLayout (new java.awt.FlowLayout (0, 5, 5));
            jPanel_OGU.setLayout( new java.awt.GridLayout( 3, 2 ) );
            jLabel_OGU_type.setText ("Operational geographical unit: type ");
//            jPanel_OGU_type.add( jLabel_OGU_type );
            jTextField_OGU_type.setPreferredSize( new java.awt.Dimension( 200, 16 ) );
            jTextField_OGU_type.setMinimumSize(   new java.awt.Dimension( 200, 16 ) );
            jTextField_OGU_type.setText ( "" );
            jTextField_OGU_type.addActionListener (new java.awt.event.ActionListener()
            {
                public void actionPerformed (java.awt.event.ActionEvent evt)
                {
                    jTextField_OGU_typeActionPerformed (evt);
                }
            }
            );
            jPanel_OGU.add( jLabel_OGU_type );
            jPanel_OGU.add( jTextField_OGU_type);

	  jLabelNotice.setText( "Notice :" );
	  jPanel_OGU.add( jLabelNotice );
          add( jPanel_OGU );

	  //----------
	  // Notice
	  //----------

//          jPanelNotice.setLayout( new java.awt.FlowLayout( 0, 5, 5 ) );
//	  jPanelNotice.setMaximumSize(   new java.awt.Dimension( 780, 250 ) );
//	  jPanelNotice.setMinimumSize(   new java.awt.Dimension( 780, 250 ) );
//	  jPanelNotice.setPreferredSize( new java.awt.Dimension( 780, 250 ) );
//	  jLabelNotice.setText( "Notice" );
//	  jPanelNotice.add( jLabelNotice );
/*
	  jTextAreaNotice.setMinimumSize(   new java.awt.Dimension( 780, 150 ) );
	  jTextAreaNotice.setPreferredSize( new java.awt.Dimension( 780, 150 ) );
	  jPanelNotice.add( jTextAreaNotice );
*/


          javax.swing.JEditorPane edit = new javax.swing.JEditorPane();

	  // edit.setMinimumSize(   new java.awt.Dimension( 680, 150 ) );
	  // edit.setPreferredSize( new java.awt.Dimension( 680, 150 ) );

          javax.swing.JScrollPane ScrollPane = new  javax.swing.JScrollPane( edit );
          // ScrollPane.setMinimumSize(   new java.awt.Dimension( 760, 150 ) );
          ScrollPane.setPreferredSize( new java.awt.Dimension( 760, 50 ) );
          ScrollPane.setAutoscrolls( true );
	  jPanelNotice.add( ScrollPane );

          add( jPanelNotice );

	  //------------
	  // Reference
	  //------------
          jPanelReference.setLayout( new java.awt.FlowLayout( 0, 5, 5 ) );
	  jLabelReference.setText( "Reference" );
	  jPanelReference.add( jLabelReference );
	  jTextFieldReference.setPreferredSize( new java.awt.Dimension( 150, 16) );
	  jTextFieldReference.setMinimumSize(   new java.awt.Dimension( 150, 16) );
	  jTextFieldReference.setText ("");
	  jPanelReference.add( jTextFieldReference );
	  jLabelReferenceAuthor.setText ("(OGU), author, year");
	  jPanelReference.add( jLabelReferenceAuthor );
          add( jPanelReference);
    }



    private void jTextField_OGU_distributionActionPerformed (java.awt.event.ActionEvent evt)
    {
    }

    private void jTextField_OGU_typeActionPerformed (java.awt.event.ActionEvent evt)
    {
    }
    private void jTextFieldLiteratureYearActionPerformed (java.awt.event.ActionEvent evt)
    {
    }
    private void jTextFieldLiteratureActionPerformed (java.awt.event.ActionEvent evt)
    {
    }
}