/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * BasicQueryField.java
 *
 * Created on 21. Juli 2003, 13:07
 */

package net.metadiversity.diversity.navigator.gui;

import org.apache.log4j.Logger;

/**
 *
 * @author  Dieter Neubacher
 */
public class BasicQueryField extends javax.swing.JPanel
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3256725095581298992L;

    static Logger logger = Logger.getLogger( BasicQueryField.class.getName() ); 

    private String databaseName     = null;
    private String tableName        = null;    
    private String fieldName        = null;   
    private int bracketOpenCount    = 0;    
    private int brackedtCloseCunt   = 0;
    private int index               = 0;
    
    private String operator = null;
    
    private Object value = null;
    
    /** Creates new form BasicQueryField */
    public BasicQueryField()
    {
        databaseName = "DatabaseName";
        tableName = "TableName";
        fieldName = "FieldName";
        initComponents();
    }
    
    public BasicQueryField( String database, String table, String field )
    {
        databaseName = database;
        tableName = table;
        fieldName = field;
        initComponents();
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public boolean isSelected()
    {
        return selectCheckBox.isSelected();
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public java.lang.String getDatabaseName()
    {
        return databaseName;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public java.lang.String getTableName()
    {
        return tableName;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public java.lang.String getFieldName()
    {
        return fieldName;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public java.lang.String getWhere()
    {
        java.lang.StringBuffer where = new java.lang.StringBuffer();
        
        java.lang.String param = whereTextField.getText().trim();
        
        if( param.length() == 0 )
        {
            return null;
        }
        where.append( "\"" + tableName + "\".\"" + fieldName + "\" " );
        where.append( compareOperatorComboBox.getSelectedItem().toString() );
        // where.append( " '" + whereTextField.getText() + "' " );
        where.append( " " + whereTextField.getText() + " " );
        
        return where.toString();
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public java.lang.String getLogicalOperator()
    {
        return " " + LogicalComboBox.getSelectedItem().toString() + " ";
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents()//GEN-BEGIN:initComponents
    {
        borderLayout1 = new java.awt.BorderLayout();
        moveDeletePanel = new javax.swing.JPanel();
        jButtonDelete = new javax.swing.JButton();
        jButtonUp = new javax.swing.JButton();
        jButtonDown = new javax.swing.JButton();
        dataPanel = new javax.swing.JPanel();
        LogicalPanel = new javax.swing.JPanel();
        selectCheckBox = new javax.swing.JCheckBox();
        close1 = new javax.swing.JToggleButton();
        close2 = new javax.swing.JToggleButton();
        close3 = new javax.swing.JToggleButton();
        LogicalComboBox = new javax.swing.JComboBox();
        open1 = new javax.swing.JToggleButton();
        open2 = new javax.swing.JToggleButton();
        open3 = new javax.swing.JToggleButton();
        tableNamePanel = new javax.swing.JPanel();
        tabelNameLabel = new javax.swing.JLabel();
        tableFieldPanel = new javax.swing.JPanel();
        fieldNameLabel = new javax.swing.JLabel();
        compareOperatorComboBox = new javax.swing.JComboBox();
        whereTextField = new javax.swing.JTextField();

        setLayout(new java.awt.BorderLayout());

        setMinimumSize(new java.awt.Dimension(200, 90));
        setPreferredSize(new java.awt.Dimension(300, 90));
        moveDeletePanel.setLayout(new java.awt.GridLayout(3, 1));

        jButtonDelete.setIcon(new javax.swing.ImageIcon(getClass().getResource("/net/metadiversity/diversity/navigator/images/PanelClose12.jpg")));
        jButtonDelete.setToolTipText("Delete");
        jButtonDelete.setMaximumSize(new java.awt.Dimension(14, 14));
        jButtonDelete.setPreferredSize(new java.awt.Dimension(14, 14));
        jButtonDelete.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                jButtonDeleteActionPerformed(evt);
            }
        });

        moveDeletePanel.add(jButtonDelete);

        jButtonUp.setIcon(new javax.swing.ImageIcon(getClass().getResource("/net/metadiversity/diversity/navigator/images/PanelUp12.jpg")));
        jButtonUp.setToolTipText("Move Up");
        jButtonUp.setMaximumSize(new java.awt.Dimension(14, 14));
        jButtonUp.setPreferredSize(new java.awt.Dimension(14, 14));
        jButtonUp.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                jButtonUpActionPerformed(evt);
            }
        });

        moveDeletePanel.add(jButtonUp);

        jButtonDown.setIcon(new javax.swing.ImageIcon(getClass().getResource("/net/metadiversity/diversity/navigator/images/PanelDown12.jpg")));
        jButtonDown.setToolTipText("Move Down");
        jButtonDown.setMaximumSize(new java.awt.Dimension(14, 14));
        jButtonDown.setPreferredSize(new java.awt.Dimension(14, 14));
        jButtonDown.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                jButtonDownActionPerformed(evt);
            }
        });

        moveDeletePanel.add(jButtonDown);

        add(moveDeletePanel, java.awt.BorderLayout.EAST);

        dataPanel.setLayout(new java.awt.GridLayout(3, 1));

        dataPanel.setMinimumSize(new java.awt.Dimension(600, 75));
        dataPanel.setPreferredSize(new java.awt.Dimension(600, 75));
        LogicalPanel.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT));

        selectCheckBox.setSelected(true);
        selectCheckBox.setText("Show");
        LogicalPanel.add(selectCheckBox);

        close1.setText(")");
        LogicalPanel.add(close1);

        close2.setText(")");
        LogicalPanel.add(close2);

        close3.setText(")");
        LogicalPanel.add(close3);

        LogicalComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "AND", "OR", "NOT" }));
        LogicalComboBox.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                LogicalComboBoxActionPerformed(evt);
            }
        });

        LogicalPanel.add(LogicalComboBox);

        open1.setText("(");
        open1.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                open1ActionPerformed(evt);
            }
        });

        LogicalPanel.add(open1);

        open2.setText("(");
        open2.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                open2ActionPerformed(evt);
            }
        });

        LogicalPanel.add(open2);

        open3.setText("(");
        open3.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                open3ActionPerformed(evt);
            }
        });

        LogicalPanel.add(open3);

        dataPanel.add(LogicalPanel);

        tableNamePanel.setLayout(new java.awt.GridLayout(1, 0));

        tabelNameLabel.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        tabelNameLabel.setText(tableName);
        tabelNameLabel.setToolTipText("Table");
        tableNamePanel.add(tabelNameLabel);

        dataPanel.add(tableNamePanel);

        tableFieldPanel.setLayout(new java.awt.GridLayout(1, 0, 5, 5));

        fieldNameLabel.setHorizontalAlignment(javax.swing.SwingConstants.LEFT);
        fieldNameLabel.setText(fieldName);
        fieldNameLabel.setToolTipText("Field");
        tableFieldPanel.add(fieldNameLabel);

        compareOperatorComboBox.setEditable(true);
        compareOperatorComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "", "=", "!=", ">", ">=", "<", "<=", "like", "not like" }));
        compareOperatorComboBox.setMaximumSize(new java.awt.Dimension(131, 24));
        compareOperatorComboBox.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                compareOperatorComboBoxActionPerformed(evt);
            }
        });

        tableFieldPanel.add(compareOperatorComboBox);

        whereTextField.setMinimumSize(new java.awt.Dimension(200, 19));
        whereTextField.setPreferredSize(new java.awt.Dimension(200, 19));
        whereTextField.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                whereTextFieldActionPerformed(evt);
            }
        });

        tableFieldPanel.add(whereTextField);

        dataPanel.add(tableFieldPanel);

        add(dataPanel, java.awt.BorderLayout.CENTER);

    }//GEN-END:initComponents

    private void open3ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_open3ActionPerformed
    {//GEN-HEADEREND:event_open3ActionPerformed
        logger.debug( "open3: " + evt );
    }//GEN-LAST:event_open3ActionPerformed

    private void open2ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_open2ActionPerformed
    {//GEN-HEADEREND:event_open2ActionPerformed
        logger.debug( "open2: " + evt );
    }//GEN-LAST:event_open2ActionPerformed

    private void open1ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_open1ActionPerformed
    {//GEN-HEADEREND:event_open1ActionPerformed
        logger.debug( "open1: " + evt );
    }//GEN-LAST:event_open1ActionPerformed

    private void LogicalComboBoxActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_LogicalComboBoxActionPerformed
    {//GEN-HEADEREND:event_LogicalComboBoxActionPerformed
        logger.debug( "AndOrNot: " + evt );
    }//GEN-LAST:event_LogicalComboBoxActionPerformed

    private void compareOperatorComboBoxActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_compareOperatorComboBoxActionPerformed
    {//GEN-HEADEREND:event_compareOperatorComboBoxActionPerformed
        logger.debug( "Operator: " + evt );        
    }//GEN-LAST:event_compareOperatorComboBoxActionPerformed

    private void whereTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_whereTextFieldActionPerformed
        logger.debug( "Edit: " + evt );
    }//GEN-LAST:event_whereTextFieldActionPerformed

    private void jButtonDeleteActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jButtonDeleteActionPerformed
    {//GEN-HEADEREND:event_jButtonDeleteActionPerformed
        logger.debug( "Delete: " + evt );
        java.awt.Container c = getParent();
        c.setVisible( false );
        c.remove( this );
        c.setVisible( true );
        c.repaint();                
        
    }//GEN-LAST:event_jButtonDeleteActionPerformed

    private void jButtonUpActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jButtonUpActionPerformed
    {//GEN-HEADEREND:event_jButtonUpActionPerformed
        logger.debug( "Move Up: " + evt );
        java.awt.Container c = getParent();
        java.awt.Point p = this.getLocation();
        int count = c.getComponentCount();
        java.awt.Component cc [] = c.getComponents();
        int index = -1;
        for( int i = 0; i < count; i++ )
        {
            // logger.debug( cc[ i ] );
            if( this.equals( cc[ i ] ) )
            {
                logger.debug( "Fount at Index: " + i );
                index = i;
                break;
            }
        }
        if( index > 0 )
        {
            c.setVisible( false );
            c.remove( this );
            c.add( this, --index );
            c.setVisible( true );
            c.repaint();                            
        }
        logger.debug( "Pos: " + p.x + " " + p.y );
        
    }//GEN-LAST:event_jButtonUpActionPerformed

    private void jButtonDownActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jButtonDownActionPerformed
    {//GEN-HEADEREND:event_jButtonDownActionPerformed
        logger.debug( "Move Down: " + evt );
        logger.debug( "Move Up: " + evt );
        java.awt.Container c = getParent();
        java.awt.Point p = this.getLocation();
        int count = c.getComponentCount();
        java.awt.Component cc [] = c.getComponents();
        int index = -1;
        for( int i = 0; i < count; i++ )
        {
            // logger.debug( cc[ i ] );
            if( this.equals( cc[ i ] ) )
            {
                logger.debug( "Fount at Index: " + i );
                index = i;
                break;
            }
        }
        if( index < --count )
        {
            c.setVisible( false );
            c.remove( this );
            c.add( this, ++index );
            c.setVisible( true );
            c.repaint();                            
        }
        logger.debug( "Pos: " + p.x + " " + p.y );
        
    }//GEN-LAST:event_jButtonDownActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox LogicalComboBox;
    private javax.swing.JPanel LogicalPanel;
    private java.awt.BorderLayout borderLayout1;
    private javax.swing.JToggleButton close1;
    private javax.swing.JToggleButton close2;
    private javax.swing.JToggleButton close3;
    private javax.swing.JComboBox compareOperatorComboBox;
    private javax.swing.JPanel dataPanel;
    private javax.swing.JLabel fieldNameLabel;
    private javax.swing.JButton jButtonDelete;
    private javax.swing.JButton jButtonDown;
    private javax.swing.JButton jButtonUp;
    private javax.swing.JPanel moveDeletePanel;
    private javax.swing.JToggleButton open1;
    private javax.swing.JToggleButton open2;
    private javax.swing.JToggleButton open3;
    private javax.swing.JCheckBox selectCheckBox;
    private javax.swing.JLabel tabelNameLabel;
    private javax.swing.JPanel tableFieldPanel;
    private javax.swing.JPanel tableNamePanel;
    private javax.swing.JTextField whereTextField;
    // End of variables declaration//GEN-END:variables
    
}
