/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package net.metadiversity.diversity.navigator.gui;

import org.apache.log4j.Logger;

import java.sql.*;
import java.util.ArrayList;
//import javax.swing.table.*;

/**
 *
 * @author  Dieter Neubacher
 */
/*
   Diese Klasse speichert die Daten der Ergebnismenge zwischen und
   eignet sich, wenn bildlauff�hige Cursor nicht unterst�tzt werden.
*/
class QueryCachingResultSetTableModel extends QueryResultSetTableModel
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3978990980986581559L;

    static Logger logger = Logger.getLogger( QueryResultSetTableModel.class.getName() );

    private ArrayList cache;
   
    public QueryCachingResultSetTableModel(ResultSet aResultSet)
    {
        super( aResultSet );
        try
        {
            cache           = new ArrayList();
            int cols        = getColumnCount();
            ResultSet rs    = getResultSet();

            // Copy all Data into Arrayliste

            while( rs.next() )
            {
                Object[] row = new Object[cols];
                for( int j = 0; j < row.length; j++ )
                {
                    row[ j ] = rs.getObject( j + 1 );
                }
                cache.add( row );
            }
        }
        catch( SQLException ex )
        {
            logger.error( ex.getMessage(), ex.fillInStackTrace() );
        }
    }
    //---------------------------------------------------------------------------
    //---------------------------------------------------------------------------
    public Object getValueAt(int r, int c)
    {
        if( r < cache.size() )
        {
            return ( (Object[]) cache.get( r ) )[ c ];
        }
        else
        {
            return null;
        }
    }
    //---------------------------------------------------------------------------
    //---------------------------------------------------------------------------
    public int getRowCount()
    {
        return cache.size();
    }
}