/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * SelectCollectionDialog.java
 *
 * Created on 19. August 2004, 11:04
 */

package net.metadiversity.diversity.navigator.gui.collection;

import net.sf.hibernate.HibernateException;
import net.sf.hibernate.Session;
import net.sf.hibernate.SessionFactory;
import net.sf.hibernate.Transaction;
//import net.sf.hibernate.cfg.Configuration;

/**
 *
 * @author  didi
 */
public class SelectCollectionDialog extends javax.swing.JDialog
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3258412828682957617L;
    
    javax.swing.table.TableModel myModel;
    int selectedCollectionId = -1;
    /** Creates new form SelectCollectionDialog */
    public SelectCollectionDialog( java.awt.Frame parent, boolean modal, net.sf.hibernate.SessionFactory sf )
    {
        super( parent, modal );        
        myModel = new Model( sf );        
        initComponents();
    }
    
//    private class Model implements javax.swing.table.TableModel
    private class Model extends javax.swing.table.DefaultTableModel
    {
        /**
         * Comment for <code>serialVersionUID</code>
         */
        private static final long serialVersionUID = 3616453384337438265L;
        int rowCount = 0;
        int columnCount = 0;
        Session session = null;
        SessionFactory sf = null;

        private String [] columnName = null;
        
        net.metadiversity.diversity.navigator.hibernate.ubt.collection.Collection collection;
        java.util.List collections;
       
        public Model( net.sf.hibernate.SessionFactory sf )
        {            
            this.sf = sf;
            
            columnCount = 4;
            columnName = new String [] { "ID","Collection Name", "Description", "Room" };
            //------------------------------------------------------------------   
            try
            {
                session = this.sf.openSession();
                Transaction trx = session.beginTransaction();
                collections = session.find( "select collection from Collection as collection" );                
                rowCount = collections.size();
                trx.commit();
            }
            catch( HibernateException he )
            {
                he.printStackTrace();
            }
            finally
            {
                try
                {
                    if (session != null)
                    {
                        session.close();
                    }
                    if (sf != null)
                    {
                        sf.close();
                    }
                } 
                catch (HibernateException e)
                {
                    e.printStackTrace();
                }
            }            
        }
        public int getColumnCount()
        {
            return columnCount;
        }        
        
        public int getRowCount()
        {
            return rowCount;
        }
        
        public Object getValueAt( int rowIndex, int columnIndex )
        {
             collection = (net.metadiversity.diversity.navigator.hibernate.ubt.collection.Collection) collections.get( rowIndex );

             switch( columnIndex )
             {
                 case 0: return collection.getCollectionId(); 
                 case 1: return collection.getCollectionName(); 
                 case 2: return collection.getDescription();    
                 case 3: return collection.getRoom(); 
                 
                 default: return "";
             }
        }
        
        public void addTableModelListener(javax.swing.event.TableModelListener l)
        {
        }
        
        public Class getColumnClass(int columnIndex)
        {
            return java.lang.String.class;
        }
        
        public String getColumnName(int columnIndex)
        {
            return columnName[ columnIndex ];
        }
        
        public boolean isCellEditable(int rowIndex, int columnIndex)
        {
            switch( columnIndex )
            {
                case 0: return false; 
                case 1: return false;
                case 2: return false;
                case 3: return false;
                
                default: return false;
            }            
        }
        
        public void removeTableModelListener(javax.swing.event.TableModelListener l)
        {
        }
        
        public void setValueAt(Object aValue, int rowIndex, int columnIndex)
        {
        }
    };
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents()//GEN-BEGIN:initComponents
    {
        jLabel1 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        jPanel1 = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setModal(true);
        setName("Select Collection");
        jLabel1.setText("Please select Collection");
        getContentPane().add(jLabel1, java.awt.BorderLayout.NORTH);

        jTable1.setModel(myModel);
        jScrollPane1.setViewportView(jTable1);

        getContentPane().add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jButton1.setText("Select");
        jButton1.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                jButton1ActionPerformed(evt);
            }
        });

        jPanel1.add(jButton1);

        jButton2.setText("Abort");
        jPanel1.add(jButton2);

        jButton3.setText("Create New");
        jPanel1.add(jButton3);

        getContentPane().add(jPanel1, java.awt.BorderLayout.SOUTH);

        pack();
    }//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jButton1ActionPerformed
    {//GEN-HEADEREND:event_jButton1ActionPerformed
        // TODO add your handling code here:
        
        selectedCollectionId = ( ( Integer ) myModel.getValueAt( jTable1.getSelectedRow(), 0 ) ).intValue();
        
        System.out.println( selectedCollectionId );
    }//GEN-LAST:event_jButton1ActionPerformed
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[])
    {
        new SelectCollectionDialog( new javax.swing.JFrame(), true, null ).setVisible( true );
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTable1;
    // End of variables declaration//GEN-END:variables
    
}
