/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * DeltaEditorTableModel.java
 *
 * Created on 9. Februar 2004, 12:34
 */

package net.metadiversity.diversity.navigator.gui.delta_editor;

import net.metadiversity.diversity.navigator.db.delta_editor.DeltaEditorData;
import net.metadiversity.diversity.navigator.db.delta_editor.CharacterStateDescription;
/**
 *
 * @author  didi
 */
// public class DeltaEditorTableModel implements javax.swing.table.TableModel 
public class DeltaEditorTableModel extends javax.swing.table.DefaultTableModel 
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3546643217836814644L;
    DeltaEditorData ded;    // database data access  
        
    /** Creates a new instance of DeltaEditorTableModel */
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public DeltaEditorTableModel( DeltaEditorData ded ) 
    { 
        super();
        this.ded = ded;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public int getColumnCount() 
    {
        // return number of characters        
        if( ded == null )
        {
            return 0;
        }
        return ded.getCharacterCount() + 1; // add first "Item" columne
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public int getRowCount() 
    {
        // return number of taxons
        if( ded == null )
        {
            return 0;
        }
        return ded.getItemNameCount(); 
    }    
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public Object getValueAt( int row, int col ) 
    {
        if( col == 0 ) 
        {
            return ded.getItemLableText( row );         // rowHeader
        }
        return ded.getTableElement( row, col -1 );      // get data
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public Class getColumnClass( int col ) 
    {
        return CharacterStateDescription.class;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public String getColumnName( int col ) 
    {
        if( col == 0 ) 
            return "Taxon";
        else
            return ded.getHeadIndex( col -1 );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public boolean isCellEditable( int col, int row ) 
    {
        if( col == 0 )
            return false;
        else
            return true;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void setValueAt( Object obj, int col, int row ) 
    {
        if( col == 0 )
        {    
            System.out.println( "setValueAt: col = " + col );
        }
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void addTableModelListener(javax.swing.event.TableModelListener tableModelListener) 
    {
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public void removeTableModelListener(javax.swing.event.TableModelListener tableModelListener) 
    {
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------    
}
