/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package net.metadiversity.diversity.navigator.hibernate.ubt.collection;

import java.io.Serializable;
import java.util.Date;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;


/** @author Hibernate CodeGenerator */
public class CollectionGeography implements Serializable {

    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3977865076768321849L;

    /** identifier field */
    private net.metadiversity.diversity.navigator.hibernate.ubt.collection.CollectionGeographyPK comp_id;

    /** nullable persistent field */
    private String location1;

    /** nullable persistent field */
    private String location2;

    /** nullable persistent field */
    private Date determinationDate;

    /** nullable persistent field */
    private String responsible;

    /** nullable persistent field */
    private Double averageAltitudeCache;

    /** nullable persistent field */
    private Double averageLongitudeCache;

    /** nullable persistent field */
    private Double averageLatitudeCache;

    /** nullable persistent field */
    private net.metadiversity.diversity.navigator.hibernate.ubt.collection.CollectionSpecimen collectionSpecimen;

    /** nullable persistent field */
    private net.metadiversity.diversity.navigator.hibernate.ubt.collection.LocalisationSystem localisationSystem;

    /** full constructor */
    public CollectionGeography(net.metadiversity.diversity.navigator.hibernate.ubt.collection.CollectionGeographyPK comp_id, String location1, String location2, Date determinationDate, String responsible, Double averageAltitudeCache, Double averageLongitudeCache, Double averageLatitudeCache, net.metadiversity.diversity.navigator.hibernate.ubt.collection.CollectionSpecimen collectionSpecimen, net.metadiversity.diversity.navigator.hibernate.ubt.collection.LocalisationSystem localisationSystem) {
        this.comp_id = comp_id;
        this.location1 = location1;
        this.location2 = location2;
        this.determinationDate = determinationDate;
        this.responsible = responsible;
        this.averageAltitudeCache = averageAltitudeCache;
        this.averageLongitudeCache = averageLongitudeCache;
        this.averageLatitudeCache = averageLatitudeCache;
        this.collectionSpecimen = collectionSpecimen;
        this.localisationSystem = localisationSystem;
    }

    /** default constructor */
    public CollectionGeography() {
    }

    /** minimal constructor */
    public CollectionGeography(net.metadiversity.diversity.navigator.hibernate.ubt.collection.CollectionGeographyPK comp_id) {
        this.comp_id = comp_id;
    }

    public net.metadiversity.diversity.navigator.hibernate.ubt.collection.CollectionGeographyPK getComp_id() {
        return this.comp_id;
    }

    public void setComp_id(net.metadiversity.diversity.navigator.hibernate.ubt.collection.CollectionGeographyPK comp_id) {
        this.comp_id = comp_id;
    }

    public String getLocation1() {
        return this.location1;
    }

    public void setLocation1(String location1) {
        this.location1 = location1;
    }

    public String getLocation2() {
        return this.location2;
    }

    public void setLocation2(String location2) {
        this.location2 = location2;
    }

    public Date getDeterminationDate() {
        return this.determinationDate;
    }

    public void setDeterminationDate(Date determinationDate) {
        this.determinationDate = determinationDate;
    }

    public String getResponsible() {
        return this.responsible;
    }

    public void setResponsible(String responsible) {
        this.responsible = responsible;
    }

    public Double getAverageAltitudeCache() {
        return this.averageAltitudeCache;
    }

    public void setAverageAltitudeCache(Double averageAltitudeCache) {
        this.averageAltitudeCache = averageAltitudeCache;
    }

    public Double getAverageLongitudeCache() {
        return this.averageLongitudeCache;
    }

    public void setAverageLongitudeCache(Double averageLongitudeCache) {
        this.averageLongitudeCache = averageLongitudeCache;
    }

    public Double getAverageLatitudeCache() {
        return this.averageLatitudeCache;
    }

    public void setAverageLatitudeCache(Double averageLatitudeCache) {
        this.averageLatitudeCache = averageLatitudeCache;
    }

    public net.metadiversity.diversity.navigator.hibernate.ubt.collection.CollectionSpecimen getCollectionSpecimen() {
        return this.collectionSpecimen;
    }

    public void setCollectionSpecimen(net.metadiversity.diversity.navigator.hibernate.ubt.collection.CollectionSpecimen collectionSpecimen) {
        this.collectionSpecimen = collectionSpecimen;
    }

    public net.metadiversity.diversity.navigator.hibernate.ubt.collection.LocalisationSystem getLocalisationSystem() {
        return this.localisationSystem;
    }

    public void setLocalisationSystem(net.metadiversity.diversity.navigator.hibernate.ubt.collection.LocalisationSystem localisationSystem) {
        this.localisationSystem = localisationSystem;
    }

    public String toString() {
        return new ToStringBuilder(this)
            .append("comp_id", getComp_id())
            .toString();
    }

    public boolean equals(Object other) {
        if ( (this == other ) ) return true;
        if ( !(other instanceof CollectionGeography) ) return false;
        CollectionGeography castOther = (CollectionGeography) other;
        return new EqualsBuilder()
            .append(this.getComp_id(), castOther.getComp_id())
            .isEquals();
    }

    public int hashCode() {
        return new HashCodeBuilder()
            .append(getComp_id())
            .toHashCode();
    }

}
