/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package net.metadiversity.diversity.navigator.hibernate.ubt.collection;

import java.io.Serializable;
import java.util.Date;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;


/** @author Hibernate CodeGenerator */
public class CollectionImage implements Serializable {

    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 4051331136645050672L;

    /** identifier field */
    private net.metadiversity.diversity.navigator.hibernate.ubt.collection.CollectionImagePK comp_id;

    /** nullable persistent field */
    private Integer identificationUnitId;

    /** nullable persistent field */
    private String imageCaption;

    /** nullable persistent field */
    private String creator;

    /** nullable persistent field */
    private Date creationDate;

    /** nullable persistent field */
    private String creationMetadata;

    /** nullable persistent field */
    private String rights;

    /** nullable persistent field */
    private net.metadiversity.diversity.navigator.hibernate.ubt.collection.CollectionSpecimen collectionSpecimen;

    /** persistent field */
    private net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollImageTypeEnum xcollImageTypeEnum;

    /** full constructor */
    public CollectionImage(net.metadiversity.diversity.navigator.hibernate.ubt.collection.CollectionImagePK comp_id, Integer identificationUnitId, String imageCaption, String creator, Date creationDate, String creationMetadata, String rights, net.metadiversity.diversity.navigator.hibernate.ubt.collection.CollectionSpecimen collectionSpecimen, net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollImageTypeEnum xcollImageTypeEnum) {
        this.comp_id = comp_id;
        this.identificationUnitId = identificationUnitId;
        this.imageCaption = imageCaption;
        this.creator = creator;
        this.creationDate = creationDate;
        this.creationMetadata = creationMetadata;
        this.rights = rights;
        this.collectionSpecimen = collectionSpecimen;
        this.xcollImageTypeEnum = xcollImageTypeEnum;
    }

    /** default constructor */
    public CollectionImage() {
    }

    /** minimal constructor */
    public CollectionImage(net.metadiversity.diversity.navigator.hibernate.ubt.collection.CollectionImagePK comp_id, net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollImageTypeEnum xcollImageTypeEnum) {
        this.comp_id = comp_id;
        this.xcollImageTypeEnum = xcollImageTypeEnum;
    }

    public net.metadiversity.diversity.navigator.hibernate.ubt.collection.CollectionImagePK getComp_id() {
        return this.comp_id;
    }

    public void setComp_id(net.metadiversity.diversity.navigator.hibernate.ubt.collection.CollectionImagePK comp_id) {
        this.comp_id = comp_id;
    }

    public Integer getIdentificationUnitId() {
        return this.identificationUnitId;
    }

    public void setIdentificationUnitId(Integer identificationUnitId) {
        this.identificationUnitId = identificationUnitId;
    }

    public String getImageCaption() {
        return this.imageCaption;
    }

    public void setImageCaption(String imageCaption) {
        this.imageCaption = imageCaption;
    }

    public String getCreator() {
        return this.creator;
    }

    public void setCreator(String creator) {
        this.creator = creator;
    }

    public Date getCreationDate() {
        return this.creationDate;
    }

    public void setCreationDate(Date creationDate) {
        this.creationDate = creationDate;
    }

    public String getCreationMetadata() {
        return this.creationMetadata;
    }

    public void setCreationMetadata(String creationMetadata) {
        this.creationMetadata = creationMetadata;
    }

    public String getRights() {
        return this.rights;
    }

    public void setRights(String rights) {
        this.rights = rights;
    }

    public net.metadiversity.diversity.navigator.hibernate.ubt.collection.CollectionSpecimen getCollectionSpecimen() {
        return this.collectionSpecimen;
    }

    public void setCollectionSpecimen(net.metadiversity.diversity.navigator.hibernate.ubt.collection.CollectionSpecimen collectionSpecimen) {
        this.collectionSpecimen = collectionSpecimen;
    }

    public net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollImageTypeEnum getXcollImageTypeEnum() {
        return this.xcollImageTypeEnum;
    }

    public void setXcollImageTypeEnum(net.metadiversity.diversity.navigator.hibernate.ubt.collection.XcollImageTypeEnum xcollImageTypeEnum) {
        this.xcollImageTypeEnum = xcollImageTypeEnum;
    }

    public String toString() {
        return new ToStringBuilder(this)
            .append("comp_id", getComp_id())
            .toString();
    }

    public boolean equals(Object other) {
        if ( (this == other ) ) return true;
        if ( !(other instanceof CollectionImage) ) return false;
        CollectionImage castOther = (CollectionImage) other;
        return new EqualsBuilder()
            .append(this.getComp_id(), castOther.getComp_id())
            .isEquals();
    }

    public int hashCode() {
        return new HashCodeBuilder()
            .append(getComp_id())
            .toHashCode();
    }

}
