/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package net.metadiversity.diversity.navigator.hibernate.ubt.collection;

import java.io.Serializable;
import java.util.Date;
import org.apache.commons.lang.builder.EqualsBuilder;
import org.apache.commons.lang.builder.HashCodeBuilder;
import org.apache.commons.lang.builder.ToStringBuilder;


/** @author Hibernate CodeGenerator */
public class IdentificationPK implements Serializable {

    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3256440300560921909L;

    /** identifier field */
    private Integer identificationUnitId;

    /** identifier field */
    private Integer collectionSpecimenId;

    /** identifier field */
    private Date identificationSequence;

    /** full constructor */
    public IdentificationPK(Integer identificationUnitId, Integer collectionSpecimenId, Date identificationSequence) {
        this.identificationUnitId = identificationUnitId;
        this.collectionSpecimenId = collectionSpecimenId;
        this.identificationSequence = identificationSequence;
    }

    /** default constructor */
    public IdentificationPK() {
    }

    public Integer getIdentificationUnitId() {
        return this.identificationUnitId;
    }

    public void setIdentificationUnitId(Integer identificationUnitId) {
        this.identificationUnitId = identificationUnitId;
    }

    public Integer getCollectionSpecimenId() {
        return this.collectionSpecimenId;
    }

    public void setCollectionSpecimenId(Integer collectionSpecimenId) {
        this.collectionSpecimenId = collectionSpecimenId;
    }

    public Date getIdentificationSequence() {
        return this.identificationSequence;
    }

    public void setIdentificationSequence(Date identificationSequence) {
        this.identificationSequence = identificationSequence;
    }

    public String toString() {
        return new ToStringBuilder(this)
            .append("identificationUnitId", getIdentificationUnitId())
            .append("collectionSpecimenId", getCollectionSpecimenId())
            .append("identificationSequence", getIdentificationSequence())
            .toString();
    }

    public boolean equals(Object other) {
        if ( (this == other ) ) return true;
        if ( !(other instanceof IdentificationPK) ) return false;
        IdentificationPK castOther = (IdentificationPK) other;
        return new EqualsBuilder()
            .append(this.getIdentificationUnitId(), castOther.getIdentificationUnitId())
            .append(this.getCollectionSpecimenId(), castOther.getCollectionSpecimenId())
            .append(this.getIdentificationSequence(), castOther.getIdentificationSequence())
            .isEquals();
    }

    public int hashCode() {
        return new HashCodeBuilder()
            .append(getIdentificationUnitId())
            .append(getCollectionSpecimenId())
            .append(getIdentificationSequence())
            .toHashCode();
    }

}
