/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * DnDbTable.java
 *
 * Created on 28. Juli 2003, 12:03
 */

package net.metadiversity.diversity.navigator.project;

import org.apache.log4j.Logger;

/**
 *
 * @author  Dieter Neubacher
 */
public class DnDbTable
{
    static Logger logger = Logger.getLogger( DnDbTable.class.getName() );
    
    
    private java.lang.String    projectName;
    private java.lang.String    dbGroupName;
    private java.lang.String    databaseName;
    private java.lang.String    tableName;
    // ??? private java.lang.String    description; 
    
    private java.util.LinkedHashMap dnDbFields;
    /** Creates a new instance of DnDbTable */
    public DnDbTable( java.sql.DatabaseMetaData meta, java.lang.String databaseName, java.lang.String tableName ) throws java.sql.SQLException
    {
        this.projectName    = null;
        this.dbGroupName    = null;
        this.databaseName = databaseName;
        this.tableName = tableName;
        
        dnDbFields = new java.util.LinkedHashMap();
        
        // try
        {
            java.util.Vector fieldNames = new java.util.Vector();
            java.sql.ResultSet mrs = meta.getColumns( null, null, tableName,  null );
            while( mrs.next() )
            {
                java.lang.String fieldName = mrs.getString( 4 );
                logger.debug( fieldName );
                fieldNames.add( fieldName );    
            }
            for( int i = 0; i < fieldNames.size(); i++ )
            {   
                addDnDbField( (java.lang.String) fieldNames.get( i ), new DnDbField( meta, databaseName, tableName, (java.lang.String) fieldNames.get( i ) ) ); 
            }    
            
            mrs.close();
        }    
    }
    public java.lang.String getName()
    {
        return tableName;
    }
    private void addDnDbField( java.lang.String dbFieldName, DnDbField field )
    {
        dnDbFields.put( dbFieldName, field );
        return;
    }
    
    public DnDbField getDnFieldByName( java.lang.String dnDbFieldName )
    {
        return ( DnDbField ) dnDbFields.get( dnDbFieldName );
    }        
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public int getChildCount()
    {
        return dnDbFields.size();
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public java.lang.String getChild( int i )
    {
        java.util.Iterator iter = dnDbFields.keySet().iterator();
        int index = 0;
        Object obj = null;
        while( iter.hasNext() )
        {
            obj = iter.next();
            if( i == index )
            {
                break;
            }
            index++;
        }
        return obj.toString();
    }
}
