/*
 * Copyright (C) 2001-2006 University Bayreuth, BayCEER, Dept. of Mycology 
 * 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/*
 * DnBooleanRenerer.java
 *
 * Created on 10. August 2002, 14:27
 */

package net.metadiversity.diversity.navigator.types;

import java.awt.*;
import java.awt.Component;
import javax.swing.*;
import javax.swing.table.*;

import net.metadiversity.diversity.navigator.*;     // icons
import org.apache.log4j.Logger;
  
public class DnBooleanTableCellRenderer implements TableCellRenderer
{
    static Logger logger = Logger.getLogger( DnBooleanTableCellRenderer.class.getName() );
    
    private JLabel label = new JLabel();
    private int    val   = 0;
    
    static boolean debugFlag = false;
       
    public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column)
    {  
        if( debugFlag && logger.isDebugEnabled() )
        {    
            logger.debug( "getTableCellRendererComponent( row : " + row + " col : " + column + " )" );
            logger.debug( "isSelected : " + isSelected );
            logger.debug( "hasFocus :   " + hasFocus  );
        }
        
        int val = 0;
        try
        {
            val = ((DnBoolean) value).getValue();    
        }
        catch( ClassCastException ex )
        {
            logger.error( ex.getLocalizedMessage() );
        }
        

        switch( val )
        {
           case -1 :
                    label.setText( "false" );
                    label.setIcon( DiversityNavigatorProperties.getCheckboxFalseIcon() );
                    break;
           case 0  :
                    label.setText( "null" );
                    label.setIcon( DiversityNavigatorProperties.getCheckboxNullIcon() );
                    break;
           case 1  :
                    label.setText( "true" );
                    label.setIcon( DiversityNavigatorProperties.getCheckboxTrueIcon() );
                    break;
        }
        label.setMaximumSize( new Dimension( 16, 50 ) );
        
        return label;
    }
}
